MAX_MODULE_NAME32	= 255
MAX_PATH		= 260
TH32CS_SNAPHEAPLIST	= 1
TH32CS_SNAPPROCESS	= 2
TH32CS_SNAPTHREAD	= 4
TH32CS_SNAPMODULE	= 8
TH32CS_SNAPALL		= TH32CS_SNAPHEAPLIST + TH32CS_SNAPPROCESS + TH32CS_SNAPTHREAD + TH32CS_SNAPMODULE
TH32CS_INHERIT		= 80000000h
HF32_DEFAULT		= 1
HF32_SHARED		= 2
LF32_FIXED		= 1
LF32_FREE		= 2
LF32_MOVEABLE		= 4

struc HEAPLIST32 {
    .dwSize		 dd ?
    .th32ProcessID	 dd ?
    .th32HeapID 	 dd ?
    .dwFlags		 dd ?
}
struct HEAPLIST32

struc HEAPENTRY32 {
    .dwSize	     dd ?
    .hHandle	     dd ?
    .dwAddress	     dd ?
    .dwBlockSize     dd ?
    .dwFlags	     dd ?
    .dwLockCount     dd ?
    .dwResvd	     dd ?
    .th32ProcessID   dd ?
    .th32HeapID      dd ?
}
struct HEAPENTRY32

struc PROCESSENTRY32 {
    .dwSize		 dd ?
    .cntUsage		 dd ?
    .th32ProcessID	 dd ?
    .th32DefaultHeapID	 dd ?
    .th32ModuleID	 dd ?
    .cntThreads 	 dd ?
    .th32ParentProcessID dd ?
    .pcPriClassBase	 dd ?
    .dwFlags		 dd ?
    .szExeFile		 rb MAX_PATH
}
struct PROCESSENTRY32

struc THREADENTRY32 {
    .dwSize		 dd ?
    .cntUsage		 dd ?
    .th32ThreadID	 dd ?
    .th32OwnerProcessID  dd ?
    .tpBasePri		 dd ?
    .tpDeltaPri 	 dd ?
    .dwFlags		 dd ?
}
struct THREADENTRY32

struc MODULEENTRY32 {
    .dwSize	     dd ?
    .th32ModuleID    dd ?
    .th32ProcessID   dd ?
    .GlblcntUsage    dd ?
    .ProccntUsage    dd ?
    .modBaseAddr     dd ?
    .modBaseSize     dd ?
    .hModule	     dd ?
    .szModule	     rb MAX_MODULE_NAME32+1
    .szExePath	     rb MAX_PATH
}
struct MODULEENTRY32